#!/usr/bin/php
<?php
require_once "/var/www/x-caracal/app/db/Database.php";
require_once "/var/www/init.php";

use Logger\Log;
use Wildix\DependencyInjection\Container;

$diContainer = new Container();
$logger      = $diContainer->get(Log::class);

$monthCount = 12;

$cdrConfigPath = '/etc/callweaver/cdr.conf';
if (file_exists($cdrConfigPath) && ($cdrConfig = parse_ini_file($cdrConfigPath, true)) && ($deleteAfter = (int)$cdrConfig['general']['deleteAfter'])){
    $monthCount = $deleteAfter;
}

$result = Database::clearOldData($monthCount);

$logger->info(__LINE__, sprintf('[x-caracal] Clearing old data for %d months %s', $monthCount, $result ? 'successful' : 'failed'));
