#!/usr/bin/php
<?php


require_once('/var/www/x-caracal/helpers/helpers.php');
require_once('/var/www/x-caracal/config.php');
require_once('/var/www/x-caracal/xCaracalDb.php');
require_once "/var/www/init.php";
require_once "/var/www/x-caracal/firstin.php";

use Logger\Log;
use Wildix\DependencyInjection\Container;

ini_set('display_errors', true);

$diContainer = new Container();
$logger      = $diContainer->get(Log::class);

// max seconds for reparsing (7 day)
$maxDiff = 7 * 24 * 3600;

$startReprocess = isset($argv[1]) ? strtotime($argv[1]) : time() - 8 * 3600;
$endReprocess = isset($argv[2]) ? strtotime($argv[2]) : time();

if (($endReprocess - $startReprocess) > $maxDiff) {
    $endReprocess = $startReprocess + $maxDiff;
}

$startReprocess = date('Y-m-d H:i:s', $startReprocess);
$endReprocess = date('Y-m-d H:i:s', $endReprocess);

$info = sprintf('[x-caracal] Start reparsing agent activity from %s to %s', $startReprocess, $endReprocess);
$logger->info(__LINE__, $info);

get_agent_activity_full_exec($startReprocess, $endReprocess);

echo $info . PHP_EOL;