#!/bin/bash
DEF_CONF=/etc/default/wildixlog
ENF_FILE=/var/www/x-caracal/.env

## Get db information configured in /var/www/x-caracal/.evn
ENV_DBHOST=`crudini --get ${ENF_FILE} '' DB_HOST`
ENV_DBUSER=`crudini --get ${ENF_FILE} '' DB_USER`
eval ENV_DBPASS=`crudini --get ${ENF_FILE} '' DB_PASS`
ENV_DBNAME=`crudini --get ${ENF_FILE} '' DB_NAME`

## Get db information from /etc/default/wildixlog, assuming it's single point for configuration
DEF_DBHOST=$(awk -F"-h " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')
DEF_DBUSER=$(awk -F"-u " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')
DEF_DBPASS=$(awk -F"-p " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')
DEF_DBNAME=$(awk -F"-d " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')

## Initialize proper database values from /var/www/x-caracal/.evn configration
if [ $ENV_DBHOST ] && [[ $ENV_DBHOST != $DEF_DBHOST ]]; then
            sed -i "s/${DEF_DBHOST}/${ENV_DBHOST}/" $DEF_CONF
fi
if [ $ENV_DBUSER ] && [[ $ENV_DBUSER != $DEF_DBUSER ]]; then
        sed -i "s/${DEF_DBUSER}/${ENV_DBUSER}/" $DEF_CONF
fi
if [ $ENV_DBPASS ] && [[ $ENV_DBPASS != $DEF_DBPASS ]]; then
        sed -i "s/${DEF_DBPASS}/${ENV_DBPASS}/" $DEF_CONF
fi
if [ $ENV_DBNAME ] && [[ $ENV_DBNAME != $DEF_DBNAME ]]; then
        sed -i "s/${DEF_DBNAME}/${ENV_DBNAME}/" $DEF_CONF
fi

## Enable queue_log in callweaver during service start sequence
CW_QUEUE_STATUS=`crudini --get /etc/callweaver/logger.conf general queue_log`
[ $CW_QUEUE_STATUS != "on" ] && crudini --set /etc/callweaver/logger.conf general queue_log on && callweaver -rx 'logger reload'

exit 0
