--
-- Create isolated DB for asternic
--

-- manage DB creation outside wms-interface or manually; whatever
-- CREATE DATABASE IF NOT EXISTS qstats CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
-- USE qstats;

--
-- Table structure for table `acl`
--

DROP TABLE IF EXISTS `acl`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `acl` (
  `id` int(11) NOT NULL auto_increment,
  `resource` varchar(50) default NULL,
  `level` varchar(20) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `byresource` (`resource`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `acl`
--

LOCK TABLES `acl` WRITE;
/*!40000 ALTER TABLE `acl` DISABLE KEYS */;
INSERT INTO `acl` VALUES (1,'admin-acl.php','2'),(2,'distribution_summary.php','7'),(3,'distribution_by_queue.php','7'),(4,'distribution_by_month.php','7'),(5,'distribution_by_week.php','7'),(6,'distribution_by_day.php','7'),(7,'distribution_by_hour.php','7'),(8,'distribution_by_day_of_week.php','7'),(9,'distribution_by_url.php','7'),(10,'distribution_detail.php','7'),(11,'answered_calls_summary.php','7'),(12,'answered_calls_by_holdtime.php','7'),(13,'answered_calls_by_queue.php','7'),(14,'answered_calls_by_agent.php','7'),(15,'answered_calls_by_event.php','7'),(16,'answered_calls_by_url.php','7'),(17,'answered_calls_by_duration.php','7'),(18,'answered_calls_transferred.php','7'),(19,'answered_calls_detail.php','7'),(20,'unanswered_calls_summary.php','7'),(21,'unanswered_calls_by_holdtime.php','7'),(22,'unanswered_calls_by_event.php','7'),(23,'unanswered_calls_by_queue.php','7'),(24,'unanswered_calls_by_url.php','7'),(25,'unanswered_calls_detail.php','7'),(26,'agent_summary.php','7'),(27,'agent_availability.php','7'),(29,'agent_pauses.php','7'),(30,'agent_dispositions.php','7'),(31,'agent_detail.php','7'),(32,'admin-setup.php','2'),(33,'admin-designer.php','2'),(34,'admin-users.php','2'),(35,'admin-language.php','10'),(36,'admin-schedule.php','10'),(37,'recordings','7'),(38,'search.php','7'),(39,'realtime.php','7'),(40,'call details drill down','7'),(41,'agent_dispositions','7'),(42,'realtime_queue_summary.php','7'),(43,'realtime_waiting_calls.php','7'),(44,'realtime_agent_status.php','7'),(45,'admin-sched.php','7'),(46,'realtime-agents-status','7'),(47,'realtime-waiting-calls','7'),(48,'index.php','7'),(49,'answered.php','7'),(50,'unanswered.php','7'),(51,'agent.php','7'),(52,'distribution_calls_det','7'),(53,'distribution.php','7'),(54,'add_config','7'),(55,'delete_marked_keyword','7'),(56,'answered_calls_by_queue','7'),(57,'answered_calls_by_agent','7'),(58,'answered_calls_by_url','7'),(59,'call_response','7'),(60,'disconnect_cause','7'),(61,'answered_calls_det','7'),(62,'transfers','7');
/*!40000 ALTER TABLE `acl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `designer`
--

DROP TABLE IF EXISTS `designer`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `designer` (
  `id` int(11) NOT NULL auto_increment,
  `keyword` varchar(50) default NULL,
  `parameter` varchar(250) default NULL,
  `value` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `keypar` (`keyword`,`parameter`),
  KEY `keyindex` (`keyword`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `designer`
--

LOCK TABLES `designer` WRITE;
/*!40000 ALTER TABLE `designer` DISABLE KEYS */;
INSERT INTO `designer` VALUES (1,'agent_reports','','agent_summary.php,agent_availability.php,agent_pauses.php,agent_dispositions.php,agent_detail.php'),(2,'ANSWERED_DISPLAY_GRID','event','6,6'),(3,'ANSWERED_DISPLAY_GRID','holdtime','7,5'),(4,'ANSWERED_DISPLAY_GRID','queue','6,6'),(5,'ANSWERED_DISPLAY_ROWS','agent','Received,Completed,Transferred,%% Calls,Talk Time,%% Talk Time,Avg Talk Time,Ring Time,Wait Time,Avg Wait Time,Max Wait Time'),(6,'ANSWERED_DISPLAY_ROWS','duration','Received,Completed,Transferred,%% Calls,Talk Time,%% Talk Time,Avg Talk Time,Wait Time,Avg Wait Time,Max Wait Time'),(7,'ANSWERED_DISPLAY_ROWS','event','Received,%% Calls'),(8,'ANSWERED_DISPLAY_ROWS','holdtime','Count,Delta,%%'),(9,'ANSWERED_DISPLAY_ROWS','queue','Received,%% Calls'),(10,'answered_reports','','answered_calls_summary.php,answered_calls_by_holdtime.php,answered_calls_by_queue.php,answered_calls_by_agent.php,answered_calls_by_event.php,answered_calls_by_duration.php,answered_calls_transferred.php,answered_calls_detail.php'),(11,'CHART_ANSWERED','01,agent,Number of Calls per Agent','Completed'),(12,'CHART_ANSWERED','01,event','Received'),(13,'CHART_ANSWERED','01,holdtime','Delta'),(14,'CHART_ANSWERED','01,queue','Received'),(15,'CHART_ANSWERED','02,agent,Total Time per Agent (seconds)','Talk Time'),(16,'CHART_DISTRIBUTION','01,day','Answered,Transferred,Abandoned,Unanswered'),(17,'CHART_DISTRIBUTION','01,day_of_week,Answered by Day','Answered'),(18,'CHART_DISTRIBUTION','01,hour,Answered/Abandoned per Hour','Answered,Abandoned'),(19,'CHART_DISTRIBUTION','01,queue','Answered,Abandoned'),(20,'CHART_DISTRIBUTION','02,day_of_week,Unanswered by Day','Abandoned'),(21,'CHART_DISTRIBUTION','02,hour','Avg Wait,Avg Talk'),(22,'CHART_DISTRIBUTION','02,queue','Avg Wait,Avg Talk'),(23,'CHART_DISTRIBUTION','03,day_of_week,Average Wait Time by Day','Avg Wait'),(24,'CHART_DISTRIBUTION','04,day_of_week,Average Duration by Day','Avg Talk'),(25,'CHART_UNANSWERED','01,event','Total'),(26,'CHART_UNANSWERED','01,holdtime','Delta'),(27,'CHART_UNANSWERED','01,queue,Answered/Abandoned','Abandoned,Unanswered'),(28,'COLUMN_ANSWERED','%%','(SUM_RECEIVED*100)/TOTAL_RECEIVED'),(29,'COLUMN_ANSWERED','%% Calls','RECEIVED*100/TOTAL_RECEIVED'),(30,'COLUMN_ANSWERED','%% Talk Time','((ANSWERED_TALK_TIME+TRANSFERRED_TALK_TIME)*100)/(TOTAL_ANSWERED_TALK_TIME+TOTAL_TRANSFERRED_TALK_TIME)'),(31,'COLUMN_ANSWERED','Avg Talk Time','(ANSWERED_TALK_TIME+TRANSFERRED_TALK_TIME)/RECEIVED'),(32,'COLUMN_ANSWERED','Avg Wait Time','(ANSWERED_WAIT_TIME + TRANSFERRED_WAIT_TIME) / RECEIVED'),(33,'COLUMN_ANSWERED','Completed','ANSWERED'),(34,'COLUMN_ANSWERED','Count','SUM_RECEIVED'),(35,'COLUMN_ANSWERED','Delta','RECEIVED'),(36,'COLUMN_ANSWERED','Max Wait Time','MAX_ANSWERED_WAIT_TIME'),(37,'COLUMN_ANSWERED','Received','RECEIVED'),(38,'COLUMN_ANSWERED','Talk Time','ANSWERED_TALK_TIME+TRANSFERRED_TALK_TIME'),(39,'COLUMN_ANSWERED','Transferred','TRANSFERRED'),(40,'COLUMN_ANSWERED','Wait Time','ANSWERED_WAIT_TIME+TRANSFERRED_WAIT_TIME'),(41,'COLUMN_ANSWERED_FORMAT','%%','%.2f %%'),(42,'COLUMN_ANSWERED_FORMAT','%% Calls','%.2f %%'),(43,'COLUMN_ANSWERED_FORMAT','%% Talk Time','%.2f %%'),(44,'COLUMN_ANSWERED_FORMAT','Avg Talk Time','{HH}:{MM}:{SS}'),(45,'COLUMN_ANSWERED_FORMAT','Avg Wait Time','{HH}:{MM}:{SS}'),(46,'COLUMN_ANSWERED_FORMAT','Count','%d'),(47,'COLUMN_ANSWERED_FORMAT','Delta','+%d'),(48,'COLUMN_ANSWERED_FORMAT','Max Wait Time','{HH}:{MM}:{SS}'),(49,'COLUMN_ANSWERED_FORMAT','Talk Time','{HH}:{MM}:{SS}'),(50,'COLUMN_ANSWERED_FORMAT','Wait Time','{HH}:{MM}:{SS}'),(51,'COLUMN_DISTRIBUTION','%% Answ','round((ANSWERED*100)/RECEIVED,2)'),(52,'COLUMN_DISTRIBUTION','%% Unansw','round(((UNANSWERED+ABANDONED)*100)/RECEIVED,2)'),(53,'COLUMN_DISTRIBUTION','Abandoned','ABANDONED'),(54,'COLUMN_DISTRIBUTION','Answered','ANSWERED'),(55,'COLUMN_DISTRIBUTION','Avg Talk','intval((ANSWERED_TALK_TIME +  TRANSFERRED_TALK_TIME) / (ANSWERED + TRANSFERRED))'),(56,'COLUMN_DISTRIBUTION','Avg Wait','intval((ANSWERED_WAIT_TIME + TRANSFERRED_WAIT_TIME + UNANSWERED_WAIT_TIME + ABANDONED_WAIT_TIME) / RECEIVED)'),(57,'COLUMN_DISTRIBUTION','Logins','LOGIN'),(58,'COLUMN_DISTRIBUTION','Logoff','LOGOUT'),(59,'COLUMN_DISTRIBUTION','Max Callers','MAX_CALLERS_WAITING'),(60,'COLUMN_DISTRIBUTION','Received','RECEIVED'),(61,'COLUMN_DISTRIBUTION','SLA','round((ANSWERED_SLA / RECEIVED)*100,2)'),(62,'COLUMN_DISTRIBUTION','Transferred','TRANSFERRED'),(63,'COLUMN_DISTRIBUTION','Unanswered','UNANSWERED'),(64,'COLUMN_DISTRIBUTION_FORMAT','%% Answ','%s %%'),(65,'COLUMN_DISTRIBUTION_FORMAT','%% Unansw','%s %%'),(66,'COLUMN_DISTRIBUTION_FORMAT','Avg Talk','{HH}:{MM}:{SS}'),(67,'COLUMN_DISTRIBUTION_FORMAT','Avg Wait','{HH}:{MM}:{SS}'),(68,'COLUMN_DISTRIBUTION_FORMAT','SLA','%s %%'),(69,'COLUMN_RECEIVED','','COMPLETECALLER,COMPLETEAGENT,ABANDON,EXITEMPTY,EXITWITHKEY,EXITWITHTIMEOUT,TRANSFER'),(70,'COLUMN_TRANSFERRED','','TRANSFER'),(71,'COLUMN_UNANSWERED','%%','((SUM_ABANDONED+SUM_UNANSWERED)*100)/(TOTAL_ABANDONED+TOTAL_UNANSWERED)'),(72,'COLUMN_UNANSWERED','%% Calls','((ABANDONED+UNANSWERED)*100)/(TOTAL_UNANSWERED+TOTAL_ABANDONED)'),(73,'COLUMN_UNANSWERED','Abandoned','ABANDONED'),(74,'COLUMN_UNANSWERED','Count','SUM_ABANDONED+SUM_UNANSWERED'),(75,'COLUMN_UNANSWERED','Delta','ABANDONED+UNANSWERED'),(76,'COLUMN_UNANSWERED','Total','UNANSWERED+ABANDONED'),(77,'COLUMN_UNANSWERED','Unanswered','UNANSWERED'),(78,'COLUMN_UNANSWERED_FORMAT','%%','%.2f %%'),(79,'COLUMN_UNANSWERED_FORMAT','%% Calls','%.2f %%'),(80,'COLUMN_UNANSWERED_FORMAT','Delta','+%d'),(81,'DISTRIBUTION_DISPLAY_ROWS','day','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(82,'DISTRIBUTION_DISPLAY_ROWS','day_of_week','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(83,'DISTRIBUTION_DISPLAY_ROWS','hour','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(84,'DISTRIBUTION_DISPLAY_ROWS','month','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(85,'DISTRIBUTION_DISPLAY_ROWS','queue','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(86,'DISTRIBUTION_DISPLAY_ROWS','url','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(87,'DISTRIBUTION_DISPLAY_ROWS','week','Received,Answered,Unanswered,Abandoned,Transferred,Logins,Logoff,Avg Wait,Avg Talk,Max Callers,%% Answ,%% Unansw,SLA'),(88,'distribution_reports','','distribution_summary.php,distribution_by_queue.php,distribution_by_month.php,distribution_by_week.php,distribution_by_day.php,distribution_by_hour.php,distribution_by_day_of_week.php,distribution_by_agent.php,distribution_detail.php'),(89,'EVENT_ABANDONED','','ABANDON'),(90,'EVENT_ANSWERED','','COMPLETECALLER,COMPLETEAGENT'),(91,'EVENT_LOGIN','','AGENTLOGIN,ADDMEMBER'),(92,'EVENT_LOGOUT','','AGENTLOGOFF,REMOVEMEMBER'),(93,'EVENT_RECEIVED','','COMPLETECALLER,COMPLETEAGENT,ABANDON,EXITEMPTY,EXITWITHKEY,EXITWITHTIMEOUT,TRANSFER'),(94,'EVENT_TRANSFERRED','','TRANSFER'),(95,'EVENT_UNANSWERED','','EXITWITHKEY,EXITEMPTY,EXITWITHTIMEOUT'),(96,'setup_reports','','admin-setup.php,admin-license.php,admin-designer.php,admin-users.php,admin-acl.php,admin-plugins.php,admin-language.php,admin-schedule.php'),(97,'TOTAL_COLUMN_ANSWERED','%% Calls','SUM_COL'),(98,'TOTAL_COLUMN_ANSWERED','%% Talk Time','SUM_COL'),(99,'TOTAL_COLUMN_ANSWERED','Avg Talk Time','(TOTAL_ANSWERED_TALK_TIME+TOTAL_TRANSFERRED_TALK_TIME)/TOTAL_RECEIVED'),(100,'TOTAL_COLUMN_ANSWERED','Avg Wait Time','(TOTAL_ANSWERED_WAIT_TIME+TOTAL_TRANSFERRED_WAIT_TIME)/TOTAL_RECEIVED'),(101,'TOTAL_COLUMN_ANSWERED','Completed','SUM_COL'),(102,'TOTAL_COLUMN_ANSWERED','Count','TOTAL_RECEIVED'),(103,'TOTAL_COLUMN_ANSWERED','Max Wait Time','MAX_COL'),(104,'TOTAL_COLUMN_ANSWERED','Received','SUM_COL'),(105,'TOTAL_COLUMN_ANSWERED','Talk Time','SUM_COL'),(106,'TOTAL_COLUMN_ANSWERED','Transferred','SUM_COL'),(107,'TOTAL_COLUMN_ANSWERED','Wait Time','SUM_COL'),(108,'TOTAL_COLUMN_DISTRIBUTION','%% Answ','round((SUM_ANSWERED*100)/SUM_RECEIVED,2)'),(109,'TOTAL_COLUMN_DISTRIBUTION','%% Unansw','round(((SUM_UNANSWERED+SUM_ABANDONED)*100)/SUM_RECEIVED,2)'),(110,'TOTAL_COLUMN_DISTRIBUTION','Abandoned','SUM_COL'),(111,'TOTAL_COLUMN_DISTRIBUTION','Answered','SUM_COL'),(112,'TOTAL_COLUMN_DISTRIBUTION','Avg Talk','intval((SUM_ANSWERED_TALK_TIME +  SUM_TRANSFERRED_TALK_TIME) / (SUM_ANSWERED + SUM_TRANSFERRED))'),(113,'TOTAL_COLUMN_DISTRIBUTION','Avg Wait','intval((SUM_ANSWERED_WAIT_TIME + SUM_TRANSFERRED_WAIT_TIME + SUM_UNANSWERED_WAIT_TIME + SUM_ABANDONED_WAIT_TIME) / SUM_RECEIVED)'),(114,'TOTAL_COLUMN_DISTRIBUTION','Logins','SUM_COL'),(115,'TOTAL_COLUMN_DISTRIBUTION','Logoff','SUM_COL'),(116,'TOTAL_COLUMN_DISTRIBUTION','Max Callers','MAX_COL'),(117,'TOTAL_COLUMN_DISTRIBUTION','Received','SUM_COL'),(118,'TOTAL_COLUMN_DISTRIBUTION','SLA','round((SUM_ANSWERED_SLA / SUM_RECEIVED)*100,2)'),(119,'TOTAL_COLUMN_DISTRIBUTION','Transferred','SUM_COL'),(120,'TOTAL_COLUMN_DISTRIBUTION','Unanswered','SUM_COL'),(121,'TOTAL_COLUMN_UNANSWERED','%% Calls','SUM_COL'),(122,'TOTAL_COLUMN_UNANSWERED','Abandoned','SUM_COL'),(123,'TOTAL_COLUMN_UNANSWERED','Count','TOTAL_UNANSWERED+TOTAL_ABANDONED'),(124,'TOTAL_COLUMN_UNANSWERED','Total','SUM_COL'),(125,'TOTAL_COLUMN_UNANSWERED','Unanswered','SUM_COL'),(126,'UNANSWERED_DISPLAY_GRID','event','7,5'),(127,'UNANSWERED_DISPLAY_GRID','holdtime','7,5'),(128,'UNANSWERED_DISPLAY_ROWS','event','Total,%% Calls'),(129,'UNANSWERED_DISPLAY_ROWS','holdtime','Count,Delta,%%'),(130,'UNANSWERED_DISPLAY_ROWS','queue','Total,Abandoned,Unanswered,%% Calls'),(131,'UNANSWERED_DISPLAY_ROWS','url','Total,Abandoned,Unanswered,%% Calls'),(132,'unanswered_reports','','unanswered_calls_summary.php,unanswered_calls_by_holdtime.php,unanswered_calls_by_event.php,unanswered_calls_by_queue.php,unanswered_calls_detail.php'),(135,'COLUMN_REALTIME','Received','RECEIVED'),(136,'COLUMN_REALTIME','Answered','ANSWERED'),(137,'COLUMN_REALTIME','Abandoned','ABANDONED'),(138,'COLUMN_REALTIME','Unanswered','UNANSWERED'),(139,'COLUMN_REALTIME','Transferred','TRANSFERRED'),(140,'COLUMN_REALTIME','Agents','AGENTS_STAFFED'),(141,'COLUMN_REALTIME','Busy','AGENTS_TALKING'),(142,'COLUMN_REALTIME','Paused','AGENTS_PAUSED'),(143,'REALTIME_DISPLAY_ROWS','queue_summary','Waiting,Agents,Logged Off,Busy,Paused,Answered,Unanswered,Abandoned,Abandon Rate,Avg Wait,Avg Duration,Max. wait time'),(144,'COLUMN_REALTIME','Waiting','CALLS_WAITING'),(145,'COLUMN_REALTIME','Available','AGENTS_STAFFED-AGENTS_TALKING'),(151,'COLUMN_REALTIME_FORMAT','Abandon Rate','%.2f %%'),(147,'COLUMN_REALTIME','Abandon Rate','round(((UNANSWERED+ABANDONED)*100)/RECEIVED,2)'),(148,'COLUMN_REALTIME','Max. wait time','MAX_WAIT_TIME'),(149,'COLUMN_REALTIME','Avg Wait','intval((ANSWERED_WAIT_TIME + TRANSFERRED_WAIT_TIME + UNANSWERED_WAIT_TIME + ABANDONED_WAIT_TIME) / RECEIVED)'),(150,'COLUMN_REALTIME','Avg Duration','intval((ANSWERED_TALK_TIME +  TRANSFERRED_TALK_TIME) / (ANSWERED + TRANSFERRED))'),(152,'COLUMN_REALTIME_FORMAT','Max. wait time','{HH}:{MM}:{SS}'),(153,'COLUMN_REALTIME_FORMAT','Avg Wait','{HH}:{MM}:{SS}'),(154,'COLUMN_REALTIME_STYLE','Max. wait time','class=\\\'timer\\\''),(155,'COLUMN_REALTIME_STYLE','Waiting','style=\\\'font-size: 20px; font-weight: bold;\\\''),(156,'COLUMN_REALTIME_FORMAT','Avg Duration','{HH}:{MM}:{SS}'),(157,'COLUMN_REALTIME','Logged Off','AGENTS_LOGGED_OFF'),(158,'realtime_reports','','realtime_waiting_calls.php,realtime_queue_summary.php,realtime_agent_status.php'),(159,'TOTAL_COLUMN_REALTIME','Received','SUM_COL'),(160,'TOTAL_COLUMN_REALTIME','Answered','SUM_COL'),(161,'TOTAL_COLUMN_REALTIME','Waiting','SUM_COL'),(163,'TOTAL_COLUMN_REALTIME','Unanswered','SUM_COL'),(162,'TOTAL_COLUMN_REALTIME','Avg Wait','intval((TOTAL_ANSWERED_WAIT_TIME + TOTAL_TRANSFERRED_WAIT_TIME + TOTAL_UNANSWERED_WAIT_TIME + TOTAL_ABANDONED_WAIT_TIME) / TOTAL_RECEIVED)'),(164,'TOTAL_COLUMN_REALTIME','Abandoned','SUM_COL'),(165,'TOTAL_COLUMN_REALTIME','Abandon Rate','round(((TOTAL_UNANSWERED+TOTAL_ABANDONED)*100)/TOTAL_RECEIVED,2)'),(166,'TOTAL_COLUMN_REALTIME','Avg Duration','intval((TOTAL_ANSWERED_TALK_TIME +  TOTAL_TRANSFERRED_TALK_TIME) / (TOTAL_ANSWERED + TOTAL_TRANSFERRED))'),(167,'TOTAL_COLUMN_REALTIME','Max. wait time','MAX_COL');
INSERT INTO `designer` VALUES (NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','agent','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','day','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','day_of_week','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','hour','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','month','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','queue','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','url','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw'),(NULL,'DISTRIBUTION_DISPLAY_OUTBOUND_ROWS','week','Total,Answered,Not Answered,Logins,Logoff,Avg Wait,Avg Talk,%% Answ,%% Unansw');
INSERT INTO `designer` VALUES (NULL,'COLUMN_DISTRIBUTION','Total','RECEIVED'),(NULL,'COLUMN_DISTRIBUTION','Not Answered','ABANDONED'),(NULL,'TOTAL_COLUMN_DISTRIBUTION','Total','SUM_COL'),(NULL,'TOTAL_COLUMN_DISTRIBUTION','Not Answered','SUM_COL');
INSERT INTO `designer` VALUES (NULL,'COLUMN_ANSWERED','Ring Time','ANSWERED_RING_TIME+TRANSFERRED_RING_TIME'),(NULL,'COLUMN_ANSWERED_FORMAT','Ring Time','{HH}:{MM}:{SS}'),(NULL,'TOTAL_COLUMN_ANSWERED','Ring Time','SUM_COL');
/*!40000 ALTER TABLE `designer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `language`
--

DROP TABLE IF EXISTS `language`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `language` (
  `id` int(6) NOT NULL auto_increment,
  `iso_code` varchar(5) collate utf8_bin NOT NULL default 'en',
  `string` text collate utf8_bin,
  `translation` text collate utf8_bin,
  `pending` tinyint(1) default '1',
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `idx` (`iso_code`,`string`(64)),
  KEY `stindex` (`string`(200))
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `language`
--

LOCK TABLES `language` WRITE;
/*!40000 ALTER TABLE `language` DISABLE KEYS */;
/*!40000 ALTER TABLE `language` ENABLE KEYS */;

INSERT INTO `language` VALUES (NULL,'en','%','%',0,'2012-10-01 23:34:18'),(NULL,'en','%%','%%',0,'2012-09-22 02:07:06'),(NULL,'en','%% Answ','%% Answ',0,'2012-10-02 06:34:01'),(NULL,'en','%% Calls','%% Calls',0,'2012-10-02 22:21:01'),(NULL,'en','%% Paused','%% Paused',0,'2012-09-07 23:59:17'),(NULL,'en','%% Talk Time','%% Talk Time',0,'2012-09-13 04:00:55'),(NULL,'en','%% Unansw','%% Unansw',0,'2012-10-02 06:34:01'),(NULL,'en','%s','%s',0,'2012-09-07 23:59:17'),(NULL,'en','%s %%','%s %%',0,'0000-00-00 00:00:00'),(NULL,'en','%s days','%s days',0,'2012-10-01 23:34:18'),(NULL,'en','%s min. ago','%s min. ago',0,'2012-09-18 10:51:34'),(NULL,'en','%s minutes','%s minutes',0,'0000-00-00 00:00:00'),(NULL,'en','%s records deleted','%s records deleted',0,'2012-10-02 07:40:16'),(NULL,'en','%s secs','%s secs',0,'0000-00-00 00:00:00'),(NULL,'en','ABANDON','Abandoned',0,'2012-10-01 23:34:19'),(NULL,'en','ALL','ALL',0,'2012-10-02 04:08:44'),(NULL,'en','Abandon Avg Queue Position at Disconnection','Abandon Avg Queue Position at Disconnection',0,'2012-09-22 02:07:06'),(NULL,'en','Abandon Avg Queue Start Position','Abandon Avg Queue Start Position',0,'2012-09-22 02:07:06'),(NULL,'en','Abandon Avg Wait Before Disconnection','Abandon Avg Wait Before Disconnection',0,'2012-09-22 02:07:06'),(NULL,'en','Abandon Rate','Abandon Rate',0,'2012-10-01 23:34:18'),(NULL,'en','Abandoned','Abandoned',0,'2012-10-02 22:21:01'),(NULL,'en','Abandoned Calls','Abandoned Calls',0,'2012-09-22 02:07:06'),(NULL,'en','Actions','Actions',0,'2012-10-01 23:34:19'),(NULL,'en','Active','Active',0,'2012-10-02 10:43:07'),(NULL,'en','Add','Add',0,'2012-10-02 10:42:51'),(NULL,'en','Add Record','Add Record',0,'2012-10-02 04:10:14'),(NULL,'en','Agent','Agent',0,'2012-10-02 10:43:07'),(NULL,'en','Agent Status','Agent Status',0,'2012-09-18 10:51:34'),(NULL,'en','Agent Totals','Agent Totals',0,'2012-09-07 23:59:17'),(NULL,'en','Agents','Agents',0,'2012-10-02 04:08:44'),(NULL,'en','Alert','Alert',0,'2012-10-02 10:43:07'),(NULL,'en','Alerts','Alerts',0,'2012-10-02 10:43:07'),(NULL,'en','All %s records are selected.','All %s records are selected.',0,'2012-10-02 07:40:13'),(NULL,'en','All %s records on this page are selected.','All %s records on this page are selected.',0,'2012-10-02 07:40:12'),(NULL,'en','An error has occurred','An error has occurred',0,'2012-10-02 07:42:53'),(NULL,'en','Answer','Answer',0,'2012-09-13 04:00:55'),(NULL,'en','Answered','Answered',0,'2012-10-02 10:43:07'),(NULL,'en','Answered Calls','Answered Calls',0,'2012-09-13 04:00:55'),(NULL,'en','Answered by Day','Answered by Day',0,'2012-10-02 06:34:01'),(NULL,'en','Answered/Abandoned','Answered/Abandoned',0,'2012-10-02 22:21:01'),(NULL,'en','Answered/Abandoned per Hour','Answered/Abandoned per Hour',0,'2012-10-02 06:34:01'),(NULL,'en','April','April',0,'2012-10-02 22:21:37'),(NULL,'en','Are you sure?','Are you sure?',0,'2012-10-02 22:21:37'),(NULL,'en','August','August',0,'2012-10-02 22:21:37'),(NULL,'en','Available','Available',0,'2012-10-02 22:21:11'),(NULL,'en','Available Keywords','Available Keywords',0,'2012-10-02 10:42:51'),(NULL,'en','Available Variables','Available Variables',0,'2012-10-02 10:42:51'),(NULL,'en','Average Duration by Day','Average Duration by Day',0,'2012-10-02 06:34:01'),(NULL,'en','Average Session Time','Average Session Time',0,'2012-09-07 23:59:17'),(NULL,'en','Average Wait Time by Day','Average Wait Time by Day',0,'2012-10-02 06:34:01'),(NULL,'en','Avg Duration','Avg Duration',0,'2012-09-18 10:51:34'),(NULL,'en','Avg Talk','Avg Talk',0,'2012-10-02 06:34:01'),(NULL,'en','Avg Talk Time','Avg Talk Time',0,'2012-09-13 04:00:55'),(NULL,'en','Avg Wait','Avg Wait',0,'2012-10-02 06:34:01'),(NULL,'en','Avg Wait Time','Avg Wait Time',0,'2012-09-13 04:00:55'),(NULL,'en','Avg. Paused','Avg. Paused',0,'2012-09-07 23:59:17'),(NULL,'en','Avg. Session','Avg. Session',0,'2012-09-07 23:59:17'),(NULL,'en','Avg. Session Time','Avg. Session Time',0,'2012-09-07 23:59:17'),(NULL,'en','Back','Back',0,'2012-10-02 10:39:48'),(NULL,'en','Bad username or password','Bad username or password',0,'2012-09-07 00:22:06'),(NULL,'en','Busy','Busy',0,'2012-09-18 10:51:34'),(NULL,'en','COMPLETEAGENT','Complete by Agent',0,'2012-09-07 23:59:17'),(NULL,'en','COMPLETECALLER','Complete by Caller',0,'2012-10-01 23:34:19'),(NULL,'en','Caller ID','Caller ID',0,'2012-09-18 10:51:34'),(NULL,'en','Calls','Calls',0,'2012-09-18 10:51:34'),(NULL,'en','Calls Waiting Detail','Calls Waiting Detail',0,'2012-09-08 01:04:39'),(NULL,'en','Campaigns','Campaigns',1,'2015-01-07 22:12:49'),(NULL,'en','Cancel','Cancel',0,'2012-10-02 22:21:27'),(NULL,'en','Cannot steal call. realtime_spy_extension for user <b>%s</b> is not defined in Setup/Preferences.','Cannot steal call. realtime_spy_extension for user <b>%s</b> is not defined in Setup/Preferences.',0,'0000-00-00 00:00:00'),(NULL,'en','Clear Selection','Clear Selection',0,'2012-10-02 07:40:13'),(NULL,'en','Click to add text','Click to add text',0,'2012-10-02 22:21:37'),(NULL,'en','Click to edit...','Click to edit...',0,'0000-00-00 00:00:00'),(NULL,'en','Click to view calls in detail','Click to view calls in detail',0,'2012-10-01 23:34:19'),(NULL,'en','Coach','Coach',0,'2012-09-18 10:51:34'),(NULL,'en','Completed','Completed',0,'2012-10-02 22:21:37'),(NULL,'en','Confirm','Confirm',0,'2012-10-02 04:08:21'),(NULL,'en','Could not connect to the Asterisk Manager Interface to retrieve status information. Please check your manager credentials in config.php and verify they match your settings in /etc/asterisk/manager.conf','Could not connect to the Asterisk Manager Interface to retrieve status information. Please check your manager credentials in config.php and verify they match your settings in /etc/asterisk/manager.conf',0,'0000-00-00 00:00:00'),(NULL,'en','Could not copy uploaded file','Could not copy uploaded file',0,'2012-10-02 04:37:27'),(NULL,'en','Count','Count',0,'2012-09-22 02:07:06'),(NULL,'en','Cron Configuration','Cron Configuration',0,'2012-10-02 10:43:07'),(NULL,'en','Dashboard','Dashboard',1,'2015-01-07 22:12:49'),(NULL,'en','Date','Date',0,'2012-10-01 23:34:19'),(NULL,'en','Day','Day',0,'2012-10-01 23:34:19'),(NULL,'en','December','December',0,'2012-10-02 22:21:37'),(NULL,'en','Delete','Delete',0,'2012-10-02 22:21:37'),(NULL,'en','Delete Marked','Delete Marked',0,'2012-10-02 22:21:37'),(NULL,'en','Delta','Delta',0,'2012-09-22 02:07:06'),(NULL,'en','Deselects all','Deselects all',0,'2012-10-02 22:21:11'),(NULL,'en','Deselects marked','Deselects marked',0,'2012-10-02 22:21:11'),(NULL,'en','Dialer','Dialer',1,'2015-01-07 22:12:49'),(NULL,'en','Display Report','Display Report',0,'2012-10-02 22:21:11'),(NULL,'en','Distribution','Distribution',0,'2012-10-02 10:43:07'),(NULL,'en','Download','Download',0,'2012-10-01 23:34:19'),(NULL,'en','Duration','Duration',0,'2012-09-18 10:51:34'),(NULL,'en','EXITWITHKEY','Exit with Key',0,'0000-00-00 00:00:00'),(NULL,'en','EXITWITHTIMEOUT','Timed Out',0,'2012-10-01 23:34:19'),(NULL,'en','Edit Email Alert','Edit Email Alert',0,'2012-10-02 10:43:07'),(NULL,'en','Edit Record','Edit Record',0,'2012-10-02 22:21:37'),(NULL,'en','Edit Scheduled Report','Edit Scheduled Report',0,'2012-10-02 10:43:07'),(NULL,'en','Email','Email',0,'2012-10-02 10:43:07'),(NULL,'en','Empty file?','Empty file?',0,'2012-10-02 04:37:27'),(NULL,'en','End Date','End Date',0,'2012-10-02 22:21:11'),(NULL,'en','End Position','End Position',0,'2012-09-22 02:07:06'),(NULL,'en','Error inserting record:<br/>','Error inserting record:<br/>',0,'2012-09-08 03:54:46'),(NULL,'en','Error updating record','Error updating record',0,'0000-00-00 00:00:00'),(NULL,'en','Event','Event',0,'2012-10-02 06:34:01'),(NULL,'en','Example','Example',0,'2012-10-02 10:43:07'),(NULL,'en','Export','Export',0,'2012-10-02 22:21:37'),(NULL,'en','Exports the data to a .pdf file','Exports the data to a .pdf file',0,'2012-10-01 23:34:19'),(NULL,'en','Exports the data to a comma separated file, to be read by your spreadsheet software','Exports the data to a comma separated file, to be read by your spreadsheet software',0,'2012-10-01 23:34:19'),(NULL,'en','Fails','Fails',1,'2013-07-03 05:55:27'),(NULL,'en','February','February',0,'2012-10-02 22:21:37'),(NULL,'en','Filter','Filter',0,'2012-10-02 22:21:37'),(NULL,'en','Filter report by Caller Id','Filter report by Caller Id',0,'2012-10-01 23:34:19'),(NULL,'en','First','First',0,'2012-10-02 22:21:37'),(NULL,'en','Friday','Friday',0,'2012-10-02 22:21:37'),(NULL,'en','From','From',0,'2012-10-02 22:21:11'),(NULL,'en','From the last (X) days','From the last (X) days',0,'2012-10-02 10:43:07'),(NULL,'en','Generate','Generate',0,'2012-10-02 10:39:48'),(NULL,'en','Generate Offline License Request','Generate Offline License Request',0,'2012-10-02 10:39:48'),(NULL,'en','Goes to the top of the page','Goes to the top of the page',0,'2012-10-01 23:34:19'),(NULL,'en','Group by Queue','Group by Queue',0,'2012-09-18 10:51:34'),(NULL,'en','Help','Help',0,'2012-10-02 09:55:45'),(NULL,'en','Hide Logged off','Hide Logged off',0,'2012-09-18 10:51:34'),(NULL,'en','Higher ...','Higher ...',0,'2012-10-02 22:21:11'),(NULL,'en','Home','Home',0,'2012-10-02 22:21:37'),(NULL,'en','Hour','Hour',0,'2012-10-01 23:34:18'),(NULL,'en','Hour Range','Hour Range',0,'2012-10-01 23:34:18'),(NULL,'en','Hours','Hours',0,'2012-10-02 10:43:07'),(NULL,'en','ISO Code','ISO Code',0,'2012-10-02 22:21:37'),(NULL,'en','If the field value is higher than this number you will receive an alerting email','If the field value is higher than this number you will receive an alerting email',0,'2012-10-02 10:43:07'),(NULL,'en','Ignoring field ','Ignoring field ',0,'2012-10-02 07:42:52'),(NULL,'en','Import','Import',0,'2012-10-02 22:21:37'),(NULL,'en','In order to receive scheduled reports or alerts via email, you must setup a cron job in the server. You can use the following command in your server command line:<br/><br/>crontab -e<br/><br/>and add the following line (replacing the user and password with a valid user/password):<br/><br/>','In order to receive scheduled reports or alerts via email, you must setup a cron job in the server. You can use the following command in your server command line:<br/><br/>crontab -e<br/><br/>and add the following line (replacing the user and password with a valid user/password):<br/><br/>',0,'2012-10-02 10:43:07'),(NULL,'en','Incompleted Calls','Incompleted Calls',0,'2012-09-22 02:07:06'),(NULL,'en','Invalid Date','Invalid Date',0,'0000-00-00 00:00:00'),(NULL,'en','Invalid Hour','Invalid Hour',0,'0000-00-00 00:00:00'),(NULL,'en','January','January',0,'2012-10-02 22:21:37'),(NULL,'en','July','July',0,'2012-10-02 22:21:37'),(NULL,'en','June','June',0,'2012-10-02 22:21:37'),(NULL,'en','Last','Last',0,'2012-10-02 22:21:37'),(NULL,'en','Last in Call','Last in Call',0,'2012-09-18 10:51:34'),(NULL,'en','Last three months','Last three months',0,'2012-10-02 22:21:11'),(NULL,'en','Level','Level',0,'2012-10-02 04:08:44'),(NULL,'en','License Handling','License Handling',0,'2012-10-02 10:39:48'),(NULL,'en','License validation problem','License validation problem',0,'2012-09-08 03:26:28'),(NULL,'en','Licensed to','Licensed to',0,'2012-10-02 22:21:37'),(NULL,'en','Listen','Listen',0,'2012-09-18 10:51:34'),(NULL,'en','Lists','Lists',1,'2015-01-07 22:12:49'),(NULL,'en','Loading','Loading',0,'2012-10-02 22:21:37'),(NULL,'en','Logged Off','Logged Off',0,'2012-09-18 10:51:34'),(NULL,'en','Login','Login',0,'2012-10-02 22:21:11'),(NULL,'en','Login Form','Login Form',0,'2012-10-02 22:21:11'),(NULL,'en','Logins','Logins',0,'2012-10-02 06:34:01'),(NULL,'en','Logoff','Logoff',0,'2012-10-02 06:34:01'),(NULL,'en','Logout','Logout',0,'2012-10-02 22:21:37'),(NULL,'en','Longest Session','Longest Session',0,'2012-09-07 23:59:17'),(NULL,'en','Lower ...','Lower ...',0,'2012-10-02 22:21:11'),(NULL,'en','March','March',0,'2012-10-02 22:21:37'),(NULL,'en','Max Callers','Max Callers',0,'2012-10-02 06:34:01'),(NULL,'en','Max Wait Time','Max Wait Time',0,'2012-09-13 04:00:55'),(NULL,'en','Max. wait time','Max. wait time',0,'2012-09-18 10:51:34'),(NULL,'en','May','May',0,'2012-10-02 22:21:37'),(NULL,'en','Minutes','Minutes',0,'2012-10-02 10:43:07'),(NULL,'en','Monday','Monday',0,'2012-10-02 22:21:37'),(NULL,'en','Month','Month',0,'2012-10-02 06:34:01'),(NULL,'en','Month days','Month days',0,'2012-10-02 10:43:07'),(NULL,'en','Name','Name',0,'2012-10-02 04:08:44'),(NULL,'en','New Email Alert','New Email Alert',0,'2012-10-02 10:43:07'),(NULL,'en','New Scheduled Report','New Scheduled Report',0,'2012-10-02 10:43:07'),(NULL,'en','Next','Next',0,'2012-10-02 22:21:37'),(NULL,'en','No','No',0,'2012-10-02 22:21:37'),(NULL,'en','No active channel','No active channel',0,'0000-00-00 00:00:00'),(NULL,'en','No info','No info',0,'2012-09-05 04:05:40'),(NULL,'en','No records found','No records found',0,'2012-10-02 22:21:14'),(NULL,'en','No results','No results',0,'2012-09-07 00:23:21'),(NULL,'en','No valid fields to import!','No valid fields to import!',0,'2012-10-02 07:05:22'),(NULL,'en','None','None',0,'2012-10-01 23:34:19'),(NULL,'en','Notice','Notice',0,'2012-10-02 10:39:48'),(NULL,'en','November','November',0,'2012-10-02 22:21:37'),(NULL,'en','Number','Number',0,'2012-10-01 23:34:19'),(NULL,'en','Number of Abandoned Calls','Number of Abandoned Calls',0,'2012-10-01 23:34:18'),(NULL,'en','Number of Agent Logins','Number of Agent Logins',0,'2012-10-01 23:34:18'),(NULL,'en','Number of Agent Logoffs','Number of Agent Logoffs',0,'2012-10-01 23:34:18'),(NULL,'en','Number of Agents','Number of Agents',0,'2012-09-07 23:59:17'),(NULL,'en','Number of Answered Calls','Number of Answered Calls',0,'2012-10-01 23:34:18'),(NULL,'en','Number of Calls per Agent','Number of Calls per Agent',0,'2012-10-02 06:34:01'),(NULL,'en','Number of Outbound Calls','Number of Outbound Calls',0,'2015-01-07 22:12:24'),(NULL,'en','Number of Received Calls','Number of Received Calls',0,'2012-10-01 23:34:18'),(NULL,'en','Number of Transferred Calls','Number of Transferred Calls',0,'2012-10-01 23:34:18'),(NULL,'en','Number of Unanswered Calls','Number of Unanswered Calls',0,'2012-10-01 23:34:18'),(NULL,'en','Numbers','Numbers',1,'2015-01-07 22:12:49'),(NULL,'en','OK','OK',0,'0000-00-00 00:00:00'),(NULL,'en','October','October',0,'2012-10-02 22:21:37'),(NULL,'en','Outbound Calls','Outbound Calls',0,'2015-01-07 22:12:24'),(NULL,'en','Overflow','Overflow',0,'2012-09-09 01:59:58'),(NULL,'en','Page','Page',0,'2012-10-02 22:21:37'),(NULL,'en','Page parsed in %s seconds','Page parsed in %s seconds',0,'2012-10-02 22:21:37'),(NULL,'en','Password','Password',0,'2012-10-02 22:21:11'),(NULL,'en','Passwords do not match','Passwords do not match',0,'2012-10-02 22:21:27'),(NULL,'en','Pause Time','Pause Time',0,'2012-09-07 23:59:17'),(NULL,'en','Paused','Paused',0,'2012-09-18 10:51:34'),(NULL,'en','Pauses','Pauses',0,'2012-09-07 23:59:17'),(NULL,'en','Pauses per Session','Pauses per Session',0,'2012-09-07 23:59:17'),(NULL,'en','Pending','Pending',0,'2012-10-02 22:21:37'),(NULL,'en','Period','Period',0,'2012-10-01 23:34:18'),(NULL,'en','Play','Play',0,'2012-10-01 23:34:19'),(NULL,'en','Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use','Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use',0,'0000-00-00 00:00:00'),(NULL,'en','Please select the reports to send','Please select the reports to send',0,'2012-10-02 10:43:07'),(NULL,'en','Please write down destination emails','Please write down destination emails',0,'2012-10-02 10:43:07'),(NULL,'en','Position','Position',0,'2012-09-08 01:04:39'),(NULL,'en','Previous','Previous',0,'2012-10-02 22:21:37'),(NULL,'en','Proceed','Proceed',0,'2012-09-07 05:56:50'),(NULL,'en','Querying data...','Querying data...',0,'2012-10-02 10:43:07'),(NULL,'en','Queue','Queue',0,'2012-10-02 22:21:01'),(NULL,'en','Queues','Queues',0,'2012-10-02 04:08:44'),(NULL,'en','RINGNOANSWER','Failed to Answer Call',0,'2012-09-07 23:59:17'),(NULL,'en','Reactivate','Reactivate',0,'2012-09-07 05:56:46'),(NULL,'en','Realtime','Realtime',0,'2012-10-02 05:53:49'),(NULL,'en','Received','Received',0,'2012-10-02 06:34:01'),(NULL,'en','Record deleted','Record deleted',0,'2012-09-08 04:18:02'),(NULL,'en','Record inserted','Record inserted',0,'2012-10-02 04:10:23'),(NULL,'en','Record updated','Record updated',0,'2012-10-02 22:21:37'),(NULL,'en','Records imported','Records imported',0,'2012-10-02 07:42:53'),(NULL,'en','Report','Report',0,'2012-10-02 10:43:07'),(NULL,'en','Reports','Reports',0,'2012-10-02 10:43:07'),(NULL,'en','Required field','Required field',0,'2012-10-02 22:21:27'),(NULL,'en','Revoke','Revoke',0,'0000-00-00 00:00:00'),(NULL,'en','Revoke Current License','Revoke Current License',0,'0000-00-00 00:00:00'),(NULL,'en','SLA','SLA',0,'2012-10-02 06:34:01'),(NULL,'en','Saturday','Saturday',0,'2012-10-02 22:21:37'),(NULL,'en','Save','Save',0,'2012-10-02 22:21:27'),(NULL,'en','Scheduled Reports and Alerts','Scheduled Reports and Alerts',0,'2012-10-02 10:43:07'),(NULL,'en','Search','Search',0,'2012-10-02 22:21:37'),(NULL,'en','Seconds','Seconds',0,'2012-09-07 04:00:52'),(NULL,'en','Select Agents','Select Agents',0,'2012-10-02 22:21:11'),(NULL,'en','Select Date Range','Select Date Range',0,'2012-10-02 22:21:11'),(NULL,'en','Select Queues','Select Queues',0,'2012-10-02 22:21:11'),(NULL,'en','Select Time Frame','Select Time Frame',0,'2012-10-02 22:21:11'),(NULL,'en','Select all %s records.','Select all %s records.',0,'2012-10-02 07:40:12'),(NULL,'en','Select an option','Select an option',0,'2012-10-02 22:21:27'),(NULL,'en','Select language','Select language',0,'2012-10-02 22:21:37'),(NULL,'en','Select option','Select option',0,'2012-10-02 22:21:37'),(NULL,'en','Select some options','Select option',0,'2012-10-02 04:08:21'),(NULL,'en','Select the field to compare','Select the field to compare',0,'2012-10-02 10:43:07'),(NULL,'en','Select the report to check','Select the report to check',0,'2012-10-02 10:43:07'),(NULL,'en','Selected','Selected',0,'2012-10-02 22:21:11'),(NULL,'en','Selects all','Selects all',0,'2012-10-02 22:21:11'),(NULL,'en','Selects marked','Selects marked',0,'2012-10-02 22:21:11'),(NULL,'en','Separate with comma ( , )<br>* means all','Separate with comma ( , )<br>* means all',0,'2012-10-02 10:43:07'),(NULL,'en','September','September',0,'2012-10-02 22:21:37'),(NULL,'en','Server Time','Server Time',0,'2012-09-18 10:51:34'),(NULL,'en','Session Time','Session Time',0,'2012-09-07 23:59:17'),(NULL,'en','Sessions','Sessions',0,'2012-09-07 23:59:17'),(NULL,'en','Setup','Setup',0,'2012-10-02 22:21:37'),(NULL,'en','Shortcuts','Shortcuts',0,'2012-10-02 22:21:11'),(NULL,'en','Shortest Session Time','Shortest Session Time',0,'2012-09-07 23:59:17'),(NULL,'en','Spy','Spy',0,'0000-00-00 00:00:00'),(NULL,'en','Start Date','Start Date',0,'2012-10-02 22:21:11'),(NULL,'en','Start Position','Start Position',0,'2012-09-22 02:07:06'),(NULL,'en','State','State',0,'2012-09-18 10:51:34'),(NULL,'en','Steal','Steal',0,'2012-09-18 10:51:34'),(NULL,'en','String','String',0,'2012-10-02 22:21:37'),(NULL,'en','Success!','Success!',0,'2012-10-02 22:21:37'),(NULL,'en','Sunday','Sunday',0,'2012-10-02 22:21:37'),(NULL,'en','TRANSFER','Transfer',0,'2012-09-07 23:59:17'),(NULL,'en','Talk Time','Talk Time',0,'2012-10-01 23:34:19'),(NULL,'en','There is no valid license file on this installation yet.','There is no valid license file on this installation yet.',0,'2012-10-02 10:39:48'),(NULL,'en','This month','This month',0,'2012-10-02 22:21:11'),(NULL,'en','This week','This week',0,'2012-10-02 22:21:11'),(NULL,'en','Thursday','Thursday',0,'2012-10-02 22:21:37'),(NULL,'en','Time','Time',0,'2012-09-07 23:59:17'),(NULL,'en','To','To',0,'2012-10-02 22:21:11'),(NULL,'en','Today','Today',0,'2012-10-02 22:21:11'),(NULL,'en','Toggle Search Form','Toggle Search Form',0,'2012-09-09 01:59:58'),(NULL,'en','Total','Total',0,'2012-10-02 22:21:01'),(NULL,'en','Total Answered Calls','Total Answered Calls',0,'2012-09-13 04:00:55'),(NULL,'en','Total Calls','Total Calls',0,'2012-10-01 23:34:18'),(NULL,'en','Total Duration','Total Duration',0,'2012-09-13 04:00:55'),(NULL,'en','Total Session Time','Total Session Time',0,'2012-09-07 23:59:17'),(NULL,'en','Total Time per Agent (seconds)','Total Time per Agent (seconds)',0,'2012-10-02 06:34:01'),(NULL,'en','Total Unanswered Calls','Total Unanswered Calls',0,'2012-09-22 02:07:06'),(NULL,'en','Total records found','Total records found',0,'2012-10-02 22:21:37'),(NULL,'en','Transferred','Transferred',0,'2012-10-02 06:34:01'),(NULL,'en','Transferred Calls','Transferred Calls',0,'2012-09-13 04:00:55'),(NULL,'en','Translation','Translation',0,'2012-10-02 22:21:37'),(NULL,'en','Tuesday','Tuesday',0,'2012-10-02 22:21:37'),(NULL,'en','Type','Type',0,'2012-10-02 10:43:07'),(NULL,'en','URL','URL',0,'2012-10-01 23:34:19'),(NULL,'en','Unanswered','Unanswered',0,'2012-10-02 22:21:01'),(NULL,'en','Unanswered Calls','Unanswered Calls',0,'2012-09-22 02:07:06'),(NULL,'en','Unanswered Rate','Unanswered Rate',0,'2012-10-01 23:34:18'),(NULL,'en','Unanswered by Day','Unanswered by Day',0,'2012-10-02 06:34:01'),(NULL,'en','Use comma to separate emails','Use comma to separate emails',0,'2012-10-02 10:43:07'),(NULL,'en','User','User',0,'2012-10-02 22:21:11'),(NULL,'en','View Record','View Record',0,'2012-10-02 22:21:37'),(NULL,'en','Wait Time','Wait Time',0,'2012-10-01 23:34:19'),(NULL,'en','Waiting','Waiting',0,'2012-09-18 10:51:34'),(NULL,'en','Wednesday','Wednesday',0,'2012-10-02 22:21:37'),(NULL,'en','Week','Week',0,'2012-10-01 23:34:18'),(NULL,'en','Week days','Week days',0,'2012-10-02 10:43:07'),(NULL,'en','Write down the value to compare','Write down the value to compare',0,'2012-10-02 10:43:07'),(NULL,'en','Yes','Yes',0,'2012-10-02 22:21:37'),(NULL,'en','You do not have enough privileges to access this resource','You do not have enough privileges to access this resource',0,'2012-10-02 10:41:59'),(NULL,'en','You must select at least one agent','You must select at least one agent',0,'0000-00-00 00:00:00'),(NULL,'en','You must select at least one queue','You must select at least one queue',0,'0000-00-00 00:00:00'),(NULL,'en','admin-acl','Access Control',0,'2012-10-02 22:21:37'),(NULL,'en','admin-designer','Report Designer',0,'2012-10-02 22:21:37'),(NULL,'en','admin-language','Translations',0,'2012-10-02 22:21:37'),(NULL,'en','admin-schedule','Schedules/Alerts',0,'2012-10-02 22:21:37'),(NULL,'en','admin-setup','Preferences',0,'2012-10-02 22:21:37'),(NULL,'en','admin-users','Users',0,'2012-10-02 22:21:37'),(NULL,'en','agent_availability','Agent Availability',0,'2012-10-02 10:43:08'),(NULL,'en','agent_detail','Full Agent Report',0,'2012-10-02 05:53:49'),(NULL,'en','agent_dispositions','Call Disposition by Agent',0,'2012-10-02 10:43:08'),(NULL,'en','agent_durations','Agent Session and Pause Durations',0,'2012-10-02 10:43:08'),(NULL,'en','agent_pauses','Pause Detail',0,'2012-10-02 05:53:49'),(NULL,'en','agent_summary','Agent Summary',0,'2012-10-02 05:53:49'),(NULL,'en','all month','all month',0,'2012-10-02 10:43:07'),(NULL,'en','answered_calls_by_agent','Answered by Agent',0,'2012-10-02 10:43:08'),(NULL,'en','answered_calls_by_duration','Answered by Call Length',0,'2012-10-02 05:53:49'),(NULL,'en','answered_calls_by_event','Disconnection Cause',0,'2012-10-02 10:43:08'),(NULL,'en','answered_calls_by_holdtime','Service Level',0,'2012-10-02 10:43:08'),(NULL,'en','answered_calls_by_queue','Answered by Queue',0,'2012-10-02 10:43:08'),(NULL,'en','answered_calls_by_url','Answered by URL',0,'2012-10-02 10:43:08'),(NULL,'en','answered_calls_detail','Answered Calls Detail',0,'2012-10-02 05:53:49'),(NULL,'en','answered_calls_summary','Answered Calls Summary',0,'2012-10-02 05:53:49'),(NULL,'en','answered_calls_transferred','Transfers',0,'2012-10-02 10:43:08'),(NULL,'en','at hour','at hour',0,'2012-10-02 10:43:07'),(NULL,'en','at minute','at minute',0,'2012-10-02 10:43:07'),(NULL,'en','calls','calls',0,'2012-10-01 23:34:18'),(NULL,'en','day','day',0,'2012-10-02 10:43:07'),(NULL,'en','disposition_help_ABANDON','The caller abandoned their position in the queue. The position is the\r\ncaller&rsquo;s position in the queue when they hungup, the origposition is\r\nthe original position the caller was when they first entered the\r\nqueue, and the waittime is how long the call had been waiting in the\r\nqueue at the time of disconnect.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_COMPLETEAGENT','The caller was connected to an agent, and the call was terminated normally\r\nby the *agent*. The caller&lsquo;s hold time and the length of the call are both\r\nrecorded. The caller&lsquo;s original position in the queue is recorded in\r\norigposition.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_COMPLETECALLER','The caller was connected to an agent, and the call was terminated normally\r\nby the *caller*. The callers hold time and the length of the call are both\r\nrecorded. The caller&rsquo;s original position in the queue is recorded in\r\norigposition.\r\n',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_CONNECT','The caller was connected to an agent.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_ENTERQUEUE','A caller entered the queue. Three parameters are also written: the URL (if specified) in the Info 1 field and the caller ID of the caller on the Info 2 field, and the original position where the call has landed in the Info 3 field.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_EXITWITEMPTY','The caller was exited from the queue forcefully because the queue had no\r\nreachable members and it&lsquo;s configured to do that to callers when there\r\nare no reachable members. The position is the caller&lsquo;s position in the\r\nqueue when they hungup, the origposition is the original position the\r\ncaller was when they first entered the queue, and the waittime is how\r\nlong the call had been waiting in the queue at the time of disconnect.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_EXITWITHKEY','The caller elected to use a menu key to exit the queue. The key and\r\nthe caller&lsquo;s position in the queue are recorded.\r\n',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_EXITWITHTIMEOUT','The caller was on hold too long and the timeout expired.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_RINGNOANSWER','The timeout value for ringing the queue member was exceeded. A single parameter will also be written indicating the amount of time the member’s extension rang in the Info 1 field.',0,'2012-10-01 23:34:19'),(NULL,'en','disposition_help_TRANSFER','Caller was transferred to a different extension. Context and extension\r\nare recorded. The caller&lsquo;s hold time and the length of the call are both\r\nrecorded. PLEASE remember that transfers performed by SIP UA&lsquo;s by way\r\nof a reinvite may not always be caught by x-caracal and trigger off this\r\nevent. The only way to be 100% sure that you will get this event when\r\na transfer is performed by a queue member is to use the built-in transfer\r\nfunctionality of x-caracal.',0,'2012-10-01 23:34:19'),(NULL,'en','distribution_by_agent','Distribution by Agent',0,'2013-05-18 06:15:17'),(NULL,'en','distribution_by_agent (outbound)','Distribution by Agent (outbound)',0,'2013-05-18 06:15:17'),(NULL,'en','distribution_by_day','Distribution per Day',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_day (outbound)','Distribution per Day (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_by_day_of_week','Distribution per Day of Week',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_day_of_week (outbound)','Distribution per Day of Week (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_by_hour','Distribution per Hour',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_hour (outbound)','Distribution per Hour (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_by_month','Distribution per Month',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_month (outbound)','Distribution per Month (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_by_queue','Distribution by Queue',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_queue (outbound)','Distribution by Queue (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_by_url','Distribution by URL',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_url (outbound)','Distribution by URL (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_by_week','Distribution per Week',0,'2012-10-02 10:43:08'),(NULL,'en','distribution_by_week (outbound)','Distribution per Week (outbound)',0,'2013-05-17 20:53:36'),(NULL,'en','distribution_detail','Detailed Distribution Report',0,'2012-10-02 10:43:07'),(NULL,'en','distribution_summary','Distribution Summary',0,'2012-10-02 05:53:49'),(NULL,'en','event_help_abandon_info1','The position is the caller&#39;s position in the queue when they hungup.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_abandon_info2','The original position the caller was positioned when they first entered the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_abandon_info3','The waittime is how long the call had been waiting in the queue at the time of disconnect.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentcallbacklogin_info1','The callback agent logged in. The login extension and context is recorded.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentcallbacklogoff_info1','The callback agent logged off.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentcallbacklogoff_info2','The last login extension and context is recorded, along with the total time the agent was logged in.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentcallbacklogoff_info3','The reason for the logoff if it was not a normal logoff (e.g., Autologoff, Chanunavail)',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentlogin_info1','The agent logged in. The channel is recorded.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentlogoff_info1','The agent logged off.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_agentlogoff_info2','The total time the agent was logged in.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_completeagent_info1','The caller&#39;s hold time.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_completeagent_info2','The length of the call.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_completeagent_info3','The caller&#39;s original position in the queue is recorded in origposition.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_completecaller_info1','The caller&#39;s hold time',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_completecaller_info2','The length of the call.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_completecaller_info3','The caller&#39;s original position in the queue is recorded in origposition.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_connect_info1','Hold time represents the amount of time the caller was on hold.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_connect_info2','The bridged channel unique ID contains the unique ID of the queue member channel that is taking the call.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_connect_info3','Ringtime represents the time the queue members phone was ringing prior to being answered.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_enterqueue_info1','URL parameter',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_enterqueue_info2','Caller ID',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_enterqueue_info3','The original position the caller was positioned when they first entered the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitempty_info1','The position is the caller&#39;s position in the queue when they hungup.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitempty_info2','The origposition is the original position the caller was when they first entered the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitempty_info3','The waittime is how long the call had been waiting in the queue at the time of disconnect.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitwithkey_info1','The caller elected to use a menu key to exit the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitwithkey_info2','The caller&#39;s position.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitwithtimeout_info1','The position the caller was when exiting the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitwithtimeout_info2','Original position at which the called entered the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_exitwithtimeout_info3','Amount of time the caller waited in the queue.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_pause_info1','Pause reason if any',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_ringnoanswer_info1','Time in milliseconds the agent phone rang until the timeout was reached. The attempt ended without the member picking up the call. Bad queue member!',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_transfer_info1','The extension',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_transfer_info2','The context',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_transfer_info3','The caller&#39;s hold time',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_transfer_info4','The length of the call.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_transfer_info5','The caller&#39;s entry position at the time of the transfer.',0,'2012-09-07 04:00:52'),(NULL,'en','event_help_unpause_info1','Unpause reason if any',0,'2012-09-07 04:00:52'),(NULL,'en','every day','every day',0,'0000-00-00 00:00:00'),(NULL,'en','every hour','every hour',0,'2012-10-02 10:43:07'),(NULL,'en','every minute','every minute',0,'2012-10-02 10:43:07'),(NULL,'en','help_text_ACTION','Define a custom action handler, so you can call your own functions/program to handle special cases. You must create the javascript function in the js/custom.js file. It will receive the uniqueid of the call when the action icon is clicked.<br/>\r\n<br/>\r\nparameter: position,icon image,Tooltip<br/>\r\nvalue: javascript_function',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_ANSWERED_DISPLAY_GRID','If a chart is defined in the answered reports tab, parameter field, then use the grid layout width as setup in the value field. The grid system has 12 columns in total:<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: width1,width2',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_ANSWERED_DISPLAY_ROWS','Comma separated list of fields to show on a specific Answered reports. The fields are the one defined as COLUMN_ANSWERED.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields ',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_CHART_ANSWERED','Shows a chart into the Answered reports page.<br/><br/>\n\nparameter: position,group field,title<br/>\nvalue: field,field',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_CHART_DISTRIBUTION','Shows a chart into the Distribution reports page.<br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_CHART_SERIES_COLOR','Colors to use for charts. Parameter is the index position, and value the hex html color.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_CHART_UNANSWERED','Shows a chart into the Unanswered reports page.<br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_ANSWERED','Column to show in Answered reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in ANSWERED_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n\r\n\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_ANSWERED_FORMAT','Format to use for displaying a cell value in the answered reports. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_ANSWERED entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_DISTRIBUTION','Column to show in Distribution reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in DISTRIBUTION_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_DISTRIBUTION_FORMAT','Format to use for displaying a cell value in the distribution reports. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_DISTRIBUTION entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_REALTIME','Column to show in the Realtime summary. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in REALTIME_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_REALTIME_FORMAT','Format to use for displaying a cell value in the realtime queue summary report. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_REALTIME entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_REALTIME_STYLE','Extra html property to add to cell values in the realtime queue summary table. You can use class or style to modify display on those cells. Example:<br/>\r\n<br/>\r\nclass=&quot;bigblue&quot;\r\n<br/>\r\nstyle=&quot;border:1px solid red;&quot;\r\n\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_UNANSWERED','Column to show in Unanswered reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in UNANSWERED_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_COLUMN_UNANSWERED_FORMAT','Format to use for displaying a cell value in the unanswered reports. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_UNANSWERED entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_DISTRIBUTION_DISPLAY_ROWS','Comma separated list of fields to show on a specific Distribution reports. The fields are the one defined as COLUMN_DISTRIBUTION.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_ABANDONED','Define the queue_log events that will count towards the ABANDONED counters/variables in reports, using a comma separated list. In a standard Asterisk setup, this must be set to \\\"ABANDON\\\" and nothing else.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_ANSWERED','Define the queue_log events that will count towards the ANSWERED counters/variables in reports, using a comma separated list. Normal answered dispositions in the queue_log are COMPLETECALLER, COMPLETEAGENT, you could also want to count the TRANSFER disposition towards the ANSWERED column, but as transfers have their own variable, you can also leave them separated.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_LOGIN','Define the queue_log events that will count towards the LOGIN counters/variables in reports, using a comma separated list. Usually you have AGENTLOGIN and ADDMEMBER as events for login events in the queue_log file. Old asterisk versions could also use AGENTCALLBACKLOGIN.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_LOGOUT','Define the queue_log events that will count towards the LOGOUT counters/variables in reports, using a comma separated list. Usually you have AGENTLOGOFF and REMOVEMEMBER as events for login events in the queue_log file.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_RECEIVED','Define the queue_log events that will count towards the RECEIVED counters/variables in reports, using a comma separated list. All dispositions on the queue_log file that should add to a received call should be listed here, for example:<br/><br/>\r\nCOMPLETECALLER,COMPLETEAGENT,ABANDON,EXITEMPTY,EXITWITHKEY,EXITWITHTIMEOUT,TRANSFER',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_TRANSFERRED','Define the queue_log events that will count towards the TRANSFERRED counters/variables in reports, using a comma separated list. In a regular Asterisk setup, the only event associated with transfers is TRANSFER.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_EVENT_UNANSWERED','Define the queue_log events that will count towards the UNANSWERED counters/variables in reports, using a comma separated list. As an abandon call has its own variable, you should list here the rest of the unanswered dispositions, for example:<br/><br/>\r\nEXITWITHKEY,EXITEMPTY,EXITWITHTIMEOUT',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_REALTIME_COLUMN_WIDTHS','Comma separated list of column widths for realtime reports, where parameter is the report to modify, for example &#39;agent&#39;',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_REALTIME_DISPLAY_ROWS','Comma separated list of fields to show on the Realtime Queue Summary table. The fields are the one defined as COLUMN_REALTIME.<br/>\r\n<br/>\r\nparameter: group field (queue_summary)<br/>\r\nvalue: comma separated list of fields',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_TOTAL_COLUMN_ANSWERED','Formula to use for the Total row on Answered reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_TOTAL_COLUMN_DISTRIBUTION','Formula to use for the Total row on Distribution reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_TOTAL_COLUMN_REALTIME','Formula to use for the Total row on Realtime reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_TOTAL_COLUMN_UNANSWERED','Formula to use for the Total row on Unanswered reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_UNANSWERED_DISPLAY_GRID','If a chart is defined in the unanswered reports, parameter field, then use the grid layout width as setup in the value field. The grid system has 12 columns in total:<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: width1,width2',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_UNANSWERED_DISPLAY_ROWS','Comma separated list of fields to show on a specific Unanswered reports. The fields are the one defined as COLUMN_UNANSWERED.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_agent_filter','Regular Expression to filter unwanted Agents from initial selection.<br/> Example: <strong>Agent/[0-9][0-9][0-9][0-9]$</strong>\r\n\r\n\r\n\r\n',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_agent_reports','Comma separated list of reports to show on the Agent page. You must specify the correct .php file that displays the report you want on each element.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_agent_row_color','To paint the whole cell background to the status color for an agent in the realtime view, set this to 1',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_answered_reports','Comma separated list of reports to show on the Answered page. You must specify the correct .php file that displays the report you want on each element.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_asterisk_12','Set this to 1 if you are using Asterisk 1.2 or older, otherwise you will have some issues in the realtime view.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_asterisk_16','Set this to 1 if you are using Asterisk 1.6, otherwise you will have some issues in the realtime view.\n',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_asterisk_18','Set this to 1 if you are using Asterisk 1.8, otherwise you will have some issues in the realtime view.',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_avg_time_format','Format for average duration fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in drill down and detailed reports.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_call_flow','To have separate reports for outbound queues, set call_flow for them. The parameter must be the queue name/number and the value must be set to \\\\\\\"outbound\\\\\\\".',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_call_time_format','Format for the call duration fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in drill down and detailed reports.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_csv_separator','Separator character to use in CSV export files. Default value is comma (,) for Excel and friends. If you use LibreOffice/OpenOffice you might need to change it to semicolon (;)',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_custom_reports','Comma separated list of custom reports to show on a new/custom tab on the menu. The parameter is the tab name to display, and value is a comma separated list of .php scripts to load.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_date_format','Format for the date field, using MySQL syntax. Example: %%m-%%d-%%Y %%H:%%i:%%s. This is used on drill down or detailed reports only. The report format themselves are set in the designer.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_decimal_places','Number of decimal places to show on float numbers.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_default_end_hour','Default end hour in HH:SS format for the date/time selection.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_default_start_hour','Default start hour in HH:SS format for the date/time selection.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_detailed_agent_report','Show a detailed agent report in the Agent tab. (Similar to the drill down information you can get on a regular report, but already expanded for the complete date range selection).',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_dict_agent','Dictionary entry for Agents. It will replace the agent set as the parameter to the value you specify (So you can use names instead of interfaces).',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_dict_queue','Dictionary entry for Queues. Same as the agent dictionary, but for replacing queue names.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_distribution_interval','Interval in minutes to break up the distribution by hour report. By default it breaks by hour (60 minutes), but you can use smaller or larger values.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_distribution_reports','Comma separated list of reports to show on the Distribution page. You must specify the correct .php file that displays the report you want on each element.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_drilldown_records_per_page','Number of records per page to show when expanding/drilling down on any report.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_first_page','Initial page to load (Eg: answered.php, unanswered.php, distribution.php, agent.php). Can be set per user',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_freepbx_device_user_mode','Set this to 1 if you use FreePBX in user&device mode',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_hide_parsed_time','Set this to 1 to hide the parsed time information on the footer of every report.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_honor_timeframe_in_agent','Honor time frame selection in Agent Tab Reports. It will also try to compute missing events for the period if \nthey are not in the logs.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_ignore_none_abandons','If you do not want to count for inbound abandoned calls when selecting some agents from a report, set this parameter to one. This is useful for when you are tracking outbound campaigns and want to track performance per agent on outbound as it filters out the inbound abandoned calls that are assigned to the whole queue (agent NONE) and not a particular agent. If you select all agents for a report it will include also the NONE agent, so inbound abandons will count normally event if this parameter is set to one.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_language','Language to use. You can specify a user name in the parameter field to limit the language to a particular user. If the parameter field is left empty, then the language will be set for all users (global setting).',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_alert_subject','Subect to use when emailing alerts',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_mail_from_email','Schedule and Alert reports needs a FROM field to send emails.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_from_name','Schedule and Alert reports needs a NAME field to send emails.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_header_image','Image file to use as header for emails reports/alerts',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_report_subject','Subject to use when emailing reports',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_mail_smtp_password','Schedule and Alert reports, configure an SMTP password if needed.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_smtp_server','Schedule and Alert reports, configure the SMTP server for sending emails. SSL protocol example: ssl://smtp.server.com ; for TLS protocol: tls://smtp.server.com ; without encryption: smtp.server.com',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_smtp_server_port','Schedule and Alert reports, configure the SMTP port if needed.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_mail_smtp_username','Schedule and Alert reports, configure the SMTP username if needed.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_pbxware','Set this to 1 if you use PBXWare for the realtime view to work correctly',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_realtime_agent_sort','If set to \\\"status\\\", busy agents will be shown first on the realtime page.',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_realtime_alarm_call_duration','Alarm in seconds for call duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_alarm_last_call','Alarm in seconds for the last call information in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_alarm_pause_duration','Alarm in seconds for pause/break duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_alarm_row_color','Background row color when a value is in alarm in the realtime view.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_alarm_threshold','Threshold (in percentage) from which to start coloring in alarm calls in the realtime view.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_alarm_wait_count','Alarm (in number of calls) for calls waiting in a queue in the realtime view.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_alarm_wait_duration','Alarm in seconds for call waiting duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_coach_options','Options to pass to chanspy when launching a Coach action from the realtime view. You can use any options available to the asterisk chanspy application, like &quot;w&quot; to enable whispering, or &quot;d&quot; to use dtmf to switch modes: 4 spy, 5 whisper, 6 barge., etc.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_custom_pauses','If this value is set to 1 the realtime page will check the ASTDB for the PAUSECUSTOM/Agent family and it will show the pause code stored there for a particular Agent as stored in astdb Key. Eg: PAUSECUSTOM/Agent/1000 = Break:${EPOCH} stored in ASTDB will show Agent 1000 as break when paused.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_group_queues','Start the realtime view with a grouped queue display.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_hide_loggedoff','Start the realtime view without showing logged off Agents.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_last_hour_stats','Set this option if you want the call counters in the realtime view to show only the last hour counts, and not the whole day.',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_realtime_refresh','Refresh time in seconds for the realtime view.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_refresh_sql','Refresh time in seconds for statistics values on the queue summary table in the realtime view. Retrieving the information is cpu expensive, so you might want to leave it at the default value of 60 seconds or even higher if you have many supervisors checking the realt time view at the same time.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_reports','Comma separated list of reports to show on the Realtime page. You must specify the correct .php file that displays the report you want on each element.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_realtime_spy_device','Device used by the user (set in the parameter field). Example: SIP/1234',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_spy_extension','Extension to reach the supervisor phone when launching a call steal action in the realtime view. The parameter must be set to the asternic user name, the value could be the extension number followed by the context, for example: 100@from-internal',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_spy_options','Options to pass to chanspy when launching a Listen action from the realtime view. You can use any options available to the asterisk chanspy application, like &quot;q&quot; to disable the initial beep, etc.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_strict_interface_status','This setting will make the realtime view show status as returned by the asterisk queue application by means of the STATE INTERFACE options for the AddQueueMember application. It should be set to 1 in systems with Local type queue members with STATE INTERFACE set, like FreePBX 2.8 or higher.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_realtime_tracking_mode','If set, coaching sessions in the realtime view will not end when the call ends, so the supervisor continues pinned to the agent for subsequent calls.',0,'2015-01-07 22:12:49'),(NULL,'en','help_text_recordings_path','Recordings location/directory in the hardrive to perform the direct download.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_session_time_format','Format for the session duration fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in the agent reports.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_setup_reports','Comma separated list of reports to show on the Setup page. You must specify the correct .php file that displays the report you want on each element.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_shared_lastcall','Compartir la información de último llamado entre colas. Sólo se mostrará el tiempo más corto para todas las colas. Si se utiliza rastreo de salientes y se guarda el valor astdb LASTCALL, será también tomado en cuenta.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_short_abandon_threshold','Duration  treshhold (in seconds) for a call to be considered as abandoned (if duration is less than this value, then ignore the call completely). Specifying the queue name as a parameter will apply the value to that queue only.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_short_unanswered_threshold','Duration  treshhold (in seconds) for a call to be considered as unanswered (if duration is less than this value, then ignore the call completely). Specifying the queue name as a parameter will apply the value to that queue only.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_show_agent_call','Show end call events when drilling down on agent reports',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_show_agent_field','Mostrar columna de Agente en reportes de no atendidos (útil cuando se rastrean llamados salientes)',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_show_url_field','Enable and display the URL field and reports',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_sla_abandoned','Service Level value in seconds for Abandoned calls',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_sla_answered','Service Level value in seconds for Answered calls',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_sla_interval','Time interval in seconds to split the table for SLA (Service Level Agreement) and Abandon Rate reports.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_sla_steps','Number of steps to show in SLA (Service Level Agreement) and Abandon Rate reports.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_sla_transferred','Service Level value in seconds for Transferred calls',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_sla_unanswered','Service Level value in seconds for unanswered calls (not abandoned, but unanswered due to timeouts, exit with key, etc).',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_timeframe_interval','Interval in minutes to present the time frame selection on the home tab. Defaults to 15 minutes.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_timezone','Timezone Configuration for user, in the format [ -]HH:MM\r\n\r\nIf the user name is specified as parameter, then applies only to that user. If parameter is left blank it will be applied globally.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_unanswered_reports','Comma separated list of reports to show on the Unanswered page. You must specify the correct .php file that displays the report you want on each element.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ABANDONED','Number of Abandoned calls (with EVENT_ABANDON disposition in queue_log)',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ABANDONED_SLA','Number of Abandoned calls (with EVENT_ABANDON disposition in queue_log) who&#146;s wait time was less or equal than sla_abandoned setting in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ABANDONED_WAIT_TIME','Wait time for abandoned calls for the particular grouped report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AGENTS_LOGGED_OFF','Number of Logged Off agents. Only available in COLUMN_REALTIME formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AGENTS_PAUSED','Number of Paused agents. Only available in COLUMN_REALTIME formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AGENTS_STAFFED','Number of Logged In/Available agents. Only available in COLUMN_REALTIME formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AGENTS_TALKING','Number of Agents engaged on a call. Only available in COLUMN_REALTIME formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ANSWERED','Number of Answered calls (with EVENT_ANSWERED disposition in the queue_log file) for the particular grouped report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ANSWERED_SLA','Number of Anaswered calls (with EVENT_ANSWERED disposition in queue_log) who&#146;s wait time was less or equal than sla_answered setting in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ANSWERED_TALK_TIME','Talk Time of Answered Calls for the particular grouped report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ANSWERED_WAIT_TIME','Wait Time of Answered Calls for the particular grouped report. (Wait Time is the time an user was waiting on the queue before being connected to an agent, it only counts the time since the queue was entered, it does not count potential previous times like IVRs, etc.)',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ABANDONED','Average of Abandoned Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ABANDONED_SLA','Average of Abandoned Calls that where waiting less or equal abandoned_sla time as setup in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ABANDONED_WAIT_TIME','Average Wait Time for Abandoned Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ANSWERED','Average number of Answered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ANSWERED_SLA','Average number of Answered Calls that were waiting for less or equal than answered_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ANSWERED_TALK_TIME','Average Talk Time for Answered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_ANSWERED_WAIT_TIME','Average Wait Time for Answered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_LOGIN','Average number of Agent Logins',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_LOGOUT','Average number of Agents Logoffs',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_RECEIVED','Average number of Received Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_TRANSFERRED','Average number of Transferred Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_TRANSFERRED_SLA','Average number of Transferred Calls that were waiting for less or equal than transferred_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_TRANSFERRED_TALK_TIME','Average Talk Time of Transferred Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_TRANSFERRED_WAIT_TIME','Average Wait Time of Transferred Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_UNANSWERED','Average number of Unanswered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_UNANSWERED_SLA','Average number of Unanswered Calls that had a wait time of less or equal seconds as set in unanswered_sla in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_AVG_UNANSWERED_WAIT_TIME','Average Wait Time for Unanswered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_CALLS_WAITING','Number of Calls Waiting. Only available in COLUMN_REALTIME formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_LOGIN','Number of Agent Logins.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_LOGOUT','Number of Agent Logoffs.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_ABANDONED_WAIT_TIME','Maximum Wait Time in Abandoned Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_ANSWERED_TALK_TIME','Maximum Talk Time in Answered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_ANSWERED_WAIT_TIME','Maximum Wait Time in Answered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_CALLERS_WAITING','Maximum number of callers waiting in the queue.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_COL','Maximum value for the column, to be used in TOTAL formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_TRANSFERRED_TALK_TIME','Maximum Talk Time for Transferred Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_TRANSFERRED_WAIT_TIME','Maximum Wait Time for Transferred Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_UNANSWERED_WAIT_TIME','Maximum Wait Time for Unanswered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MAX_WAIT_TIME','Maximum Wait Time for the particular grouped report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_ABANDONED_WAIT_TIME','Minimum Wait Time in Abandoned Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_ANSWERED_TALK_TIME','Minimum Talk Time in Answered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_ANSWERED_WAIT_TIME','Minimum Wait Time in Answered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_COL','Minimum value for the column, to be used in TOTAL formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_TRANSFERRED_TALK_TIME','Minimum Talk Time for Transferred Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_TRANSFERRED_WAIT_TIME','Minimum Wait Time for Transferred Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_MIN_UNANSWERED_WAIT_TIME','Minimum Wait Time for Unanswered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_RECEIVED','Number of Received calls (with EVENT_RECEIVED disposition in the queue_log file) for the particular grouped report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_ROW_COUNT','Number of Rows on the report. To be used in TOTAL formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ABANDONED','Sum of Abandoned calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ABANDONED_SLA','Sum of Abandoned calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_abandoned seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ABANDONED_WAIT_TIME','Sum of Wait Time for Abandoned Calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ANSWERED','Sum of Answered Calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ANSWERED_SLA','Sum of Answered Calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_answered seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ANSWERED_TALK_TIME','Sum of Talk Time for Answered calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_ANSWERED_WAIT_TIME','Sum of Wait Time for Answered calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_COL','Sum of all values for a particular column. To be used in TOTAL formulas.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_LOGIN','Sum of Login events up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_LOGOUT','Sum of Logoff events up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_RECEIVED','Sum of Received Calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_TRANSFERRED','Sum of Transferred Calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_TRANSFERRED_SLA','Sum of Transferred Calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_transferred seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_TRANSFERRED_TALK_TIME','Sum of Talk Time for Transferred calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_TRANSFERRED_WAIT_TIME','Sum of Wait Time for Transferred calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_UNANSWERED','Sum of Unanswered calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_UNANSWERED_SLA','Sum of Unanswered calls up to the particular row in a report, who&#146;s wait time is less or equal than transferred_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_SUM_UNANSWERED_WAIT_TIME','Sum of Wait Time for Transferred calls up to the particular row in a report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ABANDONED','Total number of Abandoned Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ABANDONED_SLA','Total number of Abandoned calls who&#146;s wait time is less or equal than abandoned_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ABANDONED_WAIT_TIME','Total Wait Time for Abandoned Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ANSWERED','Total number of Answered calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ANSWERED_SLA','Total number of Answered calls who&#146;s wait time is less or equal than answered_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ANSWERED_TALK_TIME','Total Talk Time for Answered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_ANSWERED_WAIT_TIME','Total Wait Time for Answered Calls',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_LOGIN','Total number of Login events.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_LOGOUT','Total number of Logoff events.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_RECEIVED','Total number of Received calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_TRANSFERRED','Total number of Transferred calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_TRANSFERRED_SLA','Total of Transferred Calls that have a wait time of less or equal transferred_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_TRANSFERRED_TALK_TIME','Total Talk Time for Transferred Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_TRANSFERRED_WAIT_TIME','Total Wait Time for Transferred Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_UNANSWERED','Total number of Unanswered Calls.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_UNANSWERED_SLA','Total of Unanswered Calls that have a wait time of less or equal unanswered_sla seconds as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TOTAL_UNANSWERED_WAIT_TIME','Wait Time for Unanswered Calls for the whole set of data.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TRANSFERRED','Number of Transferred Calls (with EVENT_TRANSFERRED disposition in queue_log)',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TRANSFERRED_SLA','Number of Transferred Calls (with EVENT_TRANSFERRED disposition in queue_log) who&#146;s wait time is less or equal than transferred_sla as set in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TRANSFERRED_TALK_TIME','Talk Time for Transferred Calls for a particular row.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_TRANSFERRED_WAIT_TIME','Wait Time for Transferred Calls for a particular row.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_UNANSWERED','Number of Unanswered calls (with EVENT_UNANSWERED disposition in the queue_log file) for the particular grouped report.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_UNANSWERED_SLA','Number of Unanswered calls (with EVENT_UNANSWERED disposition in queue_log) who&#146;s wait time was less or equal than sla_unanswered setting in Preferences.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_variable_UNANSWERED_WAIT_TIME','Wait Time for Unanswered Calls for a particular row.',0,'2012-10-02 10:42:51'),(NULL,'en','help_text_wait_time_format','Format for the wait time fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in drill down and detailed reports.',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_week_mode','When to start counting weeks from the year:<br><pre>\r\nMode    First day of week       Range   Week 1 is the first week ...\r\n0       Sunday                  0-53    with a Sunday in this year\r\n1       Monday                  0-53    with more than 3 days this year\r\n2       Sunday                  1-53    with a Sunday in this year\r\n3       Monday                  1-53    with more than 3 days this year\r\n4       Sunday                  0-53    with more than 3 days this year\r\n5       Monday                  0-53    with a Monday in this year\r\n6       Sunday                  1-53    with more than 3 days this year\r\n7       Monday                  1-53    with a Monday in this year\r\n</pre>',0,'2012-10-02 09:55:45'),(NULL,'en','help_text_wrap_up','Optinoal wrap_up time, it can be set globally or per queue. This value will affect the AHL (Average Handling Time) numbers in reports.',0,'2015-01-07 22:12:49'),(NULL,'en','hours','hours',0,'2012-10-02 22:21:11'),(NULL,'en','info1','Info 1',0,'2012-09-07 04:00:52'),(NULL,'en','info2','info 2',0,'2012-09-07 04:00:52'),(NULL,'en','info3','Info 3',0,'2012-09-07 04:00:52'),(NULL,'en','info4','Info 4',0,'2012-09-07 04:00:52'),(NULL,'en','info5','Info 5',0,'2012-09-07 04:00:52'),(NULL,'en','none','none',0,'0000-00-00 00:00:00'),(NULL,'en','of','of',0,'2012-10-02 22:21:37'),(NULL,'en','on %s since %s seconds ago','en %s desde hace %s segundos',0,'0000-00-00 00:00:00'),(NULL,'en','on %s since %s secs ago','on %s since %s secs ago',0,'2012-09-05 04:05:40'),(NULL,'en','on days','on days',0,'2012-10-02 10:43:07'),(NULL,'en','on hours','on hours',0,'2012-10-02 10:43:07'),(NULL,'en','on minutes','on minutes',0,'2012-10-02 10:43:07'),(NULL,'en','partial','partial',0,'2012-09-07 06:34:02'),(NULL,'en','realtime-agent-busy','Busy',0,'2012-09-08 03:44:12'),(NULL,'en','realtime-agent-dialout','Outbound Call',0,'2012-09-08 03:45:12'),(NULL,'en','realtime-agent-hold','On Hold',0,'0000-00-00 00:00:00'),(NULL,'en','realtime-agent-not in use','Not in use',0,'2012-09-18 10:51:34'),(NULL,'en','realtime-agent-ringing','Ringing',0,'2012-09-08 03:44:32'),(NULL,'en','realtime-agent-unavailable','Unavailable',0,'0000-00-00 00:00:00'),(NULL,'en','realtime_queue_summary','Queue Summary',0,'2012-09-18 10:51:34'),(NULL,'en','seconds','seconds',0,'0000-00-00 00:00:00'),(NULL,'en','unanswered_calls_by_event','Disconnection Cause',0,'2012-10-02 10:43:08'),(NULL,'en','unanswered_calls_by_holdtime','Service Level',0,'2012-10-02 10:43:08'),(NULL,'en','unanswered_calls_by_queue','Unanswered Calls by Queue',0,'2012-10-02 22:21:01'),(NULL,'en','unanswered_calls_by_url','Unanswered Calls by URL',0,'2012-10-02 05:53:49'),(NULL,'en','unanswered_calls_detail','Unanswered Calls Detail',0,'2012-10-02 10:43:07'),(NULL,'en','unanswered_calls_summary','Unanswered Calls Summary',0,'2012-10-02 05:53:49'),(NULL,'en','within','within',0,'0000-00-00 00:00:00'),(NULL,'en','within %d%s seconds','within %d%s seconds',0,'2012-09-22 02:07:06');

INSERT INTO `language` VALUES (NULL,'es','%','%',0,'2012-09-17 20:40:08'),(NULL,'es','%%','%%',0,'2012-09-08 04:26:34'),(NULL,'es','%% Answ','%% Atendidas',0,'2012-09-17 20:40:08'),(NULL,'es','%% Calls','%% Llamadas',0,'2012-09-08 04:26:34'),(NULL,'es','%% Paused','%% en Pausa',0,'2012-09-08 00:45:47'),(NULL,'es','%% Talk Time','%% Tiempo al habla',0,'2012-09-08 04:26:34'),(NULL,'es','%% Unansw','%% No Atendidas',0,'2012-09-17 20:40:08'),(NULL,'es','%s','%s',0,'2012-09-08 00:45:47'),(NULL,'es','%s %%','%s %%',0,'0000-00-00 00:00:00'),(NULL,'es','%s days','%s días',0,'2012-09-17 20:40:08'),(NULL,'es','%s min. ago','hace %s min.',0,'2012-09-17 20:41:28'),(NULL,'es','%s minutes','%s mins',0,'0000-00-00 00:00:00'),(NULL,'es','%s records deleted','%s registros eliminados',0,'0000-00-00 00:00:00'),(NULL,'es','%s secs','%s segs',0,'0000-00-00 00:00:00'),(NULL,'es','ABANDON','Abandonada',0,'2012-09-11 06:46:36'),(NULL,'es','ALL','Todos',0,'2012-09-13 05:35:09'),(NULL,'es','Abandon Avg Queue Position at Disconnection','Posicion Final Media en Abandono',0,'2012-09-05 01:42:02'),(NULL,'es','Abandon Avg Queue Start Position','Posicion Inicial Media en Abandono',0,'2012-09-05 01:42:02'),(NULL,'es','Abandon Avg Wait Before Disconnection','Espera media antes de Abandono',0,'2012-09-05 01:42:02'),(NULL,'es','Abandon Rate','Tasa de Abandono',0,'2012-09-17 20:41:28'),(NULL,'es','Abandoned','Abandonadas',0,'2012-09-17 20:41:28'),(NULL,'es','Abandoned Calls','Llamadas Abandonadas',0,'2012-09-05 01:42:02'),(NULL,'es','Actions','Acciones',0,'2012-09-17 20:40:08'),(NULL,'es','Active','Activo',0,'2012-09-13 05:37:57'),(NULL,'es','Add','Agregar',0,'2012-09-13 05:35:09'),(NULL,'es','Add Record','Agregar Registro',0,'0000-00-00 00:00:00'),(NULL,'es','Agent','Agente',0,'2012-09-17 20:41:28'),(NULL,'es','Agent Status','Estado de Agentes',0,'2012-09-17 20:41:28'),(NULL,'es','Agent Totals','Totales de Agente',0,'2012-09-08 00:45:47'),(NULL,'es','Agents','Agentes',0,'2012-09-17 20:41:28'),(NULL,'es','Alert','Alerta',0,'2012-09-13 05:37:57'),(NULL,'es','Alerts','Alertas',0,'2012-09-13 05:37:57'),(NULL,'es','All %s records are selected.','Todos los %s registros han sido seleccionados.',0,'0000-00-00 00:00:00'),(NULL,'es','All %s records on this page are selected.','Los %s registros de esta página han sido seleccionados.',0,'0000-00-00 00:00:00'),(NULL,'es','An error has occurred','Ha ocurrido un error',0,'0000-00-00 00:00:00'),(NULL,'es','Answer','Atendida',0,'2012-09-08 04:26:34'),(NULL,'es','Answered','Atendidas',0,'2012-09-17 20:41:28'),(NULL,'es','Answered Calls','Llamadas Atendidas',0,'2012-09-08 04:26:34'),(NULL,'es','Answered by Day','Atendidas por Día',0,'2012-09-17 20:40:08'),(NULL,'es','Answered/Abandoned','Atendidas/Abandonadas',0,'2012-09-05 01:42:02'),(NULL,'es','Answered/Abandoned per Hour','Atendidas/Abandonadas por Hora',0,'2012-09-17 20:40:08'),(NULL,'es','April','Abril',0,'2012-09-17 20:41:28'),(NULL,'es','Are you sure?','Está seguro?',0,'2012-09-13 05:37:57'),(NULL,'es','August','Agosto',0,'2012-09-17 20:41:28'),(NULL,'es','Available','Disponible',0,'2012-09-17 20:40:02'),(NULL,'es','Available Keywords','Seteos Disponibles',0,'2012-09-08 04:21:56'),(NULL,'es','Available Variables','Variables Disponibles',0,'2012-09-08 04:21:56'),(NULL,'es','Average Duration by Day','Duración Promedio por Día',0,'2012-09-17 20:40:08'),(NULL,'es','Average Session Time','Duración Media de Sesión',0,'2012-09-08 00:45:47'),(NULL,'es','Average Wait Time by Day','Espera Promedio por Día',0,'2012-09-17 20:40:08'),(NULL,'es','Avg Duration','Duración Media',0,'2012-09-17 20:41:28'),(NULL,'es','Avg Talk','Dur.Media',0,'2012-09-17 20:40:08'),(NULL,'es','Avg Talk Time','Duración Media',0,'2012-09-08 04:26:34'),(NULL,'es','Avg Wait','Esp.Media',0,'2012-09-17 20:41:28'),(NULL,'es','Avg Wait Time','Espera Media',0,'2012-09-08 04:26:34'),(NULL,'es','Avg. Paused','Promedio en Pausa',0,'2012-09-08 00:45:47'),(NULL,'es','Avg. Session','Promedio Sesión',0,'2012-09-08 00:45:47'),(NULL,'es','Avg. Session Time','Duración Media de Sesión',0,'2012-09-08 00:45:47'),(NULL,'es','Back','Volver',0,'0000-00-00 00:00:00'),(NULL,'es','Bad username or password','Nombre de Usuario o Clave Incorrectos',0,'0000-00-00 00:00:00'),(NULL,'es','Busy','Ocupado',0,'2012-09-17 20:41:28'),(NULL,'es','COMPLETEAGENT','Cortó el Agente',0,'2012-09-08 00:45:47'),(NULL,'es','COMPLETECALLER','Cortó el Usuario',0,'2012-09-11 06:46:36'),(NULL,'es','Caller ID','Ident. de Llamada',0,'2012-09-17 20:41:28'),(NULL,'es','Calls','Llamadas',0,'2012-09-17 20:41:28'),(NULL,'es','Calls Waiting Detail','Detalle de Llamadas en Espera',0,'0000-00-00 00:00:00'),(NULL,'es','Campaigns','Campaigns',1,'2015-01-07 22:37:29'),(NULL,'es','Cancel','Cancelar',0,'2012-09-13 05:37:57'),(NULL,'es','Cannot steal call. realtime_spy_extension for user <b>%s</b> is not defined in Setup/Preferences.','No se puede capturar el llamado. Falta configurar realtime_spy_extension para el usuario <b>%s</b> en Configuración/Preferencias.',0,'0000-00-00 00:00:00'),(NULL,'es','Clear Selection','Limpiar Selección',0,'0000-00-00 00:00:00'),(NULL,'es','Click to add text','Click para agregar texto',0,'2012-09-13 05:26:00'),(NULL,'es','Click to edit...','Click para editar...',0,'0000-00-00 00:00:00'),(NULL,'es','Click to view calls in detail','Pulse aquí para ver detalles',0,'2012-09-17 20:40:08'),(NULL,'es','Close','Close',1,'2017-10-13 20:05:50'),(NULL,'es','Coach','Entrenamiento',0,'0000-00-00 00:00:00'),(NULL,'es','Completed','Completadas',0,'2012-09-13 05:26:00'),(NULL,'es','Confirm','Confirmar',0,'2012-09-13 04:58:56'),(NULL,'es','Could not connect to the Asterisk Manager Interface to retrieve status information. Please check your manager credentials in config.php and verify they match your settings in /etc/asterisk/manager.conf','No es posible conectar con el Asterisk Manager para obtener informaci&oacute;n de estado actual de las colas y agentes. Por favor revise las credenciales de acceso en config.php y que éstas coincidan con las configuradas en /etc/asterisk/manager.conf.',0,'0000-00-00 00:00:00'),(NULL,'es','Could not copy uploaded file','No pude copiar el archivo subido',0,'0000-00-00 00:00:00'),(NULL,'es','Count','Cantidad',0,'2012-09-08 04:26:35'),(NULL,'es','Cron Configuration','Configuraci&oacute;n Cron',0,'2012-09-13 05:37:57'),(NULL,'es','Dashboard','Dashboard',1,'2015-01-07 22:37:29'),(NULL,'es','Date','Fecha',0,'2012-09-17 20:40:08'),(NULL,'es','Day','Día',0,'2012-09-17 20:40:08'),(NULL,'es','Day of Week','Día de Semana',0,'2017-10-13 20:05:49'),(NULL,'es','December','Diciembre',0,'2012-09-17 20:41:28'),(NULL,'es','Delete','Eliminar',0,'2012-09-13 05:37:57'),(NULL,'es','Delete Marked','Eliminar Marcados',0,'2012-09-13 05:37:57'),(NULL,'es','Delta','Delta',0,'2012-09-08 04:26:34'),(NULL,'es','Deselects all','Deseleccionar todos',0,'2012-09-17 20:40:02'),(NULL,'es','Deselects marked','Deseleccionar marcados',0,'2012-09-17 20:40:02'),(NULL,'es','Dialer','Dialer',1,'2015-01-07 22:37:29'),(NULL,'es','Display Report','Mostrar Reporte',0,'2012-09-17 20:40:02'),(NULL,'es','Distribution','Distribución',0,'2012-09-17 20:40:15'),(NULL,'es','Download','Descargar',0,'2012-09-11 06:46:36'),(NULL,'es','Duration','Duración',0,'2012-09-17 20:41:28'),(NULL,'es','EXITWITHKEY','Salida por Tecla',0,'0000-00-00 00:00:00'),(NULL,'es','EXITWITHTIMEOUT','Tiempo Máximo Alcanzado',0,'2012-09-08 04:26:30'),(NULL,'es','Edit Email Alert','Editar Alerta por Email',0,'2012-09-13 05:37:57'),(NULL,'es','Edit Record','Editar Registro',0,'2012-09-13 05:37:57'),(NULL,'es','Edit Scheduled Report','Modificar Informe Programado',0,'2012-09-13 05:37:57'),(NULL,'es','Email','Email',0,'2012-09-13 05:37:57'),(NULL,'es','Empty file?','Archivo vacío?',0,'0000-00-00 00:00:00'),(NULL,'es','End Date','Fecha Final',0,'2012-09-17 20:40:08'),(NULL,'es','End Position','Pos. Final',0,'2012-09-05 01:42:02'),(NULL,'es','Error inserting record:<br/>','Error al insertar registro:<br/>',0,'0000-00-00 00:00:00'),(NULL,'es','Error updating record','Error actualizando el registro',0,'0000-00-00 00:00:00'),(NULL,'es','Event','Evento',0,'2012-09-17 20:40:08'),(NULL,'es','Example','Ejemplo',0,'2012-09-13 05:37:57'),(NULL,'es','Export','Exportar',0,'2012-09-13 05:26:00'),(NULL,'es','Exports the data to a .pdf file','Exportar datos a archivo .pdf',0,'2012-09-11 06:46:36'),(NULL,'es','Exports the data to a comma separated file, to be read by your spreadsheet software','Exportar datos a archivo separado por comas para utilizar con planilla de cálculos',0,'2012-09-11 06:46:36'),(NULL,'es','Fails','Fallos',0,'2013-07-03 06:04:09'),(NULL,'es','February','Febrero',0,'2012-09-17 20:41:28'),(NULL,'es','Filter','Filtrar',0,'2012-09-17 20:40:15'),(NULL,'es','Filter report by Caller Id','Filtrar reporte por identificador de llamada',0,'2012-09-17 20:40:08'),(NULL,'es','First','Primera',0,'2012-09-13 05:37:57'),(NULL,'es','Friday','Viernes',0,'2012-09-17 20:41:28'),(NULL,'es','From','Desde',0,'2012-09-17 20:40:02'),(NULL,'es','From the last (X) days','De los &uacute;ltimos (X) dias',0,'2012-09-13 05:37:57'),(NULL,'es','Generate','Generar',0,'0000-00-00 00:00:00'),(NULL,'es','Generate Offline License Request','Generar solicitud de Licencia Offline',0,'0000-00-00 00:00:00'),(NULL,'es','Goes to the top of the page','Ir al comienzo de la página',0,'2012-09-17 20:41:28'),(NULL,'es','Group by Queue','Agrupar por Colas',0,'2012-09-17 20:41:28'),(NULL,'es','Help','Ayuda',0,'2012-09-13 05:12:22'),(NULL,'es','Hide Logged off','Ocultar Agentes Desconectados',0,'2012-09-17 20:41:28'),(NULL,'es','Higher ...','Mayor ...',0,'2012-09-17 20:40:02'),(NULL,'es','Home','Inicio',0,'2012-09-17 20:40:15'),(NULL,'es','Hour','Hora',0,'2012-09-17 20:40:08'),(NULL,'es','Hour Range','Rango Horario',0,'2012-09-17 20:40:08'),(NULL,'es','Hours','Horas',0,'2012-09-13 05:37:57'),(NULL,'es','ISO Code','Código ISO',0,'2012-09-13 05:26:00'),(NULL,'es','Idle Time','Tiempo Ocioso',0,'2013-07-03 05:18:22'),(NULL,'es','If the field value is higher than this number you will receive an alerting email','Si el valor del campo es mayor al indicado aquí, entonces reicibirá un email de alerta.',0,'2012-09-13 05:37:57'),(NULL,'es','Ignoring field ','Ignorando el campo',0,'0000-00-00 00:00:00'),(NULL,'es','Import','Importar',0,'2012-09-13 05:33:42'),(NULL,'es','In order to receive scheduled reports or alerts via email, you must setup a cron job in the server. You can use the following command in your server command line:<br/><br/>crontab -e<br/><br/>and add the following line (replacing the user and password with a valid user/password):<br/><br/>','Para recibir los reportes y alertas por email, deberá configurar una tarea de Cron en el servidor. Puede usar la siguiente instrucción en la línea de comandos  comandos:<br/>\r\n<br/>\r\ncrontab -e<br/>\r\n<br/>\r\ny agregar la siguiente línea (reemplazando el usuario y clave por uno válido):<br/>\r\n<br/>',0,'2012-09-13 05:37:57'),(NULL,'es','Incompleted Calls','Llamadas Incompletas',0,'2012-09-05 01:42:02'),(NULL,'es','Invalid Date','Fecha Inválida',0,'0000-00-00 00:00:00'),(NULL,'es','Invalid Hour','Hora Inválida',0,'0000-00-00 00:00:00'),(NULL,'es','January','Enero',0,'2012-09-17 20:41:28'),(NULL,'es','July','Julio',0,'2012-09-17 20:41:28'),(NULL,'es','June','Junio',0,'2012-09-17 20:41:28'),(NULL,'es','Last','Ultimo',0,'2012-09-13 05:37:57'),(NULL,'es','Last in Call','Ultima Llamada',0,'2012-09-17 20:41:28'),(NULL,'es','Last three months','Ultimos tres meses',0,'2012-09-17 20:40:02'),(NULL,'es','Level','Nivel',0,'2012-09-13 05:35:09'),(NULL,'es','License Handling','Manejo de Licencia',0,'0000-00-00 00:00:00'),(NULL,'es','License validation problem','Problema al validar la licencia',0,'2012-09-07 00:26:36'),(NULL,'es','Licensed to','Licenciado a',0,'2012-09-17 20:40:15'),(NULL,'es','Listen','Escuchar Llamada',0,'0000-00-00 00:00:00'),(NULL,'es','Lists','Lists',1,'2015-01-07 22:37:29'),(NULL,'es','Loading','Cargando',0,'2012-09-17 20:40:15'),(NULL,'es','Logged Off','Desconectados',0,'2012-09-17 20:41:28'),(NULL,'es','Login','Ingresar',0,'2012-09-13 05:35:09'),(NULL,'es','Login Form','Formulario de Ingreso',0,'0000-00-00 00:00:00'),(NULL,'es','Logins','Ingresos',0,'2012-09-17 20:40:08'),(NULL,'es','Logoff','Egresos',0,'2012-09-17 20:40:08'),(NULL,'es','Logout','Salir',0,'2012-09-17 20:40:15'),(NULL,'es','Longest Session','Sesión Más Larga',0,'2012-09-08 00:45:47'),(NULL,'es','Lower ...','Menor ...',0,'2012-09-17 20:40:02'),(NULL,'es','March','Marzo',0,'2012-09-17 20:41:28'),(NULL,'es','Max Callers','Max. en Espera',0,'2012-09-17 20:40:08'),(NULL,'es','Max Wait Time','Espera Máxima',0,'2012-09-08 04:26:34'),(NULL,'es','Max. wait time','Tiempo Máximo de Espera',0,'2012-09-17 20:41:28'),(NULL,'es','May','Mayo',0,'2012-09-17 20:41:28'),(NULL,'es','Minutes','Minutos',0,'2012-09-13 05:37:57'),(NULL,'es','Monday','Lunes',0,'2012-09-17 20:41:28'),(NULL,'es','Month','Mes',0,'2012-09-17 20:40:08'),(NULL,'es','Month days','D&iacute;as del mes',0,'2012-09-13 05:37:57'),(NULL,'es','Name','Nombre',0,'2012-09-13 05:35:09'),(NULL,'es','New Email Alert','Nuevo Alerta por Email',0,'2012-09-13 05:37:57'),(NULL,'es','New Scheduled Report','Nuevo Informe Programado',0,'2012-09-13 05:37:57'),(NULL,'es','Next','Siguiente',0,'2012-09-13 05:37:57'),(NULL,'es','No','No',0,'2012-09-13 05:37:57'),(NULL,'es','No active channel','Canal no activado',0,'0000-00-00 00:00:00'),(NULL,'es','No info','Sin datos',0,'2012-09-05 04:37:44'),(NULL,'es','No records found','No se encontraron registros',0,'2012-09-13 05:16:17'),(NULL,'es','No results','Sin resultados',0,'2012-09-07 00:26:45'),(NULL,'es','No valid fields to import!','No hay campos válidos para importar',0,'0000-00-00 00:00:00'),(NULL,'es','None','Ninguno',0,'2012-09-11 06:46:36'),(NULL,'es','Notice','Aviso',0,'0000-00-00 00:00:00'),(NULL,'es','November','Noviembre',0,'2012-09-17 20:41:28'),(NULL,'es','Number','Número',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Abandoned Calls','Número de Llamadas Abandonadas',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Agent Logins','Número de Ingresos de Agente',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Agent Logoffs','Número de Egresos de Agente',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Agents','Cantidad de Agentes',0,'2012-09-08 00:45:47'),(NULL,'es','Number of Answered Calls','Número de Llamadas Atendidas',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Calls per Agent','Número de Llamadas por Agente',0,'2012-09-08 04:26:35'),(NULL,'es','Number of Outbound Calls','Número de Llamadas Salientes',0,'2015-01-07 22:12:24'),(NULL,'es','Number of Received Calls','Número de Llamadas Recibidas',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Transferred Calls','Número de Llamadas Transferidas',0,'2012-09-17 20:40:08'),(NULL,'es','Number of Unanswered Calls','Número de Llamadas No Atendidas',0,'2012-09-17 20:40:08'),(NULL,'es','Numbers','Numbers',1,'2015-01-07 22:37:29'),(NULL,'es','OK','OK',0,'0000-00-00 00:00:00'),(NULL,'es','October','Octubre',0,'2012-09-17 20:41:28'),(NULL,'es','Outbound Calls','Llamadas Salientes',0,'2015-01-07 22:12:24'),(NULL,'es','Overflow','Desborde',0,'2012-09-07 00:24:13'),(NULL,'es','Page','Página',0,'2012-09-13 05:37:57'),(NULL,'es','Page parsed in %s seconds','Página procesada en %s segundos',0,'2012-09-17 20:41:28'),(NULL,'es','Password','Clave',0,'2012-09-13 05:35:09'),(NULL,'es','Passwords do not match','Las claves no coinciden',0,'2012-09-13 04:58:56'),(NULL,'es','Pause Time','Tiempo en Pausa',0,'2012-09-08 00:45:47'),(NULL,'es','Paused','En Pausa',0,'2012-09-17 20:41:28'),(NULL,'es','Pauses','Pausas',0,'2012-09-08 00:45:47'),(NULL,'es','Pauses per Session','Pausas por Sesión',0,'2012-09-08 00:45:47'),(NULL,'es','Pending','Pendiente',0,'2012-09-13 05:26:00'),(NULL,'es','Period','Período',0,'2012-09-17 20:40:08'),(NULL,'es','Play','Escuchar Grabación',0,'2012-09-11 06:46:36'),(NULL,'es','Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use','Por favor, copie el texto y env&iacute;elo por email a %s para su procesamiento junto con su c&oacute;digo de activacion y el nombre que desee que aparezca en la licencia.',0,'0000-00-00 00:00:00'),(NULL,'es','Please select the reports to send','Seleccione los informes a enviar',0,'2012-09-13 05:37:57'),(NULL,'es','Please write down destination emails','Escriba el/los emails de destino',0,'2012-09-13 05:37:57'),(NULL,'es','Position','Posición',0,'0000-00-00 00:00:00'),(NULL,'es','Previous','Anterior',0,'2012-09-13 05:37:57'),(NULL,'es','Proceed','Proceder',0,'2012-09-08 04:25:24'),(NULL,'es','Querying data...','Consultando...',0,'2012-09-13 05:37:57'),(NULL,'es','Queue','Cola',0,'2012-09-17 20:41:28'),(NULL,'es','Queues','Colas',0,'2012-09-13 05:35:09'),(NULL,'es','RINGNOANSWER','Fallo en Atender',0,'2012-09-08 00:48:15'),(NULL,'es','Reactivate','Reactivar',0,'2012-09-08 04:25:13'),(NULL,'es','Realtime','Estado Actual',0,'2012-09-17 20:40:15'),(NULL,'es','Received','Recibidas',0,'2012-09-17 20:40:08'),(NULL,'es','Record deleted','Registro eliminado',0,'2012-09-05 06:36:16'),(NULL,'es','Record inserted','Registro Insertado',0,'0000-00-00 00:00:00'),(NULL,'es','Record updated','Registro actualizado',0,'2012-09-05 05:47:29'),(NULL,'es','Records imported','Registros Importados',0,'0000-00-00 00:00:00'),(NULL,'es','Report','Informe',0,'2012-09-13 05:37:57'),(NULL,'es','Reports','Informes',0,'2012-09-13 05:37:57'),(NULL,'es','Required field','Campo obligatorio',0,'2012-09-13 04:58:56'),(NULL,'es','Revoke','Revocar',0,'0000-00-00 00:00:00'),(NULL,'es','Revoke Current License','Revocar la licencia Actual',0,'0000-00-00 00:00:00'),(NULL,'es','SLA','SLA',0,'2012-09-17 20:40:08'),(NULL,'es','Saturday','Sábado',0,'2012-09-17 20:41:28'),(NULL,'es','Save','Guardar',0,'2012-09-13 05:37:57'),(NULL,'es','Scheduled Reports and Alerts','Informes y Alertas Programados',0,'2012-09-13 05:37:57'),(NULL,'es','Search','Buscar',0,'2012-09-17 20:40:15'),(NULL,'es','Seconds','Segundos',0,'2012-09-08 04:26:12'),(NULL,'es','Select Agents','Seleccione Agentes',0,'2012-09-17 20:40:02'),(NULL,'es','Select Date Range','Seleccione Rango de Fechas',0,'2012-09-17 20:40:02'),(NULL,'es','Select Queues','Seleccione Colas',0,'2012-09-17 20:40:02'),(NULL,'es','Select Time Frame','Seleccione Rango Horario',0,'2012-09-17 20:40:02'),(NULL,'es','Select all %s records.','Marcar los %s registros encontrados.',0,'0000-00-00 00:00:00'),(NULL,'es','Select an option','Elija una opción',0,'2012-09-05 05:47:32'),(NULL,'es','Select language','Elija idioma',0,'2012-09-13 05:26:00'),(NULL,'es','Select option','Elija opción',0,'2012-09-13 05:38:01'),(NULL,'es','Select some options','Select some options',0,'2012-09-13 04:58:56'),(NULL,'es','Select the field to compare','Seleccione el campo a comparar',0,'2012-09-13 05:37:57'),(NULL,'es','Select the report to check','Elija el reporte a verificar',0,'2012-09-13 05:37:57'),(NULL,'es','Selected','Seleccionados',0,'2012-09-17 20:40:02'),(NULL,'es','Selects all','Selecciona todos',0,'2012-09-17 20:40:02'),(NULL,'es','Selects marked','Selecciona marcados',0,'2012-09-17 20:40:02'),(NULL,'es','Separate with comma ( , )<br>* means all','Separe con comas ( , )<br>* significa todo',0,'2012-09-13 05:37:57'),(NULL,'es','September','Septiembre',0,'2012-09-17 20:41:28'),(NULL,'es','Server Time','Hora en el Servidor',0,'2012-09-17 20:41:28'),(NULL,'es','Session Time','Tiempo de Sesión',0,'2012-09-08 00:45:47'),(NULL,'es','Sessions','Sesiones',0,'2012-09-08 00:45:47'),(NULL,'es','Setup','Configuración',0,'2012-09-17 20:40:15'),(NULL,'es','Shortcuts','Atajos',0,'2012-09-17 20:40:02'),(NULL,'es','Shortest Session Time','Sesión Más Corta',0,'2012-09-08 00:45:47'),(NULL,'es','Spy','Espiar',0,'0000-00-00 00:00:00'),(NULL,'es','Start Date','Fecha Inicial',0,'2012-09-17 20:40:08'),(NULL,'es','Start Position','Posición Inicial',0,'2012-09-05 01:42:02'),(NULL,'es','State','Estado',0,'2012-09-17 20:41:28'),(NULL,'es','Steal','Capturar',0,'0000-00-00 00:00:00'),(NULL,'es','String','Texto',0,'2012-09-13 05:26:00'),(NULL,'es','Success!','Exito!',0,'2012-09-05 06:36:16'),(NULL,'es','Sunday','Domingo',0,'2012-09-17 20:41:28'),(NULL,'es','TRANSFER','Transferida',0,'2012-09-08 00:45:47'),(NULL,'es','Tag','Etiqueta',0,'2017-10-13 20:05:49'),(NULL,'es','Talk Time','Tiempo al Habla',0,'2012-09-17 20:40:08'),(NULL,'es','There is no valid license file on this installation yet.','No hay licencia válida para esta instalación.',0,'0000-00-00 00:00:00'),(NULL,'es','This month','Este mes',0,'2012-09-17 20:40:02'),(NULL,'es','This week','Esta semana',0,'2012-09-17 20:40:02'),(NULL,'es','Thursday','Jueves',0,'2012-09-17 20:41:28'),(NULL,'es','Time','Duración',0,'2012-09-08 00:45:47'),(NULL,'es','To','Hasta',0,'2012-09-17 20:40:02'),(NULL,'es','Today','Hoy',0,'2012-09-17 20:40:02'),(NULL,'es','Toggle Search Form','Ocultar/Mostrar Formulario',0,'2012-09-07 00:24:13'),(NULL,'es','Total','Total',0,'2012-09-17 20:41:28'),(NULL,'es','Total Answered Calls','Total de Llamadas Atendidas',0,'2012-09-08 04:26:34'),(NULL,'es','Total Calls','Total de Llamadas',0,'2012-09-17 20:40:08'),(NULL,'es','Total Duration','Duración Total',0,'2012-09-08 04:26:34'),(NULL,'es','Total Session Time','Tiempo Total de Sesiones',0,'2012-09-08 00:45:47'),(NULL,'es','Total Time per Agent (seconds)','Tiempo Total por Agente (segundos)',0,'2012-09-08 04:26:35'),(NULL,'es','Total Unanswered Calls','Total de Llamadas No Atendidas',0,'2012-09-05 01:42:02'),(NULL,'es','Total records found','Total de registros encontrados',0,'2012-09-13 05:37:57'),(NULL,'es','Transferred','Transferidas',0,'2012-09-17 20:40:08'),(NULL,'es','Transferred Calls','Llamadas Transferidas',0,'2012-09-08 04:26:34'),(NULL,'es','Translation','Traducción',0,'2012-09-13 05:26:00'),(NULL,'es','Tuesday','Martes',0,'2012-09-17 20:41:28'),(NULL,'es','Type','Tipo',0,'2012-09-13 05:37:57'),(NULL,'es','URL','URL',0,'2012-09-17 20:40:08'),(NULL,'es','Unanswered','No Atendidas',0,'2012-09-17 20:41:28'),(NULL,'es','Unanswered Calls','Llamadas no Atendidas',0,'2012-09-05 01:42:02'),(NULL,'es','Unanswered Rate','Tasa de No Atendidas',0,'2012-09-17 20:40:08'),(NULL,'es','Unanswered by Day','Sin Atender por Día',0,'2012-09-17 20:40:08'),(NULL,'es','Use comma to separate emails','Use comas ( , ) para separar direcciones',0,'2012-09-13 05:37:57'),(NULL,'es','User','Usuario',0,'0000-00-00 00:00:00'),(NULL,'es','View Record','Ver Registro',0,'2012-09-13 05:35:09'),(NULL,'es','Wait Time','Tiempo Espera',0,'2012-09-17 20:40:08'),(NULL,'es','Waiting','En espera',0,'2012-09-17 20:41:28'),(NULL,'es','Wednesday','Miércoles',0,'2012-09-17 20:41:28'),(NULL,'es','Week','Semana',0,'2012-09-17 20:40:08'),(NULL,'es','Week days','Días de la semana',0,'2012-09-13 05:37:57'),(NULL,'es','Write down the value to compare','Escriba el valor a comparar',0,'2012-09-13 05:37:57'),(NULL,'es','Yes','Si',0,'2012-09-13 05:37:57'),(NULL,'es','You do not have enough privileges to access this resource','No tiene privilegios para acceder a este recurso',0,'0000-00-00 00:00:00'),(NULL,'es','You must select at least one agent','Debe seleccionar al menos un agente',0,'2012-09-05 08:07:31'),(NULL,'es','You must select at least one queue','Debe seleccionar al menos una cola',0,'2012-09-05 08:07:06'),(NULL,'es','admin-acl','Control de Acceso',0,'2012-09-17 20:40:15'),(NULL,'es','admin-designer','Diseñador de Reportes',0,'2012-09-17 20:40:15'),(NULL,'es','admin-language','Traducciones',0,'2012-09-17 20:40:15'),(NULL,'es','admin-license','admin-license',1,'2017-10-13 20:05:50'),(NULL,'es','admin-plugins','admin-plugins',1,'2017-10-13 20:05:50'),(NULL,'es','admin-queuegroups','admin-queuegroups',1,'2017-10-13 20:05:50'),(NULL,'es','admin-schedule','Tareas Programadas',0,'2012-09-17 20:40:15'),(NULL,'es','admin-setup','Preferencias',0,'2012-09-17 20:40:15'),(NULL,'es','admin-users','Usuarios',0,'2012-09-17 20:40:15'),(NULL,'es','agent_availability','Disponibilidad de Agentes',0,'2012-09-17 20:40:15'),(NULL,'es','agent_detail','Reporte Detallado de Agentes',0,'2012-09-17 20:40:15'),(NULL,'es','agent_dispositions','Disposición de llamados por Agente',0,'2012-09-17 20:40:15'),(NULL,'es','agent_durations','Duración de Sesión y Pausas de Agente',0,'2012-09-17 20:40:15'),(NULL,'es','agent_pauses','Detalle de Pausas',0,'2012-09-17 20:40:15'),(NULL,'es','agent_summary','Sumario de Agentes',0,'2012-09-17 20:40:15'),(NULL,'es','all month','todo el mes',0,'2012-09-13 05:37:57'),(NULL,'es','answered_calls_by_agent','Atendidas por Agente',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_by_duration','Atendidas por Duración',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_by_event','Causa de Desconexión',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_by_holdtime','Nivel de Servicio',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_by_queue','Atendidas por Cola',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_by_url','Atendidas por URL',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_detail','Detalle de Llamadas Atendidas',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_summary','Sumario de Atendidas',0,'2012-09-17 20:40:15'),(NULL,'es','answered_calls_transferred','Llamadas Transferidas',0,'2012-09-17 20:40:15'),(NULL,'es','at hour','a la hora',0,'2012-09-13 05:37:57'),(NULL,'es','at minute','en el minuto',0,'2012-09-13 05:37:57'),(NULL,'es','calls','llamadas',0,'2012-09-17 20:40:08'),(NULL,'es','day','el día',0,'2012-09-13 05:37:57'),(NULL,'es','disposition_help_ABANDON','El usuario cortó el llamado sin haber sido atendido por ningún agente.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_COMPLETEAGENT','El llamado fue atendido por el agente, quien finalmente finalizó la llamada cortando antes que el usuario.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_COMPLETECALLER','El llamado fue atendido por el agente, pero quien cortó primero la llamada fue el usuario.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_CONNECT','La llamada fue atendida por un agente.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_ENTERQUEUE','La llamada entró en la cola.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_EXITWITEMPTY','No había ningún agente disponible en la cola, por lo que el usuario fue desconectado de la misma y dirigido al siguiente paso en el plan de discado.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_EXITWITHKEY','El usuario se salió de la cola marcando un dígito de salida.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_EXITWITHTIMEOUT','El tiempo máximo de espera en cola fue alcanzado, por lo que el usuario fue desconectado de la misma y dirigido al siguiente paso en su plan de discado.',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_RINGNOANSWER','Luego de sonar el teléfono del miembro de cola por la cantidad de milisengundos del campo info1, el intento finalizó sin que el agente atendiera la llamada. Mal desempeño del agente!',0,'2012-09-11 06:46:36'),(NULL,'es','disposition_help_TRANSFER','El llamado fue conectado al agente, quien finalmente transfirió el mismo hacia otro lugar.',0,'2012-09-11 06:46:36'),(NULL,'es','distribution_by_agent','Distribución por Agente',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_agent (outbound)','Distribución por Agente (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_day','Distribución por Día',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_day (outbound)','Distribución por Día (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_day_of_week','Distribución por Día de Semana',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_day_of_week (outbound)','Distribución por Día de Semana (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_hour','Distribución por Hora',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_hour (outbound)','Distribución por Hora (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_month','Distribución por Mes',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_month (outbound)','Distribución por Mes (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_queue','Distribución por Cola',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_queue (outbound)','Distribución por Cola (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_tag (outbound)','Distribución por Etiqueta (saliente)',0,'2017-10-13 20:05:49'),(NULL,'es','distribution_by_url','Distribución por URL',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_url (outbound)','Distribución por URL (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_by_week','Distribución por Semana',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_by_week (outbound)','Distribución por Semana (saliente)',0,'2013-05-22 21:27:04'),(NULL,'es','distribution_detail','Detalles de Distribución',0,'2012-09-17 20:40:15'),(NULL,'es','distribution_summary','Sumario de Distribución',0,'2012-09-17 20:40:15'),(NULL,'es','event_help_abandon_info1','position, la posición que tenía en la cola cuando realizó el hangup',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_abandon_info2','origposition, la posición en la que entró en la cola',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_abandon_info3','waittime, el tiempo que espero en la cola',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentcallbacklogin_info1','exten@context, el interno@contexto del agente',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentcallbacklogoff_info1','exten@context, el interno@contexto utilizado por el agente',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentcallbacklogoff_info2','logintime, el tiempo que estuvo logueado',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentcallbacklogoff_info3','reason, la razón por la cual fue deslogueado, si no es un logoff normal. Ej: Autologoff, Chanunavail',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentlogin_info1','channel, el canal donde se genero el logueo',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentlogoff_info1','channel, el canal donde se origino el deslogueo',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_agentlogoff_info2','logintime, la cantidad de tiempo que el agente estuvo logueado. (en segundos)',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_completeagent_info1','holdtime, Tiempo que espero el cliente a ser atendido',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_completeagent_info2','holdtime, Duración de la llamada',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_completeagent_info3','origposition, Posición donde ingresó en que ingresó el llamado a la cola.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_completecaller_info1','holdtime, Tiempo que espero el cliente a ser atendido',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_completecaller_info2','holdtime, Duración de la llamada',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_completecaller_info3','origposition, Posición donde ingresó en que ingresó el llamado a la cola.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_connect_info1','holdtime, la cantidad de tiempo que el cliente estuvo en hold',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_connect_info2','bridgedchanneluniqueid, es el uniqueid del canal del agente que toma el llamado',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_connect_info3','Ringtime es el tiempo en que el tel&eacute;fono son&oacute; hasta ser atendido por un miembro de la cola.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_enterqueue_info1','URL configurada en la cola',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_enterqueue_info2','Identificador de Llamado (CallerID) de la persona que entró en la cola.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_enterqueue_info3','La posici&oacute;n inicial en la que entr&oacute; el llamado al entrar en la cola.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitempty_info1','position, posición de la llamada en el momento que fue rechazada',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitempty_info2','origposition, posición de la llamada cuando ingresó a la cola',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitempty_info3','waittime, tiempo de espera',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitwithkey_info1','key, tecla que presionó para salir de la cola',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitwithkey_info2','position, posición en la que se encontraba en la cola al momento de salir',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitwithtimeout_info1','La posici&oacute;n de la llamada en la cola al salir de la misma.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitwithtimeout_info2','La posici&oacute;n original de la llamada al entrar en la cola inicialmente.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_exitwithtimeout_info3','Cantidad de tiempo que una llamada esper&oacute; en la cola.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_pause_info1','Raz&oacute;n de una pausa (si existe)',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_ringnoanswer_info1','ringtime, tiempo que estuvo sonando el teléfono del agente.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_transfer_info1','extension, interno de destino',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_transfer_info2','context, contexto utilizado',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_transfer_info3','holdtime, tiempo en espera del agente hasta que se realizó la transferencia',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_transfer_info4','calltime, duración de la llamada hasta que fue transferida. ',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_transfer_info5','La posici&oacute;n que toma la llamada en el momento de la transferencia.',0,'2012-09-08 04:26:12'),(NULL,'es','event_help_unpause_info1','Raz&oacute;n de la salida de pausa (si existe)',0,'2012-09-08 04:26:12'),(NULL,'es','every day','todos los dias',0,'0000-00-00 00:00:00'),(NULL,'es','every hour','cada hora',0,'2012-09-13 05:37:57'),(NULL,'es','every minute','cada minuto',0,'2012-09-13 05:37:57'),(NULL,'es','help_text_ACTION','Define un controlador de acci&oacute;n personalizado, para que pueda llamar a sus propias funciones/programas para casos especiales. Debe crear la funci&oacute;n javascript en el archivo js/custom.js . Recibir&aacute; el valor de UNIQUEID de la llamada cuando el icono de acci&oacute;n es clickado.\r\n\r\nparametro: posici&oacute;n,imagen de icono,Tooltip\r\nvalue: javascript_function',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_ANSWERED_DISPLAY_GRID','Si una gráfica está definida en los reportes de llamadas atendidas, entonces utilizar la disposición de ancho de grilla de acuerdo a los valores especificados en la campo value. La grilla tiene 12 columnas en total. Ejemplo:<br>\r\n<br>\r\nparameter: campo agrupadogroup field\r\nvalue: 6,6',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_ANSWERED_DISPLAY_ROWS','Listado de campos separados por coma para mostrarse en los reportes de Atendidas. Los campos se definen como COLUMN_ANSWERED\r\n\r\nparametro: group field\r\nvalor: listado de campos separados por coma ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_CHART_ANSWERED','Muestra un diagrama dentro de la p&aacute;gina de Atendidas.\r\n\r\nparametro: posicion,group field,titulo\r\nvalor: campo,campo',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_CHART_DISTRIBUTION','Muestra un diagrama dentro de la p&aacute;gina de Distribuci&oacute;n.\r\n\r\nparametro: posicion,group field,titulo\r\nvalor: campo,campo',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_CHART_SERIES_COLOR','Color a utilizar en los gráficos. El parámetro es el número de posición/índice, y el valor el color en valor hexadecimal html.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_CHART_UNANSWERED','Muestra un diagrama dentro de la p&aacute;gina de Desatendidas.\r\n\r\nparametro: posicion,group field,titulo\r\nvalor: campo,campo',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_ANSWERED','Columna para mostrar dentro de los reportes de Atendidas. Puede agregar todas las columnas que usted quiera a un reporte, luego podr&aacute; limitarlas en cada grupo enumerandolas con ANSWERED_DISPLAY_ROWS.\r\n\r\nparametro: nombre columna/etiqueta\r\nvalor: variable o f&oacute;rmula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_ANSWERED_FORMAT','Formato para mostrar en el valor de la celda en los reportes de Atendidas. Utiliza las t&iacute;picas reglas de formato de printf, excepto por los valores horarios que pueden usar tambi&eacute;n \r\n{HH}, {MM}, {SS}, {mm} y {ss}\r\n\r\npar&aacute;metro: nombre de campo\r\nvalor: cadena de formato\r\n\r\nEl par&aacute;metro nombre de campo debe ser definido como el campo de par&aacute;metro en COLUMN_ANSWERED.\r\n\r\nFormato de Ejemplo:\r\n\r\nDado un valor en segundos, convertirlo a HH:MM:SS con:\r\n\r\n{HH}:{MM}:{SS} ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_DISTRIBUTION','Columna a mostrar en los reportes de Distribuci&oacute;n. Puede agregar todas las columnas que quiera a cada reporte, luego puede limitarlos filtrando en cada grupo enumerandolos en DISTRIBUTION_DISPLAY_ROWS.\r\n\r\nparametro: nombre de columna/etiqueta\r\nvalue: variable o f&oacute;rmula\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_DISTRIBUTION_FORMAT','Formato para mostrar el valor de la celda en los reportes de distribuci&oacute;n. Usa las t&iacute;picas reglas de formato de printf, excepto por los valores horarios que pueden usar\r\n{HH}, {MM}, {SS}, {mm} y {ss}\r\n\r\nparametro: nombre del campo\r\nvalor: cadena de formato\r\n\r\nEl par&aacute;metro nombre del campo debe ser definido en COLUMN_DISTRIBUTION.\r\nEjemplos de Formato:\r\n\r\nDado un valor en segundos, convertirlo a HH:MM:SS con:\r\n{HH}:{MM}:{SS} ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_REALTIME','Columna a mostrar en el sumario de la vista REALTIME. Puede agregar todas las columnas que quiera al reporte, luego puede filtrarlas en cada reporte enumerandolas en REATIME_DISPLAY_ROWS.\r\n\r\nparametro: nombre de columna/etiqueta\r\nvalor: variable o f&oacute;rmula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_REALTIME_FORMAT','Formato a utilizar para mostrar el valor de una columna en el sumario de Realtime. Usa las t&iacute;picas reglas de formato de printf, excepto por los valores horarios que puede utilizar {HH}, {MM}, {SS}, {mm} y {ss}\r\n\r\nparametro: nombre del campo\r\nvalor: cadena con el formato\r\n\r\nEl par&aacute;metro nombre del campo debe ser definido en COLUMN_REALTIME.\r\nEjemplo de Formato:\r\n\r\nDado un valor en segundos, convertirlo a HH:MM:SS con:\r\n{HH}:{MM}:{SS} ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_REALTIME_STYLE','Propiedad HTML extra para adicionar a los valores de las celdas en el sumario de REALTIME. Puede usar class o style para modificar la visualizaci&oacute;n de la celda. Ejemplo:\r\n\r\nclass=\\\"bigblue\\\"\r\nstyle=\\\"border:1px solid red;\\\" ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_UNANSWERED','Columna para ser mostrada en los reportes de Desatendidas. Puede agregar todas las columnas que desee a un reporte, luego podr&aacute; filtrarlos en cada grupo enumerandolas en UNANSWERED_DISPLAY_ROWS.\r\n\r\nparametro: nombre de columna/etiqueta\r\nvalor: variable o f&oacute;rmula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_COLUMN_UNANSWERED_FORMAT','Formato a utilizar para mostrar en las celdas de reportes de desatendidas. Usa las t&iacute;picas reglas de formato de printf, excepto por los valores de horarios que puede utilizar {HH}, {MM}, {SS}, {mm} y {ss}\r\n\r\nparametro: nombre del campo\r\nvalor: cadena de formato\r\n\r\nEl par&aacute;metro nombre de campo debe ser definido en COLUMN_UNANSWERED.\r\nEjemplo de formato:\r\n\r\nDado un valor en segundos, convertirlo a HH:MM:SS con:\r\n{HH}:{MM}:{SS} ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_DISTRIBUTION_DISPLAY_ROWS','Listado de campos separados por coma para mostrar en un reporte específico de Distribui&oaucte;n. Los campos son los definidos en COLUMN_DISTRIBUTION.\r\n\r\nparametro: group field\r\nvalor: lista de campos separados por coma',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_ABANDONED','Define los eventos de queue_log que incrementarán los contadores/variables de llamadas Abandonadas usando un listado separado por coma. Dentro de la configuraci&oacute;n est&aacute;ndar de Asterisk, esto debe ser definido como &quot;ABANDON&quot; y nada m&aacute;s.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_ANSWERED','Define los eventos de queue_log que incrementarán los contadores/variables de llamadas Atendidas en los reportes, usando un listado separado por coma. Las disposiciones usuales de llamadas atendidas dentro de la configuraci&oacute;n est&aacute;ndar de Asterisk son COMPLETECALLER y COMPLETEAGENT. Podría también incluirse la disposición TRANSFER. Pero tenga en cuenta que las transferencias disponen de su propio evento/variable por si desea reportearlas de forma separada.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_LOGIN','Define los eventos de queue_log que incrementarán los contadores/variables de ingreso de agentes en los reportes, usando un listado separado por coma. En una configuración normal de Asterisk dichos eventos son AGENTLOGIN y ADDMEMBER. Versiones antiguas de Asterisk podrían incluir AGENTCALLBACKLOGIN.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_LOGOUT','Define los eventos de queue_log que incrementarán los contadores/variables de egreso/desconexión de agentes en los reportes, usando un listado separado por coma. En una configuración normal de Asterisk dichos eventos son AGENTLOGOFF y REMOVEMEMBER.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_RECEIVED','Define los eventos de queue_log que incrementarán los contadores/variables de llamadas Recibidas usando un listado separado por coma. Todas las disposiciones que figuren en el queue_log que deban sumar como llamada recibida, tanto atendida como no, deberán ser listadas aquí, por ejemplo:<br/><br/>\r\nCOMPLETECALLER,COMPLETEAGENT,ABANDON,EXITEMPTY,EXITWITHKEY,EXITWITHTIMEOUT,TRANSFER',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_TRANSFERRED','Define los eventos de queue_log que incrementarán los contadores/variables de llamadas Transferidas usando un listado separado por coma. En instalaciones normales, el único evento a listar es TRANSFER',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_EVENT_UNANSWERED','Define los eventos de queue_log que incrementarán los contadores/variables de llamadas No Atendidas usando un listado separado por coma. A diferencia de un Abandono, done el llamado no es atendido porque el llamante corta la llamada antes de ser atendido por un agente, las disposiciones de No Atendidas listan las razones por las cuales un llamado puede salirse de la espera en cola por otros motivos, como ser tiempo máximo de espera, salida por pulsación de tecla, etc. Los eventos usuales son: EXITWITHKEY,EXITEMPTY,EXITWITHTIMEOUT',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_REALTIME_COLUMN_WIDTHS','Lista separada por comas del ancho de columnas para reportes de tiempo real, el parametro especifica el reporte, por ejemplo &#39;agent&#39;',0,'0000-00-00 00:00:00'),(NULL,'es','help_text_REALTIME_DISPLAY_ROWS','Lista separada por comas de los campos a mostrar en la tabla de sumario de tiempo real. Los campos posibles son los definidos en COLUMN_REALTIME.<br/>\r\n<br/>\r\nparameter: campo agrupado<br/>\r\nvalue: lista de campos separados por coma',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_TOTAL_COLUMN_ANSWERED','Formula a usar para la fila Total en los reportes de llamados Atendidos.<br/>\r\n<br/>\r\nparameter: campo<br/>\r\nvalue: formula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_TOTAL_COLUMN_DISTRIBUTION','Formula a usar para la fila Total en los reportes de Distribución.<br/>\r\n<br/>\r\nparameter: campo<br/>\r\nvalue: formula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_TOTAL_COLUMN_REALTIME','Formula a usar para la fila Total en los reportes de Tiempo Real.<br/>\r\n<br/>\r\nparameter: campo<br/>\r\nvalue: formula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_TOTAL_COLUMN_UNANSWERED','Formula a usar para la fila Total en los reportes de llamados No Atendidos.<br/>\r\n<br/>\r\nparameter: campo<br/>\r\nvalue: formula',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_UNANSWERED_DISPLAY_GRID','Si una gráfica está definida en los reportes de llamadas no atendidas, entonces utilizar la disposición de ancho de grilla de acuerdo a los valores especificados en la campo value. La grilla tiene 12 columnas en total. Ejemplo:<br>\r\n<br>\r\nparameter: campo agrupadogroup field\r\nvalue: 6,6',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_UNANSWERED_DISPLAY_ROWS','Listado de campos separados por coma para mostrarse en los reportes de No Atendidas. Los campos se definen como COLUMN_UNANSWERED<br><br>\r\n\r\nparametro: group field\r\nvalor: listado de campos separados por coma ',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_agent_filter','Expresión regular para filtrar aquellos Agents que no queremos visualizar en la selección inicial.<br/><br/>Ejemplo: <strong>Agent/[0-9][0-9][0-9][0-9]$</strong>\r\n',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_agent_reports','Lista separada por comas de los reportes a mostrar en la solapa de Agente. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_agent_row_color','Para rellenar el fondo de la celda del Agente con su color de estado en la vista TiempoReal, activar con 1',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_answered_reports','Lista separada por comas de los reportes a mostrar en la solapa de Atendidos. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_asterisk_12','Si utiliza Asterisk 1.2.X ponga este valor en 1 para que funcione la solapa &quot;Estado Actual&quot;',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_asterisk_16','Ponga este valor en 1 si utiliza Asterisk 1.6 para que la vista de Estado Actual funcione correctamente.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_asterisk_18','Ponga este valor en 1 si utiliza Asterisk 1.8 para que la vista de Estado Actual funcione correctamente.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_avg_time_format','Formato para campos de promedio de duración. HH = horas, MM=minutos, SS=segundos, mm=minutos absolutos, ss=segundos absolutos. Utilizado en reportes de información detallados y drill down.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_call_flow','Configure este parámetro por cada cola con valor \\\'outbound\\\' para marcar la cola como saliente, de manera de tener reportes separados de distribución para los mismos.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_call_time_format','Formato para campos de  duración de llamada. HH = horas, MM=minutos, SS=segundos, mm=minutos absolutos, ss=segundos absolutos. Utilizado en reportes de información detallados y drill down.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_csv_separator','Caracter separador para archivos separados por coma (CSV). El valor por defecto es una coma (,) para Excel o similares. Si utiliza OpenOffice puede requerir cambiar este parámetro por un punto y coma (;)',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_custom_reports','Lista separada por comas de los reportes a mostrar en una solapa personalizada en el menú. El parámetro es el nombre de solapa a utilizar. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_date_format','Formato para los campos de fecha, en sintaxis Mysql:\r\n\r\nEjemplo: %%m-%%d-%%Y %%H:%%i:%%s',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_decimal_places','Cantidad de posiciones decimales a mostrar al redondear números decimales. El valor por omisión es dos.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_default_end_hour','Hora inicial para mostrar en la seleccion de fecha/hora, en formato HH:MM.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_default_start_hour','Hora final para mostrar en la seleccion de fecha/hora, en formato HH:MM.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_detailed_agent_report','Muestra el reporte detallado de actividad de agentes en la solapa de Agente (similar a la información obtenida durante un drill down, pero aplicado a todos los agentes para el rango completo de fechas seleccionado).',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_dict_agent','Entrada de diccionario para numero de agente.  En parámetro debe poner el nombre de agente tal como lo ve originalmente en los reportes, y en valor complete el nombre que desee que aparezca en su lugar.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_dict_queue','Entrada de diccionario para nombre de colas. De esta manera podrá cambiar el nombre de una cola por otro. En parámetro debe poner el nombre de cola tal como lo ve originalmente en los reportes, y en valor complete el nombre que desee que aparezca en su lugar.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_distribution_interval','Intervalo de tiempo en minutos para separar las tablas de distribución de llamados por hora. El valor por omisión es de 60 minutos, pero puede elegir intervalos menores.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_distribution_reports','Lista separada por comas de los reportes a mostrar en la solapa de Distribución. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_drilldown_records_per_page','Numero de registros por pagina en los listados drill down. El valor por omisión es 10.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_first_page','Página inicial a cargar (Ej: answered.php, unanswered.php, distribution.php).',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_freepbx_device_user_mode','Configure este valor en 1 si utiliza freepbx en modo user&device',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_hide_parsed_time','Ocultar el tiempo de generación de página en el pie de los reportes.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_honor_timeframe_in_agent','Honrar seleccion de horario en reportes de Agente. Tambien intenta computar eventos faltantes. (Por ejemplo, si en la selección de horario en la solapa inicial se pide un reporte de 11 a 16 horas, los reportes de agente computaran un fin de sesión a las 16 hs si no existe un evento de fin de sesión registrado).',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_ignore_none_abandons','Si no desea contar las llamadas abadonadas entrantes cuando selecciona un reporte sobre una lista parcial de agentes debe poner este seteo en uno. Esto es util cuando se reporta sobre llamados salientes y determinar la performance de cada agente, ya que los abandons entrantes son filtrados debido a que no se puede computar un abandono entrante a ningun agente en particular. Si al ejecutar un reporte se seleccionan todos los agentes disponibles, esto incluira tambien el agente NONE por lo que los abandonos entrantes se contaran incluso si esta configuracion esta puesta en uno.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_language','Idioma a usar. Si el parámetro se deja en blanco, se aplicará globalmente. En caso de que el parámetro sea el nombre de un usuario, entonces el idioma se aplicará solamente a ese usuario.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_alert_subject','Asunto de mensaje a utilizar para los envios de alertas por mail',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_mail_from_email','Alertas y Reportes programados, definir un email de remitente para los mails que se originan el servidor.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_from_name','Alertas y Reportes programados, definir un nombre de remitente para los mails que se originan el servidor.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_header_image','Imagen a usar como encabezado en los reportes y alertas por email',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_report_subject','Asunto de mensaje a utilizar para los envios de reportes por mail',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_mail_smtp_password','Alertas y Reportes programados, configure la clave del servidor smtp para el env&iacute;o de correos.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_smtp_server','Alertas y Reportes programados, definir un servidor SMTP que se utilizará para enviar correos. Para el protocolo SSL: ssl://smtp.servidor.com , para TLS: tls://smtp.servidor.com , sin encriptaci&oacute;n : smtp.servidor.com',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_smtp_server_port','Alertas y Reportes programados, defina el puerto del servidor SMTP.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_mail_smtp_username','Alertas y Reportes programados, configure el nombre de usuario para autenticarse al servidor SMTP para enviar correos electr&oacute;nicos.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_pbxware','Ponga este valor en 1 si utiliza PBXWare para que la vista  de Estado Actual funcione correctamente.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_realtime_agent_sort','Ponga este valor en \\\'status\\\' para que la vista de Estado Actual ordene los agentes por su estado, mostrando a los que estén en llamado primero. De lo contrario el orden se hace por penalidad.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_realtime_alarm_call_duration','Alarma de duración de llamada activada por segundos para la vista en TiempoReal. Puede definirse por cola configurando el parámetro al nombre de la cola.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_alarm_last_call','Alarma (en segundos) para tiempo desde el último llamado recibido de cola en la vista de estado actual. Puede configurarse un valor independiente por cola poniendo el nombre de cola como parámetro.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_alarm_pause_duration','Alarma (en segundos) para la duración de pausa en la vista de estado actual. Puede configurarse un valor independiente por cola poniendo el nombre de cola como parámetro.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_alarm_row_color','Color de fondo de una fila cuando algún valor está en alarma.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_alarm_threshold','Umbral (en porcentual) a partir del cual empezar a colorear los registros en alarma.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_alarm_wait_count','Alarma (en cantidad de llamados) para los llamados esperando en una cola.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_alarm_wait_duration','Alarma de llamada en espera en la vista en TiempoReal definiendo su duración. Puede asignarse a una cola definiendo el nombre de la cola en el parámetro.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_coach_options','Opciones de chanspy para pasar a la acción de Entrenamiento, usualmente se utiliza la opción &quot;w&quot; para habilitar whisper. También podría utilizarse &quot;d&quot; en Asterisk 1.8 o superior para habilitar modo selectivo por DTMF, digitando 4 para spy, 5 para whisper y 6 para barge.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_custom_pauses','Si el valor se pone en 1, la pagina realtime consultara ASTDB por la familia PAUSECUSTOM/Agent y mostrara el tipo de pausa para el agente guardado en el key. Ej: PAUSECUSTOM/Agent/1000 = Break:${EPOCH} guardado en ASTDB mostrara al Agente 1000 con tipo de pausa Break.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_group_queues','Agrupar Colas en la vista de &quot;Estado Actual&quot;',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_hide_loggedoff','Ocultar Agentes Deslogueados en la vista de &quot;Estado Actual&quot;',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_last_hour_stats','Configure esta opción para que la vista de Estado Actual solo muestre la última hora en las estadísticas de llamados recibidos/abandonados.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_realtime_refresh','Tiempo en segundos para refresco de la vista de &quot;Estado Actual&quote;. El valor por defecto es de 5 segundos.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_refresh_sql','Tiempo en segundos para refresco de datos estadísticos (atendidas,abandonadas,etc) para la tabla de sumario de colas en la vista de &quot;Estado Actual&quot;. El valor por defecto es de 60 segundos. Esta consulta consume mucho procesador, es recomendado dejar este valor en 60 segundos o incluso subirlo un poco más si hay muchos supervisores revisando la vista simultáneamente.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_reports','Lista separada por comas de los reportes a mostrar en la solapa de Tiempo Real. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_realtime_spy_device','Canal o Dispositivo del usuario utilizado para las escuchas, debe ponerse como parámetro el nombre del usuario y como valor el canal completo. Ej: SIP/1234',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_spy_extension','Extensión utilizada por el usuario (configurado como parámetro) para recibir un llamado capturado. Puede incluirse también el contexto de dialplan separandolo con una arroba. \n\nEj: 100@from-internal',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_spy_options','Opciones para pasar a chanspy cuando se incia una escucha de llamada. Algunas opciones posibles son: &quot;E&quot; para que finalice la escucha cuando se corta la llamada, &quot;q&quot; para silenciar el beep al inicio de la escucha, etc.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_strict_interface_status','Si utiliza la opción STATE_INTERFACE cuando utilice AddQueueMemeber la cola podrá informar del estado de agentes de tipo Local sin inconsistencias. En ese caso, debe poner esta valor en 1 para que el estado de agentes en la vista actual se base exclusivamente en la información de la aplicación de cola.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_realtime_tracking_mode','Habilite tracking mode para que las escuchas lanzadas desde Estado Actual siguen activas aunque finalice el llamado del agente.',0,'2015-01-07 22:37:29'),(NULL,'es','help_text_recordings_path','Directorio de grabaciones en el disco duro para descarga directa.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_session_time_format','Formato para campos de tiempo de sesión. HH = horas, MM=minutos, SS=segundos, mm=minutos absolutos, ss=segundos absolutos. Utilizado en reportes de información detallados y drill down.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_setup_reports','Lista separada por comas de los reportes a mostrar en el menú de Configuración. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_shared_lastcall','Compartir la información de último llamado entre colas. Sólo se mostrará el tiempo más corto para todas las colas. Si se utiliza rastreo de salientes y se guarda el valor astdb LASTCALL, será también tomado en cuenta.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_short_abandon_threshold','Tiempo mínimo que una llamada debe tener (en segundos) para que sea considerada entre las llamadas abandonadas. Si se especifica como parámetro el nombre de una cola, entonces se aplicará para esa cola solamente.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_short_unanswered_threshold','Tiempo mínimo que una llamada debe tener (en segundos) para que sea considerada entre las llamadas no atendidas. Si se especifica como parámetro el nombre de una cola, entonces se aplicará para esa cola solamente.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_show_agent_call','Mostrar eventos de llamado cuando se expanden reportes de Agente',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_show_agent_field','Mostrar columna de Agente en reportes de no atendidos (util cuando se rastrean llamados salientes)',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_show_url_field','Mostrar columna de URL en los reportes de llamados atentidos',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_sla_abandoned','Tiempo SLA en segundos para llamadas Abandonadas.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_sla_answered','Tiempo SLA en segundos para llamadas Atendidas.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_sla_interval','Intervalo de tiempo en segundos para separar los reportes de Nivel de Servicio en Atendidas y No Atendidas.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_sla_steps','Número de filas a mostrar en los reportes de Nivel de Servicio en Atendidas y No Atendidas.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_sla_transferred','Tiempo SLA en segundos para llamadas Transferidas.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_sla_unanswered','Tiempo SLA en segundos para llamadas No Atendidas (no incluye las Abandonadas sino las no atendidas por otras razones, como ser Tiempo Expirado, Salida por tecla, etc).',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_timeframe_interval','Intervalo en minutos para presentar en la selección de horarios en la solapa de Inicio. El valor por omisión es de 15 minutos.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_timezone','Configurar la zona horaria para el usuario, en formato [+-]HH:MM\r\n\r\nSi pone un nombre de usuario como parámetro, la configuración se aplicará solamente para ese usuario. Si el parámetro se deja en blanco la configuración será global.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_unanswered_reports','Lista separada por comas de los reportes a mostrar en la solapa de No Atendidas. Debe especificar el listado correcto de archivos .php para mostrar en cada elemento/sección.\r\n',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ABANDONED','Número de llamados abandonados (con la disposici&oacute;n EVENT_ABANDON en queue_log)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ABANDONED_SLA','N&uacute;mero de llamadas abandonadas (con la disposici&oacute;n EVENT_ABANDON en queue_log) en el que el tiempo de espera es menor o igual que los seteos de preferencias de sla_abandoned.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ABANDONED_WAIT_TIME','Tiempo de espera para llamadas abandonadas por un reporte agrupado particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AGENTS_LOGGED_OFF','N&uacute;mero de agentes en estado Logged Off. S&oacute;lo disponible en las f&oacute;rmulas de COLUMN_REALTIME.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AGENTS_PAUSED','N&uacute;mero de agentes pausados. S&oacute;lo disponible en formulas de COLUMN_REALTIME',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AGENTS_STAFFED','N&uacute;mero de agentes disponibles (Logged In). S&oacute;lo disponible en formulas de COLUMN_REALTIME.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AGENTS_TALKING','N&uacute;mero de agentes con una llamada establecida. S&oacute;lo disponible en f&oacute;rmulas de COLUMN_REALTIME.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ANSWERED','N&uacute;mero de llamadas atendidas (con disposici&oacute;n EVENT_ANSWERED en el queue_log) para el reporte agrupado en particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ANSWERED_SLA','N&uacute;mero de llamadas atendidas (con la disposici&oacute;n en EVENT_ANSWERED en queue_log) cuyo tiempo de espera fue menor o igual que el seteo en preferencias del sla_answered',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ANSWERED_TALK_TIME','Tiempo de conversaci&oacute;n de llamadas atendidas para un reporte agrupado en particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ANSWERED_WAIT_TIME','Wait Time of Answered Calls for the particular grouped report. (Wait Time is the time an user was waiting on the queue before being connected to an agent, it only counts the time since the queue was entered, it does not count potential previous times like IVRs, etc.)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ABANDONED','Promedio de llamadas abandonadas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ABANDONED_SLA','Promedio de llamadas abandonadas que han esperado menos o igual tiempo que el definido en preferencias en abandonen_sla.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ABANDONED_WAIT_TIME','Promedio de tiempo de espera para llamadas abandonadas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ANSWERED','Promedio de llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ANSWERED_SLA','Promedio de llamadas atendidas que han esperado menos o igual que lo definido en segundos en las preferencias en answered_sla.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ANSWERED_TALK_TIME','Promedio de tiempo de conversaci&oacute;n para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_ANSWERED_WAIT_TIME','Promedio the tiempo de espera para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_LOGIN','Promedio de agentes logueados',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_LOGOUT','Promerdio de agentes desloagueados.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_RECEIVED','Promedio de llamadas recibidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_TRANSFERRED','Promedio de llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_TRANSFERRED_SLA','Promedio de llamadas transferidas que han esperado menos o iguales segundos que los definidos en preferencias en transferred_sla',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_TRANSFERRED_TALK_TIME','Promedio de tiempo de conversaci&oacute;n de llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_TRANSFERRED_WAIT_TIME','Promedio de tiempo de espera para llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_UNANSWERED','Promedio de llamadas no atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_UNANSWERED_SLA','Promedio de llamadas no atendidas que han esperado menos o iguales segundos a los definidos en las preferencias en unanswered_sla.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_AVG_UNANSWERED_WAIT_TIME','Promedio de tiempo de espera para llamadas no atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_CALLS_WAITING','N&uacute;mero de llamadas esperando. S&oacute;lo disponible en f&oacute;rmulas de COLUMN_REALTIME',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_LOGIN','Number of Agent Logins.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_LOGOUT','Number of Agent Logoffs.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_ABANDONED_WAIT_TIME','Tiempo de espera m&aacute;ximo para llamadas abandonadas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_ANSWERED_TALK_TIME','Tiempo m&aacute;ximo de conversaci&oacute;n para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_ANSWERED_WAIT_TIME','Tiempo de espera m&aacute;ximo para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_CALLERS_WAITING','N&uacute;mero de llamantes m&aacute;ximo esperando en una cola.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_COL','Maximum value for the column, to be used in TOTAL formulas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_TRANSFERRED_TALK_TIME','Tiempo de conversaci&oacute;n m&aacute;ximo para llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_TRANSFERRED_WAIT_TIME','Tiempo de espera m&aacute;ximo para llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_UNANSWERED_WAIT_TIME','Maximum Wait Time for Unanswered Calls.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MAX_WAIT_TIME','Tiempo de espera m&aacute;ximo para un reporte agrupado particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_ABANDONED_WAIT_TIME','Tiempo de espera m&iacute;nimo en llamadas abandonadas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_ANSWERED_TALK_TIME','Tiempo de conversaci&oacute;n m&iacute;nimo para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_ANSWERED_WAIT_TIME','Tiempo de espera m&iacute;nimo para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_COL','Valor m&iacute;nimo para la columna para ser usado en f&oacute;rmulas de TOTAL.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_TRANSFERRED_TALK_TIME','Tiempo mínimo al habla de llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_TRANSFERRED_WAIT_TIME','Tiempo mínimo de espera en llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_MIN_UNANSWERED_WAIT_TIME','Tiempo mínimo de espera en llamadas no atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_RECEIVED','Número de llamadas recibidas (con disposición enumerada en EVENT_RECEIVED) para el reporte agrupado en particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_ROW_COUNT','N&uacute;mero de filas en el reporte. Para ser usado en f&oacute;rmulas en TOTAL.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ABANDONED','Suma de llamadas abandonadas para una fila en particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ABANDONED_SLA','Sum of Abandoned calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_abandoned seconds as set in Preferences.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ABANDONED_WAIT_TIME','Suma de tiempo de espera de llamadas abandonadas para una fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ANSWERED','Suma de llamadas atendidas de una fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ANSWERED_SLA','Suma de llamadas atendidas de una fila particular en un reporte, cuyo tiempo de espera es menor o igual que el seteo en las preferencias de sla_answered (segundos)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ANSWERED_TALK_TIME','Suma de tiempo de conversaci&oacute;n para llamadas atendidas de una fila en particular dentro de un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_ANSWERED_WAIT_TIME','Suma del tiempo de espera para llamadas atendidas de una fila particular de un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_COL','Suma de todos los valores para una columna en particular. Para ser usado en f&oacute;rmulas TOTAL.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_LOGIN','Suma de los eventos de Login para una fila en particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_LOGOUT','Suma de los eventos de Logoff para una fila en particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_RECEIVED','Suma de las llamadas recibidas para una fila en particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_TRANSFERRED','Suma de las llamadas transferidas para una fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_TRANSFERRED_SLA','Suma de llamadas transferidas para una fila particular en un reporte, cuyo tiempo de espera es menor o igual que lo definido en las preferencias en sla_transferred (segundos)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_TRANSFERRED_TALK_TIME','Suma del tiempo de conversaci&oacute;n para llamadas transferidas para una fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_TRANSFERRED_WAIT_TIME','Suma del tiempo de espera para llamadas transferidas de una fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_UNANSWERED','Suma de las llamadas no atendidas para la fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_UNANSWERED_SLA','Suma de las llamadas no atendidas para una fila particular en un reporte, cuyo tiempo de espera es menor o igual al definido en preferencias en transferred_sla (segundos)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_SUM_UNANSWERED_WAIT_TIME','Suma del tiempo de espera para llamadas transferidas para una fila particular en un reporte.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ABANDONED','Total de llamadas abandonadas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ABANDONED_SLA','Total de llamadas abandonadas cuyo tiempo de espera es menor o igual que el definido en preferencias en abandoned_sla.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ABANDONED_WAIT_TIME','Tiempo de espera total para llamadas abandonadas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ANSWERED','Total de llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ANSWERED_SLA','Total de llamadas atendidas cuyo tiempo de espera es menor o igual que lo definido en preferencias en answered_sla (segundos)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ANSWERED_TALK_TIME','Tiempo de conversaci&oacute;n total para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_ANSWERED_WAIT_TIME','Tiempo de espera total para llamadas atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_LOGIN','Total de eventos Login.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_LOGOUT','Total de eventos Logoff',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_RECEIVED','Total de llamadas recibidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_TRANSFERRED','Total de llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_TRANSFERRED_SLA','Total de llamadas transferidas que cuyo tiempo de espera es menor o igual al definido en preferencias en transferred_sla (segundos)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_TRANSFERRED_TALK_TIME','Tiempo de conversaci&oacute;n total para llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_TRANSFERRED_WAIT_TIME','Tiempo de espera total para llamadas transferidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_UNANSWERED','Total de llamadas no atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_UNANSWERED_SLA','Total de llamadas no atendidas cuyo tiempo de espera es menor o igual al definido en preferencias en unanswered_sla',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TOTAL_UNANSWERED_WAIT_TIME','Tiempo de espera total para la totalidad de llamadas no atendidas.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TRANSFERRED','Cantidad de llamadas transferidas (con disposici&oacute;n EVENT_TRANSFERRED en queue_log)',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TRANSFERRED_SLA','Cantidad de llamadas transferidas (con disposición EVENT_TRANSFERRED en queue_log) cuyo tiempo de espera es menor o igual que el definido en preferencias en transferred_sla',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TRANSFERRED_TALK_TIME','Tiempo de conversaci&oacute;n para llamadas transferidas en una fila en particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_TRANSFERRED_WAIT_TIME','Tiempo de espera para llamadas transferidas para la fila en particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_UNANSWERED','Cantidad de llamadas no atendidas (con disposici&oacute;n EVENT_UNANSWERED en el queue_log) para el reporte agrupado particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_UNANSWERED_SLA','Cantidad de llamadas no atendidas (con disposici&oacute;n EVENT_UNANSWERED en queue_log) cuyo tiempo de espera es menor o igual que el definido en preferencias en sla_unanswered.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_variable_UNANSWERED_WAIT_TIME','Tiempo de espera para llamadas no atendidas en la fila particular.',0,'2012-09-08 04:21:56'),(NULL,'es','help_text_wait_time_format','Formato para campos de tiempo en espera. HH = horas, MM=minutos, SS=segundos, mm=minutos absolutos, ss=segundos absolutos. Utilizado en reportes de información detallados y drill down.',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_week_mode','Cuándo empezar a contar semanas en el año:\n<pre>\nModo    1er día de semana       Rango   Semana 1 es la primer semana ...\n0       Domingo                 0-53    con un Domingo en el año\n1       Lunes                   0-53    con más de 3 días en el año\n2       Domingo                 1-53    con un domingo en el año\n3       Lunes                   1-53    con más de 3 días este año\n4       Domingo                 0-53    con más de 3 días este año\n5       Lunes                   0-53    con un Lunes en el año\n6       Domingo                 1-53    con más de 3 días este año\n7       Lunes                   1-53    con un Lunes en el año\n</pre>',0,'2012-09-13 05:12:22'),(NULL,'es','help_text_wrap_up','Este seteo permite especificar un tiempo de \\\'wrap up\\\' ya sea global o por cola. Este tiempo afectará el valor de AHT (Average Handling Time) en los reportes que incluyen esa métrica.',0,'2015-01-07 22:37:29'),(NULL,'es','hours','horas',0,'2012-09-17 20:40:02'),(NULL,'es','info1','Info 1',0,'2012-09-08 04:26:12'),(NULL,'es','info2','Info 2',0,'2012-09-08 04:26:12'),(NULL,'es','info3','Info 3',0,'2012-09-08 04:26:12'),(NULL,'es','info4','Info 4',0,'2012-09-08 04:26:12'),(NULL,'es','info5','Info 5',0,'2012-09-08 04:26:12'),(NULL,'es','none','ninguno',0,'0000-00-00 00:00:00'),(NULL,'es','of','de',0,'2012-09-13 05:37:57'),(NULL,'es','on %s since %s seconds ago','en %s desde hace %s segundos',0,'0000-00-00 00:00:00'),(NULL,'es','on %s since %s secs ago','en %s hace %s segundos',0,'2012-09-05 04:37:44'),(NULL,'es','on days','los días',0,'2012-09-13 05:37:57'),(NULL,'es','on hours','en las horas',0,'2012-09-13 05:37:57'),(NULL,'es','on minutes','en los minutos',0,'2012-09-13 05:37:57'),(NULL,'es','partial','parcial',0,'2012-09-07 00:26:33'),(NULL,'es','realtime-agent-busy','Ocupado',0,'0000-00-00 00:00:00'),(NULL,'es','realtime-agent-dialout','Llamada Saliente',0,'0000-00-00 00:00:00'),(NULL,'es','realtime-agent-hold','Retenido',0,'0000-00-00 00:00:00'),(NULL,'es','realtime-agent-not in use','Libre',0,'2012-09-17 20:41:28'),(NULL,'es','realtime-agent-ringing','Ringing',0,'0000-00-00 00:00:00'),(NULL,'es','realtime-agent-unavailable','No Disponible',0,'0000-00-00 00:00:00'),(NULL,'es','realtime_queue_summary','Sumario de Colas',0,'2012-09-17 20:41:28'),(NULL,'es','seconds','segundos',0,'0000-00-00 00:00:00'),(NULL,'es','unanswered_calls_by_event','Causa de Desconexión',0,'2012-09-17 20:40:15'),(NULL,'es','unanswered_calls_by_holdtime','Nivel de Servicio',0,'2012-09-17 20:40:15'),(NULL,'es','unanswered_calls_by_queue','No Atendidas por Cola',0,'2012-09-17 20:40:15'),(NULL,'es','unanswered_calls_by_url','No Atendidas por URL',0,'2012-09-17 20:40:15'),(NULL,'es','unanswered_calls_detail','Detalle de Llamadas No Atendidas',0,'2012-09-17 20:40:15'),(NULL,'es','unanswered_calls_summary','Sumario de No Atendidas',0,'2012-09-17 20:40:15'),(NULL,'es','within','dentro de',0,'0000-00-00 00:00:00'),(NULL,'es','within %d%s seconds','dentro de %d%s segundos',0,'2012-09-08 04:26:34');

INSERT INTO `language` VALUES (NULL,'fr','%','%',0,'0000-00-00 00:00:00'),(NULL,'fr','%%','%%',0,'0000-00-00 00:00:00'),(NULL,'fr','%% Answ','%% Rép',0,'0000-00-00 00:00:00'),(NULL,'fr','%% Calls','%% Appel',0,'0000-00-00 00:00:00'),(NULL,'fr','%% Paused','%% En pause',0,'0000-00-00 00:00:00'),(NULL,'fr','%% Session','%% Session',0,'0000-00-00 00:00:00'),(NULL,'fr','%% Talk Time','%% Temps de paroles',0,'0000-00-00 00:00:00'),(NULL,'fr','%% Unansw','%% Non Rép',0,'0000-00-00 00:00:00'),(NULL,'fr','%s','%s',0,'0000-00-00 00:00:00'),(NULL,'fr','%s %%','%s %%',0,'0000-00-00 00:00:00'),(NULL,'fr','%s days','%s jours',0,'0000-00-00 00:00:00'),(NULL,'fr','%s min. ago','%s min. ago',0,'0000-00-00 00:00:00'),(NULL,'fr','%s minutes','%s min',0,'0000-00-00 00:00:00'),(NULL,'fr','%s records deleted','%s enregistrements supprimés',0,'0000-00-00 00:00:00'),(NULL,'fr','%s secs','%s secs',0,'0000-00-00 00:00:00'),(NULL,'fr','ABANDON','Abandonné',0,'0000-00-00 00:00:00'),(NULL,'fr','AHT','AHT',0,'0000-00-00 00:00:00'),(NULL,'fr','ALL','TOUT',0,'0000-00-00 00:00:00'),(NULL,'fr','Abandon Avg Queue Position at Disconnection','Abandon de la position de la file d\'attente à la déconnexion',0,'0000-00-00 00:00:00'),(NULL,'fr','Abandon Avg Queue Start Position','Abandon Moyen de la position de départ dans la file',0,'0000-00-00 00:00:00'),(NULL,'fr','Abandon Avg Wait Before Disconnection','Abandon attente moyenne avant déconnexion',0,'0000-00-00 00:00:00'),(NULL,'fr','Abandon Rate','Taux d\'abandon',0,'0000-00-00 00:00:00'),(NULL,'fr','Abandoned','Abandonné',0,'0000-00-00 00:00:00'),(NULL,'fr','Abandoned Calls','Appels abandonnés',0,'0000-00-00 00:00:00'),(NULL,'fr','Action','Action',0,'0000-00-00 00:00:00'),(NULL,'fr','Actions','Actions',0,'0000-00-00 00:00:00'),(NULL,'fr','Active','Actif',0,'0000-00-00 00:00:00'),(NULL,'fr','Add','Ajouter',0,'0000-00-00 00:00:00'),(NULL,'fr','Add Record','Ajouter un enregistrement',0,'0000-00-00 00:00:00'),(NULL,'fr','Agent','Agent',0,'0000-00-00 00:00:00'),(NULL,'fr','Agent Status','Statut Agent',0,'0000-00-00 00:00:00'),(NULL,'fr','Agent Totals','Totaux Agent',0,'0000-00-00 00:00:00'),(NULL,'fr','Agents','Agents',0,'0000-00-00 00:00:00'),(NULL,'fr','Alert','Alerte',0,'0000-00-00 00:00:00'),(NULL,'fr','Alerts','Alertes',0,'0000-00-00 00:00:00'),(NULL,'fr','All','Tout',0,'0000-00-00 00:00:00'),(NULL,'fr','All %s records are selected.','Tous %s enregistrements sélectionnés.',0,'0000-00-00 00:00:00'),(NULL,'fr','All %s records on this page are selected.','Tous %s enregistrements sur cette page sont sélectionnés.',0,'0000-00-00 00:00:00'),(NULL,'fr','An error has occurred','Une erreur est survenue',0,'0000-00-00 00:00:00'),(NULL,'fr','Answer','Répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Answered','Répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Answered Calls','Appels répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Answered by Day','Répondu par Jour',0,'0000-00-00 00:00:00'),(NULL,'fr','Answered/Abandoned','Répondu/Abandonné',0,'0000-00-00 00:00:00'),(NULL,'fr','Answered/Abandoned per Hour','Répondu/Abandonné par heure',0,'0000-00-00 00:00:00'),(NULL,'fr','April','Avril',0,'0000-00-00 00:00:00'),(NULL,'fr','Are you sure?','Êtes-vous sûr?',0,'0000-00-00 00:00:00'),(NULL,'fr','August','Août',0,'0000-00-00 00:00:00'),(NULL,'fr','Available','Disponible',0,'0000-00-00 00:00:00'),(NULL,'fr','Available Keywords','Mots-clés disponibles',0,'0000-00-00 00:00:00'),(NULL,'fr','Available Variables','Variables disponibles',0,'0000-00-00 00:00:00'),(NULL,'fr','Average Duration by Day','Durée moyenne par jour',0,'0000-00-00 00:00:00'),(NULL,'fr','Average Session Time','Temps moyen de session',0,'0000-00-00 00:00:00'),(NULL,'fr','Average Wait Time by Day','Temps d attente moyen par jour',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg Duration','Durée moyenne',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg Talk','Conversation moyenne',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg Talk Time','Temps de conversation moyen',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg Wait','Attente moyenne',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg Wait Time','Temps d\'attente moyen',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg. Paused','Moy. Pause',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg. Session','Moy. Session',0,'0000-00-00 00:00:00'),(NULL,'fr','Avg. Session Time','Moy. Temps session',0,'0000-00-00 00:00:00'),(NULL,'fr','Back','Retour',0,'0000-00-00 00:00:00'),(NULL,'fr','Bad username or password','Nom d\'utilisateur ou mot de passe incorrect',0,'0000-00-00 00:00:00'),(NULL,'fr','Busy','Occupé',0,'0000-00-00 00:00:00'),(NULL,'fr','Buy','Acheter',0,'0000-00-00 00:00:00'),(NULL,'fr','COMPLETEAGENT','Terminé par l agent',0,'0000-00-00 00:00:00'),(NULL,'fr','COMPLETECALLER','Terminé par l appelant',0,'0000-00-00 00:00:00'),(NULL,'fr','Caller ID','Numéro Appelant',0,'0000-00-00 00:00:00'),(NULL,'fr','Calls','Appels',0,'0000-00-00 00:00:00'),(NULL,'fr','Calls Waiting Detail','Détail Appels en attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Campaigns','Campagnes',0,'0000-00-00 00:00:00'),(NULL,'fr','Cancel','Annuler',0,'0000-00-00 00:00:00'),(NULL,'fr','Cancelled','Annulé',0,'0000-00-00 00:00:00'),(NULL,'fr','Cannot connect to the Asterisk Manager. Check your credentials in config.php','Impossible de se connecter au gestionnaire Asterisk. Vérifier les identifiants dans config.php  ',0,'0000-00-00 00:00:00'),(NULL,'fr','Cannot steal call. realtime_spy_extension for user <b>%s</b> is not defined in Setup/Preferences.','Ne peut pas prendre l\'appel. realtime_spy_extension pour l\'utilisateur <b>%s</b> n\'est pas définit dans les préférences.',0,'0000-00-00 00:00:00'),(NULL,'fr','Clear Selection','Effacer Sélection',0,'0000-00-00 00:00:00'),(NULL,'fr','Click to add text','Cliquez pour ajouter du texte',0,'0000-00-00 00:00:00'),(NULL,'fr','Click to edit...','Cliquer pour modifier...',0,'0000-00-00 00:00:00'),(NULL,'fr','Click to view calls in detail','Cliquez pour afficher les appels en détail',0,'0000-00-00 00:00:00'),(NULL,'fr','Close','Fermer',0,'0000-00-00 00:00:00'),(NULL,'fr','Coach','Coacher ',0,'0000-00-00 00:00:00'),(NULL,'fr','Completed','Terminé',0,'0000-00-00 00:00:00'),(NULL,'fr','Confirm','Confirmer',0,'0000-00-00 00:00:00'),(NULL,'fr','Could not connect to the Asterisk Manager Interface to retrieve status information. Please check your manager credentials in config.php and verify they match your settings in /etc/asterisk/manager.conf','Impossible de se connecter à l\'interface Asterisk Manager pour récupérer les informations d\'état. Merci de vérifier les identifiants dans config.php et de vérifier qu\'ils correspondent à ceux définis dans /etc/asterisk/manager.conf',0,'0000-00-00 00:00:00'),(NULL,'fr','Could not copy uploaded file','Impossible de copier le fichier téléchargé',0,'0000-00-00 00:00:00'),(NULL,'fr','Count','Compter',0,'0000-00-00 00:00:00'),(NULL,'fr','Cron Configuration','Cron Configuration',0,'0000-00-00 00:00:00'),(NULL,'fr','DID','SDA',0,'0000-00-00 00:00:00'),(NULL,'fr','Dashboard','Tableau de bord',0,'0000-00-00 00:00:00'),(NULL,'fr','Data','Data',0,'0000-00-00 00:00:00'),(NULL,'fr','Date','Date',0,'0000-00-00 00:00:00'),(NULL,'fr','Day','Jour',0,'0000-00-00 00:00:00'),(NULL,'fr','Day of Week','Jour de la semaine',0,'0000-00-00 00:00:00'),(NULL,'fr','December','Décembre',0,'0000-00-00 00:00:00'),(NULL,'fr','Delete','Effacer',0,'0000-00-00 00:00:00'),(NULL,'fr','Delete Marked','Effacer sélectionnés',0,'0000-00-00 00:00:00'),(NULL,'fr','Delta','Delta',0,'0000-00-00 00:00:00'),(NULL,'fr','Description','Description ',0,'0000-00-00 00:00:00'),(NULL,'fr','Deselects all','Désélectionner tout',0,'0000-00-00 00:00:00'),(NULL,'fr','Deselects marked','Désélectionner marqués',0,'0000-00-00 00:00:00'),(NULL,'fr','Destination','Destination',0,'0000-00-00 00:00:00'),(NULL,'fr','Dialer','Numéroteur',0,'0000-00-00 00:00:00'),(NULL,'fr','Display Report','Afficher Rapport',0,'0000-00-00 00:00:00'),(NULL,'fr','Distribution','Distribution',0,'0000-00-00 00:00:00'),(NULL,'fr','Download','Télécharger',0,'0000-00-00 00:00:00'),(NULL,'fr','Duration','Durée',0,'0000-00-00 00:00:00'),(NULL,'fr','EXITWITHKEY','Sorti avec la clé',0,'0000-00-00 00:00:00'),(NULL,'fr','EXITWITHTIMEOUT','Temps dépassé',0,'0000-00-00 00:00:00'),(NULL,'fr','Edit Email Alert','Modifier l alerte par mail',0,'0000-00-00 00:00:00'),(NULL,'fr','Edit Record','Modifier l\'enregistrement',0,'0000-00-00 00:00:00'),(NULL,'fr','Edit Scheduled Report','Modifier le rapport planifié',0,'0000-00-00 00:00:00'),(NULL,'fr','Email','Email',0,'0000-00-00 00:00:00'),(NULL,'fr','Empty file?','Fichier vide?',0,'0000-00-00 00:00:00'),(NULL,'fr','Enabled','Activé',0,'0000-00-00 00:00:00'),(NULL,'fr','End Date','Date de fin',0,'0000-00-00 00:00:00'),(NULL,'fr','End Position','Position de Fin',0,'0000-00-00 00:00:00'),(NULL,'fr','Error','Erreur',0,'0000-00-00 00:00:00'),(NULL,'fr','Error extracting plugin','Erreur lors de l\'extraction du plugin',0,'0000-00-00 00:00:00'),(NULL,'fr','Error inserting record:<br/>','Erreur d\'ajout enregistrement:<br/>',0,'0000-00-00 00:00:00'),(NULL,'fr','Error updating record','Erreur de mise à jour de l\'enregistrement',0,'0000-00-00 00:00:00'),(NULL,'fr','Event','Événement',0,'0000-00-00 00:00:00'),(NULL,'fr','Example','Exemple',0,'0000-00-00 00:00:00'),(NULL,'fr','Export','Exporter',0,'0000-00-00 00:00:00'),(NULL,'fr','Exports the data to a .pdf file','Exporter les données vers un fichier .pdf',0,'0000-00-00 00:00:00'),(NULL,'fr','Exports the data to a comma separated file, to be read by your spreadsheet software','Exporter les données vers un fichier séparé par des virgules, pour lire par votre tableur',0,'0000-00-00 00:00:00'),(NULL,'fr','Failed','Échoué',0,'0000-00-00 00:00:00'),(NULL,'fr','Fails','Manquer',0,'0000-00-00 00:00:00'),(NULL,'fr','February','Février',0,'0000-00-00 00:00:00'),(NULL,'fr','Filter','Filtre',0,'0000-00-00 00:00:00'),(NULL,'fr','Filter report by Caller Id','Filtrer le rapport par numéro de l appelant',0,'0000-00-00 00:00:00'),(NULL,'fr','First','Premier',0,'0000-00-00 00:00:00'),(NULL,'fr','Free','Libre',0,'0000-00-00 00:00:00'),(NULL,'fr','Friday','Vendredi',0,'0000-00-00 00:00:00'),(NULL,'fr','From','De',0,'0000-00-00 00:00:00'),(NULL,'fr','From the last (X) days','À partir des (X) derniers jours',0,'0000-00-00 00:00:00'),(NULL,'fr','Generate','Générer',0,'0000-00-00 00:00:00'),(NULL,'fr','Generate Offline License Request','Générer la demande de licence hors ligne',0,'0000-00-00 00:00:00'),(NULL,'fr','Goes to the top of the page','Aller au haut de la page',0,'0000-00-00 00:00:00'),(NULL,'fr','Group','Groupe',0,'0000-00-00 00:00:00'),(NULL,'fr','Group by Queue','Grouper par file d\'attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Help','Aide',0,'0000-00-00 00:00:00'),(NULL,'fr','Hide Logged off','Masquer Déconnecté',0,'0000-00-00 00:00:00'),(NULL,'fr','Higher ...','Plus haut ...',0,'0000-00-00 00:00:00'),(NULL,'fr','Hold Time','Temps d\'attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Home','Accueil',0,'0000-00-00 00:00:00'),(NULL,'fr','Hour','Heure',0,'0000-00-00 00:00:00'),(NULL,'fr','Hour Range','Plage Horaire',0,'0000-00-00 00:00:00'),(NULL,'fr','Hours','Heures',0,'0000-00-00 00:00:00'),(NULL,'fr','IRM','IRM',0,'0000-00-00 00:00:00'),(NULL,'fr','ISO Code','Code ISO',0,'0000-00-00 00:00:00'),(NULL,'fr','Idle Time','Temps d\'inactivité',0,'0000-00-00 00:00:00'),(NULL,'fr','If the field value is higher than this number you will receive an alerting email','Si la valeur du champ est supérieure à ce numéro, vous recevrez un email d alerte',0,'0000-00-00 00:00:00'),(NULL,'fr','Ignoring field ','Ignorer le champ',0,'0000-00-00 00:00:00'),(NULL,'fr','Imagerie','Imagerie',0,'0000-00-00 00:00:00'),(NULL,'fr','Import','Importer',0,'0000-00-00 00:00:00'),(NULL,'fr','In order to receive scheduled reports or alerts via email, you must setup a cron job in the server. You can use the following command in your server command line:<br/><br/>crontab -e<br/><br/>and add the following line (replacing the user and password with a valid user/password):<br/><br/>','Pour recevoir des rapports planifiés ou des alertes par mail, vous devez configurer un cron dans le serveur. Vous pouvez utiliser la commande suivante en ligne de commande : crontab -eet ajouter cette ligne (en remplacant l utilisateur et le mot de passe avec un user/password valide):',0,'0000-00-00 00:00:00'),(NULL,'fr','Including Today','Y compris aujourd hui',0,'0000-00-00 00:00:00'),(NULL,'fr','Incompleted Calls','Appels incomplets',0,'0000-00-00 00:00:00'),(NULL,'fr','Invalid Date','Date invalide',0,'0000-00-00 00:00:00'),(NULL,'fr','Invalid Hour','Heure invalide',0,'0000-00-00 00:00:00'),(NULL,'fr','January','Janvier',0,'0000-00-00 00:00:00'),(NULL,'fr','July','Juillet',0,'0000-00-00 00:00:00'),(NULL,'fr','June','Juin',0,'0000-00-00 00:00:00'),(NULL,'fr','Last','Dernier',0,'0000-00-00 00:00:00'),(NULL,'fr','Last 30 days','Les 30 derniers jours',0,'0000-00-00 00:00:00'),(NULL,'fr','Last 7 days','Les 7 derniers jours',0,'0000-00-00 00:00:00'),(NULL,'fr','Last in Call','Dernier appel',0,'0000-00-00 00:00:00'),(NULL,'fr','Last month','Mois dernier',0,'0000-00-00 00:00:00'),(NULL,'fr','Last three months','Trois derniers mois',0,'0000-00-00 00:00:00'),(NULL,'fr','Level','Niveau',0,'0000-00-00 00:00:00'),(NULL,'fr','License Handling','Gestion des licences',0,'0000-00-00 00:00:00'),(NULL,'fr','License validation problem','Problème de validation de licence',0,'0000-00-00 00:00:00'),(NULL,'fr','Licensed to','Licence à',0,'0000-00-00 00:00:00'),(NULL,'fr','Listen','Écouter',0,'0000-00-00 00:00:00'),(NULL,'fr','Lists','Listes',0,'0000-00-00 00:00:00'),(NULL,'fr','Loading','Chargement',0,'0000-00-00 00:00:00'),(NULL,'fr','Logged Off','Déconnecté',0,'0000-00-00 00:00:00'),(NULL,'fr','Login','Connexion',0,'0000-00-00 00:00:00'),(NULL,'fr','Login Form','Formulaire de connexion',0,'0000-00-00 00:00:00'),(NULL,'fr','Logins','Connexions',0,'0000-00-00 00:00:00'),(NULL,'fr','Logoff','Déconnecté ',0,'0000-00-00 00:00:00'),(NULL,'fr','Logout','Déconnexion',0,'0000-00-00 00:00:00'),(NULL,'fr','Longest Session','Session la plus longue',0,'0000-00-00 00:00:00'),(NULL,'fr','Lower ...','Inférieur ...',0,'0000-00-00 00:00:00'),(NULL,'fr','Mail Send Test','Envoyer mail de test',0,'0000-00-00 00:00:00'),(NULL,'fr','March','Mars',0,'0000-00-00 00:00:00'),(NULL,'fr','Max Callers','Appelants Max',0,'0000-00-00 00:00:00'),(NULL,'fr','Max Wait Time','Temps d\'attente max',0,'0000-00-00 00:00:00'),(NULL,'fr','Max. wait time','Temps d\'attente Max.',0,'0000-00-00 00:00:00'),(NULL,'fr','May','Mai',0,'0000-00-00 00:00:00'),(NULL,'fr','Message Sent','Message envoyé',0,'0000-00-00 00:00:00'),(NULL,'fr','Minutes','Minutes',0,'0000-00-00 00:00:00'),(NULL,'fr','Monday','Lundi',0,'0000-00-00 00:00:00'),(NULL,'fr','Month','Mois',0,'0000-00-00 00:00:00'),(NULL,'fr','Month days','Jour du Mois',0,'0000-00-00 00:00:00'),(NULL,'fr','NONE','AUCUN',0,'0000-00-00 00:00:00'),(NULL,'fr','Name','Nom',0,'0000-00-00 00:00:00'),(NULL,'fr','New Email Alert','Nouvelle alerte email',0,'0000-00-00 00:00:00'),(NULL,'fr','New Scheduled Report','Nouveau rapport planifié',0,'0000-00-00 00:00:00'),(NULL,'fr','Next','Suivant',0,'0000-00-00 00:00:00'),(NULL,'fr','No','Non',0,'0000-00-00 00:00:00'),(NULL,'fr','No active channel','Pas de canal actif ',0,'0000-00-00 00:00:00'),(NULL,'fr','No info','Pas d\'info',0,'0000-00-00 00:00:00'),(NULL,'fr','No records found','Aucun enregistrement trouvé',0,'0000-00-00 00:00:00'),(NULL,'fr','No results','Aucun résultat',0,'0000-00-00 00:00:00'),(NULL,'fr','No valid fields to import!','Aucun champ valable à importer!',0,'0000-00-00 00:00:00'),(NULL,'fr','None','Aucun',0,'0000-00-00 00:00:00'),(NULL,'fr','Not Answered','Non répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Notice','Remarque',0,'0000-00-00 00:00:00'),(NULL,'fr','November','Novembre',0,'0000-00-00 00:00:00'),(NULL,'fr','Number','Numéro',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Abandoned Calls','Nombre d\'appels abandonnés',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Agent Logins','Nombre de logins d\'agents',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Agent Logoffs','Nombre de déconnexion d\'agents',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Agents','Nombre d\'agents',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Answered Calls','Nombre d\'appels répondus',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Calls per Agent','Nombre d appels par agent',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Outbound Calls','Nombre d\'Appels Sortants',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Received Calls','Nombre d\'appels reçus',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Transferred Calls','Nombre d\'appels transférés',0,'0000-00-00 00:00:00'),(NULL,'fr','Number of Unanswered Calls','Nombre d\'appels non répondus',0,'0000-00-00 00:00:00'),(NULL,'fr','Numbers','Nombres',0,'0000-00-00 00:00:00'),(NULL,'fr','OK','OK',0,'0000-00-00 00:00:00'),(NULL,'fr','October','Octobre',0,'0000-00-00 00:00:00'),(NULL,'fr','Outbound Calls','Appels Sortants',0,'0000-00-00 00:00:00'),(NULL,'fr','Overflow','Débordement',0,'0000-00-00 00:00:00'),(NULL,'fr','Page','Page',0,'0000-00-00 00:00:00'),(NULL,'fr','Page parsed in %s seconds','Page analysée en %s secondes',0,'0000-00-00 00:00:00'),(NULL,'fr','Password','Mot de passe',0,'0000-00-00 00:00:00'),(NULL,'fr','Passwords do not match','Les mots de passe ne correspondent pas',0,'0000-00-00 00:00:00'),(NULL,'fr','Pause','Pause',0,'0000-00-00 00:00:00'),(NULL,'fr','Pause Time','Temps de pause',0,'0000-00-00 00:00:00'),(NULL,'fr','Paused','En pause',0,'0000-00-00 00:00:00'),(NULL,'fr','Pauses','Pauses',0,'0000-00-00 00:00:00'),(NULL,'fr','Pauses per Session','Pauses par session',0,'0000-00-00 00:00:00'),(NULL,'fr','Penalty','Pénalité',0,'0000-00-00 00:00:00'),(NULL,'fr','Pending','En attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Period','Période',0,'0000-00-00 00:00:00'),(NULL,'fr','Play','Lecture',0,'0000-00-00 00:00:00'),(NULL,'fr','Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use','Veuillez copier le texte ci-dessus et l envoyer par mail à %s pour le traitement, ainsi que votre code d activation et le nom de la licence que vous souhaitez utiliser',0,'0000-00-00 00:00:00'),(NULL,'fr','Please select the reports to send','Sélectionnez les rapports à envoyer',0,'0000-00-00 00:00:00'),(NULL,'fr','Please wait...','Merci de patienter...',0,'0000-00-00 00:00:00'),(NULL,'fr','Please write down destination emails','Veuillez écrire les mails de destination',0,'0000-00-00 00:00:00'),(NULL,'fr','Plugin installed successfully','Plugin installé avec succès',0,'0000-00-00 00:00:00'),(NULL,'fr','Port','Port',0,'0000-00-00 00:00:00'),(NULL,'fr','Position','Position',0,'0000-00-00 00:00:00'),(NULL,'fr','Previous','Précédent',0,'0000-00-00 00:00:00'),(NULL,'fr','Price','Prix',0,'0000-00-00 00:00:00'),(NULL,'fr','Proceed','Procéder',0,'0000-00-00 00:00:00'),(NULL,'fr','Querying data...','Consultation des données ...',0,'0000-00-00 00:00:00'),(NULL,'fr','Queue','File',0,'0000-00-00 00:00:00'),(NULL,'fr','Queues','Files',0,'0000-00-00 00:00:00'),(NULL,'fr','REST Authentication error, please check the REST_USER and REST_PASS values in config.php','REST Erreur d authentification, vérifiez les valeurs REST_USER et REST_PASS dans config.php',0,'0000-00-00 00:00:00'),(NULL,'fr','REST connection error, please check your firewall rules or the REST_URL value in config.php','REST erreur de connexion, vérifiez les règles de votre pare-feu ou la valeur REST_URL dans config.php',0,'0000-00-00 00:00:00'),(NULL,'fr','RINGNOANSWER','Echec de la réponse à l appel',0,'0000-00-00 00:00:00'),(NULL,'fr','Re-Test','Re-Tester',0,'0000-00-00 00:00:00'),(NULL,'fr','Reactivate','Réactiver',0,'0000-00-00 00:00:00'),(NULL,'fr','Realtime','Temps Réel',0,'0000-00-00 00:00:00'),(NULL,'fr','Reason','Raison',0,'0000-00-00 00:00:00'),(NULL,'fr','Received','Reçu',0,'0000-00-00 00:00:00'),(NULL,'fr','Record deleted','Enregistrement supprimé',0,'0000-00-00 00:00:00'),(NULL,'fr','Record inserted','Enregistrement inséré',0,'0000-00-00 00:00:00'),(NULL,'fr','Record updated','Enregistrement mis à jour',0,'0000-00-00 00:00:00'),(NULL,'fr','Records imported','Enregistrements importés',0,'0000-00-00 00:00:00'),(NULL,'fr','Report','Rapport',0,'0000-00-00 00:00:00'),(NULL,'fr','Reports','Rapports',0,'0000-00-00 00:00:00'),(NULL,'fr','Required field','Champs Requis',0,'0000-00-00 00:00:00'),(NULL,'fr','Resource','Ressource',0,'0000-00-00 00:00:00'),(NULL,'fr','Revoke','Révoquer',0,'0000-00-00 00:00:00'),(NULL,'fr','Revoke Current License','Révoquer de la licence actuelle',0,'0000-00-00 00:00:00'),(NULL,'fr','Ring Time','Temps de sonnerie',0,'0000-00-00 00:00:00'),(NULL,'fr','Run Now','Exécuter maintenant',0,'0000-00-00 00:00:00'),(NULL,'fr','SLA','SLA',0,'0000-00-00 00:00:00'),(NULL,'fr','Saturday','Samedi',0,'0000-00-00 00:00:00'),(NULL,'fr','Save','Sauvegarder',0,'0000-00-00 00:00:00'),(NULL,'fr','Scheduled Reports and Alerts','Rapports et alertes planifiés',0,'0000-00-00 00:00:00'),(NULL,'fr','Search','Chercher',0,'0000-00-00 00:00:00'),(NULL,'fr','Search Results','Résultats de recherche',0,'0000-00-00 00:00:00'),(NULL,'fr','Seconds','Secondes',0,'0000-00-00 00:00:00'),(NULL,'fr','Select','Sélectionner',0,'0000-00-00 00:00:00'),(NULL,'fr','Select Agents','Sélectionner Agents',0,'0000-00-00 00:00:00'),(NULL,'fr','Select Date Range','Sélectionner plage de dates',0,'0000-00-00 00:00:00'),(NULL,'fr','Select Queues','Sélectionner les files d attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Select Time Frame','Sélection plage Horaire',0,'0000-00-00 00:00:00'),(NULL,'fr','Select all %s records.','Sélectionnez tous les %s enregistrements.',0,'0000-00-00 00:00:00'),(NULL,'fr','Select an option','Choisir une option',0,'0000-00-00 00:00:00'),(NULL,'fr','Select language','Choisir la langue',0,'0000-00-00 00:00:00'),(NULL,'fr','Select option','Choisir option',0,'0000-00-00 00:00:00'),(NULL,'fr','Select some options','Choisir certaines options',0,'0000-00-00 00:00:00'),(NULL,'fr','Select the field to compare','Sélectionnez le champ à comparer',0,'0000-00-00 00:00:00'),(NULL,'fr','Select the queues','Sélectionnez les files d attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Select the report to check','Sélectionnez le rapport à vérifier',0,'0000-00-00 00:00:00'),(NULL,'fr','Selected','Sélectionné ',0,'0000-00-00 00:00:00'),(NULL,'fr','Selects all','Sélectionner tout',0,'0000-00-00 00:00:00'),(NULL,'fr','Selects marked','Sélectionner marqués',0,'0000-00-00 00:00:00'),(NULL,'fr','Separate with comma ( , )<br>* means all','Séparer par une virgule (,) <br>* signifie tout',0,'0000-00-00 00:00:00'),(NULL,'fr','September','Septembre',0,'0000-00-00 00:00:00'),(NULL,'fr','Server ','Serveur',0,'0000-00-00 00:00:00'),(NULL,'fr','Server Time','Heure du serveur',0,'0000-00-00 00:00:00'),(NULL,'fr','Session Time','Temps de session',0,'0000-00-00 00:00:00'),(NULL,'fr','Sessions','Sessions',0,'0000-00-00 00:00:00'),(NULL,'fr','Setup','Configuration',0,'0000-00-00 00:00:00'),(NULL,'fr','Shortcuts','Raccourcis',0,'0000-00-00 00:00:00'),(NULL,'fr','Shortest Session Time','Temps de session le plus court',0,'0000-00-00 00:00:00'),(NULL,'fr','Spy','Écouter',0,'0000-00-00 00:00:00'),(NULL,'fr','Start Date','Date de début',0,'0000-00-00 00:00:00'),(NULL,'fr','Start Position','Position de départ',0,'0000-00-00 00:00:00'),(NULL,'fr','State','Etat',0,'0000-00-00 00:00:00'),(NULL,'fr','Steal','Intercepter',0,'0000-00-00 00:00:00'),(NULL,'fr','String','Chaîne',0,'0000-00-00 00:00:00'),(NULL,'fr','Success!','Succès!',0,'0000-00-00 00:00:00'),(NULL,'fr','Suggestion','Suggestion',0,'0000-00-00 00:00:00'),(NULL,'fr','Sunday','Dimanche',0,'0000-00-00 00:00:00'),(NULL,'fr','TRANSFER','Transfert',0,'0000-00-00 00:00:00'),(NULL,'fr','Tag','Marque',0,'0000-00-00 00:00:00'),(NULL,'fr','Talk Time','Temps de conversation',0,'0000-00-00 00:00:00'),(NULL,'fr','Test','Test',0,'0000-00-00 00:00:00'),(NULL,'fr','There are no records to export','Il n\'y a aucun enregistrement à exporter',0,'0000-00-00 00:00:00'),(NULL,'fr','There is no valid license file on this installation yet.','Il n\'y a pas encore de fichier de licence valide sur cette installation.',0,'0000-00-00 00:00:00'),(NULL,'fr','This month','Ce mois-ci',0,'0000-00-00 00:00:00'),(NULL,'fr','This week','Cette semaine',0,'0000-00-00 00:00:00'),(NULL,'fr','Thursday','Jeudi',0,'0000-00-00 00:00:00'),(NULL,'fr','Time','Temps',0,'0000-00-00 00:00:00'),(NULL,'fr','To','À',0,'0000-00-00 00:00:00'),(NULL,'fr','To use the license on a different server, you must revoke it first on this one. Remember that you need one license per server, so you won\'t be able to use the same activation code on more than one server at a time. You must also have your activation code at hand in order to activate the license on the new server.','Pour utiliser la licence sur un serveur différent, vous devez d\'abord l\'annuler sur celui-ci. N\'oubliez pas que vous avez besoin d\'une licence par serveur, de sorte que vous ne pourrez pas utiliser le même code d\'activation sur plus d\'un serveur à la fois. Vous devez également avoir votre code d\'activation pour activer la licence sur le nouveau serveur.',0,'0000-00-00 00:00:00'),(NULL,'fr','Today','Aujourd hui',0,'0000-00-00 00:00:00'),(NULL,'fr','Toggle Search Form','Basculer Formulaire de recherche',0,'0000-00-00 00:00:00'),(NULL,'fr','Total','Total',0,'0000-00-00 00:00:00'),(NULL,'fr','Total Answered Calls','Total des appels répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Total Calls','Total des appels',0,'0000-00-00 00:00:00'),(NULL,'fr','Total Duration','Durée totale',0,'0000-00-00 00:00:00'),(NULL,'fr','Total Session Time','Temps total de la session',0,'0000-00-00 00:00:00'),(NULL,'fr','Total Time per Agent (seconds)','Temps total par agent (secondes)',0,'0000-00-00 00:00:00'),(NULL,'fr','Total Unanswered Calls','Total des appels non répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Total records found','Total des enregistrements trouvés',0,'0000-00-00 00:00:00'),(NULL,'fr','Transferred','Transféré',0,'0000-00-00 00:00:00'),(NULL,'fr','Transferred Calls','Appels transférés',0,'0000-00-00 00:00:00'),(NULL,'fr','Translation','Traduction',0,'0000-00-00 00:00:00'),(NULL,'fr','Tuesday','Mardi',0,'0000-00-00 00:00:00'),(NULL,'fr','Type','Type',0,'0000-00-00 00:00:00'),(NULL,'fr','URL','URL',0,'0000-00-00 00:00:00'),(NULL,'fr','Unanswered','Non Répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Unanswered Calls','Appels non répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Unanswered Rate','Taux non répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','Unanswered by Day','Non Répondu par jour',0,'0000-00-00 00:00:00'),(NULL,'fr','Uniqueid','ID unique',0,'0000-00-00 00:00:00'),(NULL,'fr','Upgrade','Mise à niveau',0,'0000-00-00 00:00:00'),(NULL,'fr','Use comma to separate emails','Utiliser une virgule pour séparer les emails',0,'0000-00-00 00:00:00'),(NULL,'fr','User','Utilisateur',0,'0000-00-00 00:00:00'),(NULL,'fr','View Record','Voir les enregistrements ',0,'0000-00-00 00:00:00'),(NULL,'fr','Wait Time','Temps d\'attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Waiting','Attente',0,'0000-00-00 00:00:00'),(NULL,'fr','Wednesday','Mercredi',0,'0000-00-00 00:00:00'),(NULL,'fr','Week','Semaine',0,'0000-00-00 00:00:00'),(NULL,'fr','Week days','Jours de la semaine',0,'0000-00-00 00:00:00'),(NULL,'fr','Wrapup Time','Temps Wrapup',0,'0000-00-00 00:00:00'),(NULL,'fr','Write down the value to compare','Notez la valeur à comparer',0,'0000-00-00 00:00:00'),(NULL,'fr','Yes','Oui',0,'0000-00-00 00:00:00'),(NULL,'fr','Yesterday','Hier',0,'0000-00-00 00:00:00'),(NULL,'fr','You do not have enough privileges to access this resource','Vous n\'avez pas assez de privilèges pour accéder à cette ressource',0,'0000-00-00 00:00:00'),(NULL,'fr','You must select at least one agent','Vous devez sélectionner au moins un agent',0,'0000-00-00 00:00:00'),(NULL,'fr','You must select at least one queue','Vous devez sélectionner au moins une file d\'attente',0,'0000-00-00 00:00:00'),(NULL,'fr','You need to configure mail options here','Vous devez configurer les options de messagerie ici',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-acl','Contrôle des droits',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-designer','Concepteur de rapport',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-language','Traductions',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-license','Licence',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-plugins','Plugins',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-queuegroups','Groupe de Files',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-schedule','Planning/Alertes',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-setup','Préférences',0,'0000-00-00 00:00:00'),(NULL,'fr','admin-users','Utilisateurs',0,'0000-00-00 00:00:00'),(NULL,'fr','agent_availability','Disponibilité de l\'agent',0,'0000-00-00 00:00:00'),(NULL,'fr','agent_detail','Rapport agent complet',0,'0000-00-00 00:00:00'),(NULL,'fr','agent_dispositions','Disposition appel par agent',0,'0000-00-00 00:00:00'),(NULL,'fr','agent_durations','Session agent et Durée de pause',0,'0000-00-00 00:00:00'),(NULL,'fr','agent_pauses','Détail pause',0,'0000-00-00 00:00:00'),(NULL,'fr','agent_summary','Résumé agent',0,'0000-00-00 00:00:00'),(NULL,'fr','all month','tout le mois',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_agent','Répondu par agent',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_did','Répondu par SDA',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_duration','Répondu par Longueur d appel',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_event','Cause de déconnexion',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_holdtime','Niveau de service',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_queue','Répondu par file',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_by_url','Répondu par URL',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_detail','Détails des appels répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_summary','Résumé des appels répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','answered_calls_transferred','Transferts',0,'0000-00-00 00:00:00'),(NULL,'fr','at hour','à l heure',0,'0000-00-00 00:00:00'),(NULL,'fr','at minute','à la minute',0,'0000-00-00 00:00:00'),(NULL,'fr','calls','appels',0,'0000-00-00 00:00:00'),(NULL,'fr','csv_quote','Caractère de quote à utiliser pour les exportations CSV, certains programmes utilisent une double quote, d\'autres une seule, vous pouvez configurer ce chracter avec ce paramètre.',0,'0000-00-00 00:00:00'),(NULL,'fr','day','jour',0,'0000-00-00 00:00:00'),(NULL,'fr','disposition_help_ABANDON','L\'appelant a abandonné sa position dans la file.\r\nLa position est la position de l agent quand il a quitté la file, le origposition est la position originale de l a gent quand il est rentré dans la file, et le temps d attente est combien de temps il est resté en attente.',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_agent','distribution par agent',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_agent (outbound)','Distribution par agent (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_day','Distribution par jour',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_day (outbound)','Distribution par jour (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_day_of_week','Distribution par jour de la semaine',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_day_of_week (outbound)','Distribution per Day of Week (outbound)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_day_of_week_outbound','distribution par jour de la semaine sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_day_outbound','distribution par jour sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_did','Distribution par SDA',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_did (outbound)','Distribution par SDA (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_group','Distribution par groupe',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_hour','Distribution par heure',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_hour (outbound)','Distribution par heure (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_hour_outbound','Distribution par heure sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_month','Distribution par mois',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_month (outbound)','Distribution par mois (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_month_outbound','Distribution par mois sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_queue','Distribution par file',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_queue (outbound)','Distribution par file (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_queue_outbound','Distribution par files sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_tag (outbound)','Distribution par tag (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_url','Distribution by URL',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_url (outbound)','Distribution par URL (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_url_outbound','Distribution par url sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_week','Distribution par semaine',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_week (outbound)','Distribution par semaine (sortant)',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_by_week_outbound','Distribution par semaine sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_detail','Rapport de distribution détaillé',0,'0000-00-00 00:00:00'),(NULL,'fr','distribution_summary','Résumé de distribution',0,'0000-00-00 00:00:00'),(NULL,'fr','download','Télécharger',0,'0000-00-00 00:00:00'),(NULL,'fr','every day','tous les jours',0,'0000-00-00 00:00:00'),(NULL,'fr','every hour','Toutes les heures',0,'0000-00-00 00:00:00'),(NULL,'fr','every minute','chaque minute',0,'0000-00-00 00:00:00'),(NULL,'fr','hours','heure',0,'0000-00-00 00:00:00'),(NULL,'fr','info1','Info 1',0,'0000-00-00 00:00:00'),(NULL,'fr','info2','info 2',0,'0000-00-00 00:00:00'),(NULL,'fr','info3','Info 3',0,'0000-00-00 00:00:00'),(NULL,'fr','info4','Info 4',0,'0000-00-00 00:00:00'),(NULL,'fr','info5','Info 5',0,'0000-00-00 00:00:00'),(NULL,'fr','jscolumnvisibility','Column Visibility',0,'0000-00-00 00:00:00'),(NULL,'fr','keyword','mot-clé',0,'0000-00-00 00:00:00'),(NULL,'fr','none','aucun',0,'0000-00-00 00:00:00'),(NULL,'fr','of','de',0,'0000-00-00 00:00:00'),(NULL,'fr','on %s since %s seconds ago','en %s depuis %s secondes',0,'0000-00-00 00:00:00'),(NULL,'fr','on %s since %s secs ago','en %s depuis %s secs',0,'0000-00-00 00:00:00'),(NULL,'fr','on days','les jours',0,'0000-00-00 00:00:00'),(NULL,'fr','on hours','les heures',0,'0000-00-00 00:00:00'),(NULL,'fr','on minutes','les minutes',0,'0000-00-00 00:00:00'),(NULL,'fr','parameter','paramètre',0,'0000-00-00 00:00:00'),(NULL,'fr','partial','partiel',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime-agent-busy','Occupé',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime-agent-dialout','Appel sortant',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime-agent-hold','En attente',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime-agent-not in use','Disponible',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime-agent-ringing','Sonnerie',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime-agent-unavailable','Indisponible',0,'0000-00-00 00:00:00'),(NULL,'fr','realtime_queue_summary','Résumé de la file d attente',0,'0000-00-00 00:00:00'),(NULL,'fr','sEmptyTable','Aucune donn&eacute;e disponible dans le tableau',0,'0000-00-00 00:00:00'),(NULL,'fr','sFirst','Premier',0,'0000-00-00 00:00:00'),(NULL,'fr','sInfo','Affichage de l\'&eacute;l&eacute;ment _START_ &agrave; _END_ sur _TOTAL_ &eacute;l&eacute;ments',0,'0000-00-00 00:00:00'),(NULL,'fr','sInfoEmpty','Affichage de l\'&eacute;l&eacute;ment 0 &agrave; 0 sur 0 &eacute;l&eacute;ment',0,'0000-00-00 00:00:00'),(NULL,'fr','sInfoFiltered','(filtr&eacute; de _MAX_ &eacute;l&eacute;ments au total)',0,'0000-00-00 00:00:00'),(NULL,'fr','sInfoPostFix','',0,'0000-00-00 00:00:00'),(NULL,'fr','sLast','Dernier',0,'0000-00-00 00:00:00'),(NULL,'fr','sLengthMenu','Afficher _MENU_ &eacute;l&eacute;ments',0,'0000-00-00 00:00:00'),(NULL,'fr','sLoadingRecords','Chargement en cours...',0,'0000-00-00 00:00:00'),(NULL,'fr','sNext','Suivant',0,'0000-00-00 00:00:00'),(NULL,'fr','sPrevious','Pr&eacute;c&eacute;dent',0,'0000-00-00 00:00:00'),(NULL,'fr','sProcessing','Traitement en cours...',0,'0000-00-00 00:00:00'),(NULL,'fr','sSearch','Rechercher&nbsp;:',0,'0000-00-00 00:00:00'),(NULL,'fr','sSortAscending',': activer pour trier la colonne par ordre croissant',0,'0000-00-00 00:00:00'),(NULL,'fr','sSortDescending',': activer pour trier la colonne par ordre d&eacute;croissant',0,'0000-00-00 00:00:00'),(NULL,'fr','sZeroRecords','Aucun &eacute;l&eacute;ment &agrave; afficher',0,'0000-00-00 00:00:00'),(NULL,'fr','seconds','secondes',0,'0000-00-00 00:00:00'),(NULL,'fr','secs','secs',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_by_did','Appels non répondu par SDA',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_by_event','Cause de déconnexion',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_by_holdtime','Niveau de service',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_by_queue','Appels non répondu par file d\'attente',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_by_url','Appels non répondu par URL',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_detail','Détail des appels non répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','unanswered_calls_summary','Résumé des appels non répondu',0,'0000-00-00 00:00:00'),(NULL,'fr','value','valeur',0,'0000-00-00 00:00:00'),(NULL,'fr','within','dans',0,'0000-00-00 00:00:00'),(NULL,'fr','within %d%s seconds','dans %d%s secondes',0,'0000-00-00 00:00:00');

INSERT INTO `language` VALUES (NULL,'pt_br','%','%',0,'2012-10-02 22:18:40'),(NULL,'pt_br','%%','%%',0,'2012-10-02 22:17:26'),(NULL,'pt_br','%% Answ','%% Atendidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','%% Calls','%% Chamadas',0,'2012-10-02 22:17:26'),(NULL,'pt_br','%% Paused','%% Pausado',0,'2012-10-02 22:17:24'),(NULL,'pt_br','%% Talk Time','%% Tempo Total',0,'2012-09-27 03:27:13'),(NULL,'pt_br','%% Unansw','%% Nao Atendidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','%s','%s',0,'2012-10-02 22:17:24'),(NULL,'pt_br','%s %%','%s %%',0,'0000-00-00 00:00:00'),(NULL,'pt_br','%s days','%s dias',0,'2012-10-02 22:18:40'),(NULL,'pt_br','%s min. ago','%s min. atras',0,'2012-10-02 22:18:50'),(NULL,'pt_br','%s minutes','%s minutos',0,'0000-00-00 00:00:00'),(NULL,'pt_br','%s records deleted','%s registros deletados',0,'2012-09-22 05:45:37'),(NULL,'pt_br','%s secs','%s segs',0,'0000-00-00 00:00:00'),(NULL,'pt_br','ABANDON','Abandono',0,'2012-10-02 22:17:26'),(NULL,'pt_br','ALL','TODOS',0,'2012-09-22 06:07:38'),(NULL,'pt_br','Abandon Avg Queue Position at Disconnection','Posiçao Media na Fila ao Abandonar',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Abandon Avg Queue Start Position','Posiçao Inicial na fila de quem abandonou',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Abandon Avg Wait Before Disconnection','Media espera antes de desligar dos Abandonos',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Abandon Rate','Percentual Abandono',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Abandoned','Ligações abandonadas',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Abandoned Calls','Lig. Abandonadas',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Actions','Açao',0,'2012-10-02 22:18:49'),(NULL,'pt_br','Active','Ativo',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Add','Adicionar',0,'2012-10-02 04:24:54'),(NULL,'pt_br','Add Record','Acrescentar registro',0,'2012-09-26 06:06:23'),(NULL,'pt_br','Agent','Agente',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Agent Status','Status Agentes',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Agent Totals','Total Agentes',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Agents','Total de Agentes',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Alert','Alerta',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Alerts','Alertas',0,'2012-10-02 22:18:52'),(NULL,'pt_br','All %s records are selected.','Todos %s registros selecionados',0,'2012-09-22 05:53:08'),(NULL,'pt_br','All %s records on this page are selected.','Todos os %s registros nesta página são selecionados.',0,'2012-09-22 05:53:04'),(NULL,'pt_br','An error has occurred','Ocorreu um Erro',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Answer','Atendidas em ate X Segundos',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Answered','Total Lig. Atend.',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Answered Calls','Atendidas',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Answered by Day','Atendidas por Dia',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Answered/Abandoned','Atendidas/Abandonadas',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Answered/Abandoned per Hour','Atendido/Abandonado por Hora',0,'2012-10-02 22:18:40'),(NULL,'pt_br','April','Abril',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Are you sure?','Tem Certeza?',0,'2012-10-02 22:18:52'),(NULL,'pt_br','August','Agosto',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Available','Disponivel',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Available Keywords','Palavras-chave Disponíveis',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Available Variables','Variáveis Disponíveis',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Average Duration by Day','Duração Media por Dia',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Average Session Time','Sessões - Tempo Medio',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Average Wait Time by Day','Espera Media por Dia',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Avg Duration','Duração Media',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Avg Talk','Tempo Medio',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Avg Talk Time','Media Tempo Falando',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Avg Wait','Espera Media',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Avg Wait Time','Media Tempo Espera',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Avg. Paused','Pausa - Tempo Medio',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Avg. Session','Média de sessões',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Avg. Session Time','Sessões - Tempo Medio',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Back','Voltar',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Bad username or password','Nome de usuário ou senha ruim',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Busy','Ocupados',0,'2012-10-02 22:18:50'),(NULL,'pt_br','COMPLETEAGENT','COMPLETADA',0,'2012-10-02 22:17:24'),(NULL,'pt_br','COMPLETECALLER','COMPLETADA',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Caller ID','Numero',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Calls','Ligaçoes Atend.',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Calls Waiting Detail','Detalhes Fila',0,'2012-09-26 04:33:57'),(NULL,'pt_br','Campaigns','Campaigns',1,'2017-10-13 20:06:01'),(NULL,'pt_br','Cancel','Cancelar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Cannot steal call. realtime_spy_extension for user <b>%s</b> is not defined in Setup/Preferences.','Nao é possivel captar a ligaçao.  realtime_spy_extension para usuario <b>%s</b> no foi definido em Setup/Preferencias',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Clear Selection','Desselecionar',0,'2012-09-22 05:53:08'),(NULL,'pt_br','Click to add text','Clique para acrescentar Texto',0,'2012-10-02 04:24:37'),(NULL,'pt_br','Click to edit...','Clique para editar...',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Click to view calls in detail','Clica para ver detalhs da ligaçao',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Coach','Supervisionar',0,'2012-09-26 06:11:21'),(NULL,'pt_br','Completed','Completado',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Confirm','Confirmar',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Could not connect to the Asterisk Manager Interface to retrieve status information. Please check your manager credentials in config.php and verify they match your settings in /etc/asterisk/manager.conf','Nao foi possivel conectar a interface Manager do asterisk para pegar inforamçao de status. Favor checar seus credencias no config.php e verificar que correspondem as configuraçoes no  /etc/asterisk/manager.conf',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Could not copy uploaded file','Nao foi possivel importar arquivo',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Count','Contagem',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Cron Configuration','Configuraçao Cron',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Dashboard','Dashboard',1,'2017-10-13 20:06:01'),(NULL,'pt_br','Date','Data',0,'2012-10-02 22:18:49'),(NULL,'pt_br','Day','Dia',0,'2012-10-02 22:18:40'),(NULL,'pt_br','December','Dezembro',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Delete','Deletar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Delete Marked','Deletar selecionados',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Delta','Delta',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Deselects all','Desselecionar todos',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Deselects marked','Desselecionar marcados',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Dialer','Dialer',1,'2017-10-13 20:06:01'),(NULL,'pt_br','Display Report','Mostrar Relatorio',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Distribution','Distribuiçao',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Download','Download',0,'2012-10-02 22:16:33'),(NULL,'pt_br','Duration','Duração ',0,'2012-10-02 22:18:50'),(NULL,'pt_br','EXITWITHKEY','Saída com tecla',0,'0000-00-00 00:00:00'),(NULL,'pt_br','EXITWITHTIMEOUT','Exit with Timeout',1,'2012-10-02 22:17:26'),(NULL,'pt_br','Edit Email Alert','Editar Alerta de EMail',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Edit Record','Editar Registro',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Edit Scheduled Report','Editar Relatorio Automatico',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Email','Email',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Empty file?','Arquivo vazio?',0,'0000-00-00 00:00:00'),(NULL,'pt_br','End Date','Data Final',0,'2012-10-02 22:19:07'),(NULL,'pt_br','End Position','Posição ao Abandonar Fila',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Error inserting record:<br/>','Erro Inserindo Registro:<br/>',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Error updating record','Erro Atualizando Registro',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Event','Evento',0,'2012-10-02 22:18:49'),(NULL,'pt_br','Example','Exemplo',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Export','Exportar',0,'2012-10-02 04:24:37'),(NULL,'pt_br','Exports the data to a .pdf file','Exportar para pdf',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Exports the data to a comma separated file, to be read by your spreadsheet software','Exportar para CSV para excel',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Fails','Falhas',0,'2013-07-03 06:04:46'),(NULL,'pt_br','February','Fevereiro',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Filter','Filtro',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Filter report by Caller Id','Filtrar por Bina',0,'2012-10-02 22:18:40'),(NULL,'pt_br','First','Primeiro',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Friday','Sexta',0,'2012-10-02 22:19:10'),(NULL,'pt_br','From','De',0,'2012-10-02 22:19:07'),(NULL,'pt_br','From the last (X) days','Dos ultimo (X) dias',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Generate','Gerar',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Generate Offline License Request','Gerar Solicitação de Licença Desligada ',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Goes to the top of the page','Votar ao topo da Pagina',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Group by Queue','Agrupar Filas',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Help','Ajuda',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Hide Logged off','Esconder Nao Logados',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Higher ...','Maior ...',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Home','Home',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Hour','Hora',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Hour Range','Horario',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Hours','Horas',0,'2012-10-02 22:18:52'),(NULL,'pt_br','ISO Code','Codigo ISO',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Idle Time','Tempo ocioso',0,'2013-07-03 05:38:34'),(NULL,'pt_br','If the field value is higher than this number you will receive an alerting email','Se o valor do campo é maior do que este número, você receberá um e-mail de alerta',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Ignoring field ','Ignoring field ',1,'0000-00-00 00:00:00'),(NULL,'pt_br','Import','Importar',0,'2012-10-02 04:24:37'),(NULL,'pt_br','In order to receive scheduled reports or alerts via email, you must setup a cron job in the server. You can use the following command in your server command line:<br/><br/>crontab -e<br/><br/>and add the following line (replacing the user and password with a valid user/password):<br/><br/>','Para receber relatorios programados ou alertas via email, é necessario criar um “cron job” no servidor. É possivel usar o seguinte commando na linha de commando do servidor:<br/><br/>crontab -e<br/><br/>and acrescenta a linha seguinte (repoem user/password com o usuario e senha validos:<br/><br/>',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Incompleted Calls','Ligaçoes Nao completadas',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Invalid Date','Data Invalida',0,'2012-09-22 05:45:37'),(NULL,'pt_br','Invalid Hour','Hora Invalida',0,'2012-09-22 05:45:37'),(NULL,'pt_br','January','Janeiro',0,'2012-10-02 22:19:10'),(NULL,'pt_br','July','Julho',0,'2012-10-02 22:19:10'),(NULL,'pt_br','June','Junho',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Last','Ultimo',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Last in Call','Ultima Lig. At.',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Last three months','Ultimos 3 meses',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Level','Nivel',0,'2012-09-22 06:07:38'),(NULL,'pt_br','License Handling','Manipulação de Licença',0,'0000-00-00 00:00:00'),(NULL,'pt_br','License validation problem','Problema de validação de licença',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Licensed to','Licenciado:',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Listen','Escutar',0,'2012-09-26 06:11:21'),(NULL,'pt_br','Lists','Lists',1,'2017-10-13 20:06:01'),(NULL,'pt_br','Loading','Carregando',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Logged Off','Não Logados',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Login','Login',0,'2012-09-27 03:26:20'),(NULL,'pt_br','Login Form','Login',0,'2012-09-27 03:26:20'),(NULL,'pt_br','Logins','Logins',1,'2012-10-02 22:18:40'),(NULL,'pt_br','Logoff','Logoffs',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Logout','Logout',1,'2012-10-02 22:19:07'),(NULL,'pt_br','Longest Session','Sessão mais longa',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Lower ...','Mais Baixo...',0,'2012-10-02 22:19:07'),(NULL,'pt_br','March','Março',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Max Callers','Max Ligaçoes',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Max Wait Time','Tempo Max Espera\n',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Max. wait time','Temp Max. Espera',0,'2012-10-02 22:18:50'),(NULL,'pt_br','May','Maio',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Minutes','Minutos',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Monday','Segunda Feira',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Month','Mes',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Month days','Dias Mes',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Name','Nome',0,'2012-09-22 06:07:38'),(NULL,'pt_br','New Email Alert','Nova alerta de Email',0,'2012-10-02 22:18:52'),(NULL,'pt_br','New Scheduled Report','Novo relatorio automatico',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Next','Proximo',0,'2012-10-02 22:18:52'),(NULL,'pt_br','No','No',0,'2012-10-02 22:18:52'),(NULL,'pt_br','No active channel','Nenhum canal ativo',0,'0000-00-00 00:00:00'),(NULL,'pt_br','No info','Sem Informação',0,'2012-09-26 03:49:04'),(NULL,'pt_br','No records found','Nenhum Registro encontrado',0,'2012-10-02 04:24:29'),(NULL,'pt_br','No results','Nenhum resultado',0,'0000-00-00 00:00:00'),(NULL,'pt_br','No valid fields to import!','No valid fields to import!',1,'0000-00-00 00:00:00'),(NULL,'pt_br','None','Nenhum',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Notice','Aviso',0,'0000-00-00 00:00:00'),(NULL,'pt_br','November','Novembro',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Number','Numero',0,'2012-10-02 22:18:49'),(NULL,'pt_br','Number of Abandoned Calls','Ligaçoes Abandonadas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Number of Agent Logins','Numero de Logins de Agentes',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Number of Agent Logoffs','Numero de Logoffs de Agentes',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Number of Agents','Número de Agentes',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Number of Answered Calls','Atendidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Number of Calls per Agent','Ligações por Atendentes',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Number of Outbound Calls','Número de Chamadas de Saída',0,'2015-01-07 22:12:24'),(NULL,'pt_br','Number of Received Calls','Ligaçoes Recebidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Number of Transferred Calls','Numero ligaçoes transferidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Number of Unanswered Calls','Ligaçeos Nao Atendidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Numbers','Numbers',1,'2017-10-13 20:06:01'),(NULL,'pt_br','OK','OK',0,'0000-00-00 00:00:00'),(NULL,'pt_br','October','Outubro',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Outbound Calls','Chamadas de Saída',0,'2015-01-07 22:12:24'),(NULL,'pt_br','Overflow','Overflow',1,'2012-10-02 22:18:49'),(NULL,'pt_br','Page','Pagina',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Page parsed in %s seconds','Pagina atualizada em %s segundos',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Password','Senha',0,'2012-09-27 03:26:20'),(NULL,'pt_br','Passwords do not match','Senhas digitadas nao são iguais',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Pause Time','Duração da Pausa',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Paused','Pausados',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Pauses','Pausas',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Pauses per Session','Pausas por Sessão',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Pending','Pendente',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Period','Periodo',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Play','Tocar',0,'2012-10-02 22:16:33'),(NULL,'pt_br','Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use','Por favor, copie o texto acima e enviá-lo por e-mail a %s para processamento, juntamente com seu código de ativação eo nome licenciado que pretende utilizar',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Please select the reports to send','Selecione os relatorios para enviar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Please write down destination emails','Favor indicar email de envio',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Position','Posiçao',0,'2012-09-26 04:33:57'),(NULL,'pt_br','Previous','Anterior',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Proceed','Prosseguir',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Querying data...','Procurando informaçao',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Queue','Fila',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Queues','Filas',0,'2012-09-22 06:07:38'),(NULL,'pt_br','RINGNOANSWER','Failed to Answer Call',1,'2012-10-02 22:17:24'),(NULL,'pt_br','Reactivate','Reativar',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Realtime','Tempo Real',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Received','Recebidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Record deleted','Registros deletados',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Record inserted','Registro inserido',0,'2012-09-26 06:06:31'),(NULL,'pt_br','Record updated','Registro atualizado',0,'2012-10-02 04:06:53'),(NULL,'pt_br','Records imported','Registros importados',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Report','Relatorio',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Reports','Relatorio',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Required field','Campo obrigatorio',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Revoke','Revogar',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Revoke Current License','Revogar Licença',0,'0000-00-00 00:00:00'),(NULL,'pt_br','SLA','SLA',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Saturday','Sábado',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Save','Salvar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Scheduled Reports and Alerts','Relatorios e alarmes programados',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Search','Busca',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Seconds','Segundos',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Select Agents','Selecione Agentes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Select Date Range','Selecione Data',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Select Queues','Selecione Fila',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Select Time Frame','Selecione Horario',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Select all %s records.','Selecionar todos %s registros',0,'2012-09-22 05:53:04'),(NULL,'pt_br','Select an option','Selecione uma opçao',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Select language','Selecione Idioma',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Select option','Selecione opção',0,'2012-10-02 22:18:53'),(NULL,'pt_br','Select some options','Selecione algumas opções',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Select the field to compare','Selecione campo para comparar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Select the report to check','Selecione relatorio para verificar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Selected','Selecionado',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Selects all','Seleciona TODOS',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Selects marked','Seleciona opções marcadas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Separate with comma ( , )<br>* means all','separar com vírgula ( , )<br>* significa tudo',0,'2012-10-02 22:18:52'),(NULL,'pt_br','September','Setembro',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Server Time','HORA =',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Session Time','Duração da Sessão',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Sessions','Sessões',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Setup','Configuraçoes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Shortcuts','Atalhos',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Shortest Session Time','Menor tempo de sessão',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Spy','Espiar',0,'0000-00-00 00:00:00'),(NULL,'pt_br','Start Date','Data Inicial',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Start Position','Posição ao entrar na fila',0,'2012-10-02 22:17:26'),(NULL,'pt_br','State','Status',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Steal','Puxar ligação',0,'2012-09-26 06:11:21'),(NULL,'pt_br','String','Texto',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Success!','Sucesso!',0,'2012-10-02 04:06:53'),(NULL,'pt_br','Sunday','Domingo',0,'2012-10-02 22:19:10'),(NULL,'pt_br','TRANSFER','Transferência',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Talk Time','Tempo conversando',0,'2012-10-02 22:18:49'),(NULL,'pt_br','There is no valid license file on this installation yet.','There is no valid license file on this installation yet.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','This month','Este Mes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','This week','Esta Semana',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Thursday','5a Feira',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Time','Tempo',0,'2012-10-02 22:17:24'),(NULL,'pt_br','To','Para',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Today','Hoje',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Toggle Search Form','Expandir Busca',0,'2012-10-02 22:18:49'),(NULL,'pt_br','Total','Total',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Total Answered Calls','Total Atendidas',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Total Calls','Total Ligações',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Total Duration','Duração Total das Ligações:',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Total Session Time','Tempo Total da Sessão',0,'2012-10-02 22:17:24'),(NULL,'pt_br','Total Time per Agent (seconds)','Tempo Total por Agenete',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Total Unanswered Calls','Total ligações não atendidas\n',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Total records found','Total de registros encontrados',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Transferred','Transferidas',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Transferred Calls','Ligações Transferidas',0,'2012-09-27 03:27:13'),(NULL,'pt_br','Translation','Traduçao',0,'2012-10-02 04:24:45'),(NULL,'pt_br','Tuesday','3a Feira',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Type','Tipo',0,'2012-10-02 22:18:52'),(NULL,'pt_br','URL','URL',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Unanswered','Total Não Atendidas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','Unanswered Calls','N_Atendidas',0,'2012-10-02 22:17:26'),(NULL,'pt_br','Unanswered Rate','Percentual Nao Atendidas\n',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Unanswered by Day','Não Atendidas por Dia',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Use comma to separate emails','Use vírgula para separar e-mails',0,'2012-10-02 22:18:52'),(NULL,'pt_br','User','Usuario',0,'2012-09-27 03:26:20'),(NULL,'pt_br','View Record','Ver registro',0,'2012-10-02 04:24:54'),(NULL,'pt_br','Wait Time','Tempo espernado ate Abandonar',0,'2012-10-02 22:18:49'),(NULL,'pt_br','Waiting','Na Fila',0,'2012-10-02 22:18:50'),(NULL,'pt_br','Wednesday','4a Feira',0,'2012-10-02 22:19:10'),(NULL,'pt_br','Week','Semana',0,'2012-10-02 22:18:40'),(NULL,'pt_br','Week days','Dias da semana',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Write down the value to compare','Anote o valor para comparar',0,'2012-10-02 22:18:52'),(NULL,'pt_br','Yes','Sim',0,'2012-10-02 22:18:52'),(NULL,'pt_br','You do not have enough privileges to access this resource','Você não tem privilégios suficientes para aceder a este recurso',0,'0000-00-00 00:00:00'),(NULL,'pt_br','You must select at least one agent','Você deve selecionar pelo menos um agente',0,'0000-00-00 00:00:00'),(NULL,'pt_br','You must select at least one queue','Você deve selecionar pelo menos uma fila',0,'0000-00-00 00:00:00'),(NULL,'pt_br','admin-acl','Controle de Acesso',0,'2012-10-02 22:19:07'),(NULL,'pt_br','admin-designer','Configurar Relatorios',0,'2012-10-02 22:19:07'),(NULL,'pt_br','admin-language','Traduçao',0,'2012-10-02 22:19:07'),(NULL,'pt_br','admin-schedule','Configurar Alertas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','admin-setup','Preferencias',0,'2012-10-02 22:19:07'),(NULL,'pt_br','admin-users','Usuarios',0,'2012-10-02 22:19:07'),(NULL,'pt_br','agent_availability','Disponibilidade dos Agentes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','agent_detail','Detalhe por Agente',0,'2012-10-02 22:19:07'),(NULL,'pt_br','agent_dispositions','Status de ligações por Agente',0,'2012-10-02 22:19:07'),(NULL,'pt_br','agent_durations','Sessões e Pausas dos Agentes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','agent_pauses','Detalhe pausas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','agent_summary','Resumo de Agentes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','all month','Mes atual',0,'2012-10-02 22:18:52'),(NULL,'pt_br','answered_calls_by_agent','Atendidas por Agente',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_by_duration','Atendidas por Duração',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_by_event','Causa Desconexão',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_by_holdtime','Nivel de Serviço',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_by_queue','Atendidas por Fila',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_by_url','Atendidas por URL',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_detail','Detalhes das Ligaçoes Atendidas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_summary','Atendidas - Resumo',0,'2012-10-02 22:19:07'),(NULL,'pt_br','answered_calls_transferred','Transferencias',0,'2012-10-02 22:19:07'),(NULL,'pt_br','at hour','na hora ?',0,'2012-10-02 22:18:52'),(NULL,'pt_br','at minute','no minuto ?',0,'2012-10-02 22:18:52'),(NULL,'pt_br','calls','ligaçoes',0,'2012-10-02 22:18:40'),(NULL,'pt_br','day','dia',0,'2012-10-02 22:18:52'),(NULL,'pt_br','disposition_help_ABANDON','Ligou e abandonou/desligou a ligação antes de ser atendido',0,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_COMPLETEAGENT','Ligação foi atendida por um agente e a ligação foi encerrada pelo agente.Tempo de espera, e porisição ao entrar na fila sao registradas.',0,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_COMPLETECALLER','The caller was connected to an agent, and the call was terminated normally\r\nby the *caller*. The callers hold time and the length of the call are both\r\nrecorded. The caller&rsquo;s original position in the queue is recorded in\r\norigposition.\r\n',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_CONNECT','The caller was connected to an agent.',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_ENTERQUEUE','disposition_help_ENTERQUEUE',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_EXITWITEMPTY','The caller was exited from the queue forcefully because the queue had no\r\nreachable members and it&lsquo;s configured to do that to callers when there\r\nare no reachable members. The position is the caller&lsquo;s position in the\r\nqueue when they hungup, the origposition is the original position the\r\ncaller was when they first entered the queue, and the waittime is how\r\nlong the call had been waiting in the queue at the time of disconnect.',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_EXITWITHKEY','The caller elected to use a menu key to exit the queue. The key and\r\nthe caller&lsquo;s position in the queue are recorded.\r\n',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_EXITWITHTIMEOUT','The caller was on hold too long and the timeout expired.',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_RINGNOANSWER','The timeout value for ringing the queue member was exceeded. A single parameter will also be written indicating the amount of time the member’s extension rang in the Info 1 field.',1,'2012-10-02 22:17:26'),(NULL,'pt_br','disposition_help_TRANSFER','Caller was transferred to a different extension. Context and extension\r\nare recorded. The caller&lsquo;s hold time and the length of the call are both\r\nrecorded. PLEASE remember that transfers performed by SIP UA&lsquo;s by way\r\nof a reinvite may not always be caught by x-caracal and trigger off this\r\nevent. The only way to be 100% sure that you will get this event when\r\na transfer is performed by a queue member is to use the built-in transfer\r\nfunctionality of x-caracal.',1,'2012-10-02 22:17:26'),(NULL,'pt_br','distribution_by_agent','Ligações por Agente',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_agent (outbound)','Ligações por Agente (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_day','Ligações por Dia',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_day (outbound)','Ligações por Dia (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_day_of_week','Ligações por dia da Semana',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_day_of_week (outbound)','Ligações por dia da Semana (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_hour','Ligações por Hora',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_hour (outbound)','Ligações por Hora (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_month','Ligações por Mes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_month (outbound)','Ligações por Mes (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_queue','Ligações por Fila',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_queue (outbound)','Ligações por Fila (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_url','Ligações por URL',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_url (outbound)','Ligações por URL (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_by_week','Ligações por Semana',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_by_week (outbound)','Ligações por Semana (saída)',0,'2013-06-25 17:36:03'),(NULL,'pt_br','distribution_detail','Detalhes Ligaçoes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','distribution_summary','Resumo',0,'2012-10-02 22:19:07'),(NULL,'pt_br','event_help_abandon_info1','The position is the caller&#39;s position in the queue when they hungup.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_abandon_info2','The original position the caller was positioned when they first entered the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_abandon_info3','The waittime is how long the call had been waiting in the queue at the time of disconnect.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentcallbacklogin_info1','The callback agent logged in. The login extension and context is recorded.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentcallbacklogoff_info1','The callback agent logged off.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentcallbacklogoff_info2','The last login extension and context is recorded, along with the total time the agent was logged in.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentcallbacklogoff_info3','The reason for the logoff if it was not a normal logoff (e.g., Autologoff, Chanunavail)',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentlogin_info1','The agent logged in. The channel is recorded.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentlogoff_info1','The agent logged off.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_agentlogoff_info2','The total time the agent was logged in.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_completeagent_info1','The caller&#39;s hold time.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_completeagent_info2','The length of the call.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_completeagent_info3','The caller&#39;s original position in the queue is recorded in origposition.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_completecaller_info1','The caller&#39;s hold time',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_completecaller_info2','The length of the call.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_completecaller_info3','The caller&#39;s original position in the queue is recorded in origposition.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_connect_info1','Hold time represents the amount of time the caller was on hold.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_connect_info2','The bridged channel unique ID contains the unique ID of the queue member channel that is taking the call.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_connect_info3','Ringtime represents the time the queue members phone was ringing prior to being answered.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_enterqueue_info1','URL parameter',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_enterqueue_info2','Caller ID',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_enterqueue_info3','The original position the caller was positioned when they first entered the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitempty_info1','The position is the caller&#39;s position in the queue when they hungup.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitempty_info2','The origposition is the original position the caller was when they first entered the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitempty_info3','The waittime is how long the call had been waiting in the queue at the time of disconnect.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitwithkey_info1','The caller elected to use a menu key to exit the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitwithkey_info2','The caller&#39;s position.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitwithtimeout_info1','The position the caller was when exiting the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitwithtimeout_info2','Original position at which the called entered the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_exitwithtimeout_info3','Amount of time the caller waited in the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_pause_info1','Pause reason if any',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_ringnoanswer_info1','Time in milliseconds the agent phone rang until the timeout was reached. The attempt ended without the member picking up the call. Bad queue member!',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_transfer_info1','The extension',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_transfer_info2','The context',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_transfer_info3','The caller&#39;s hold time',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_transfer_info4','The length of the call.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_transfer_info5','The caller&#39;s entry position at the time of the transfer.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','event_help_unpause_info1','Unpause reason if any',1,'0000-00-00 00:00:00'),(NULL,'pt_br','every day','todos os dias',0,'0000-00-00 00:00:00'),(NULL,'pt_br','every hour','todas as horas',0,'2012-10-02 22:18:52'),(NULL,'pt_br','every minute','a cada minuto',0,'2012-10-02 22:18:52'),(NULL,'pt_br','help_text_ACTION','Define a custom action handler, so you can call your own functions/program to handle special cases. You must create the javascript function in the js/custom.js file. It will receive the uniqueid of the call when the action icon is clicked.<br/>\r\n<br/>\r\nparameter: position,icon image,Tooltip<br/>\r\nvalue: javascript_function',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_ANSWERED_DISPLAY_GRID','If a chart is defined in the answered reports tab, parameter field, then use the grid layout width as setup in the value field. The grid system has 12 columns in total:<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: width1,width2',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_ANSWERED_DISPLAY_ROWS','Comma separated list of fields to show on a specific Answered reports. The fields are the one defined as COLUMN_ANSWERED.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields ',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_CHART_ANSWERED','Shows a chart into the Answered reports page.<br/><br/>\n\nparameter: position,group field,title<br/>\nvalue: field,field',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_CHART_DISTRIBUTION','Shows a chart into the Distribution reports page.<br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_CHART_SERIES_COLOR','Colors to use for charts. Parameter is the index position, and value the hex html color.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_CHART_UNANSWERED','Shows a chart into the Unanswered reports page.<br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_ANSWERED','Column to show in Answered reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in ANSWERED_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n\r\n\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_ANSWERED_FORMAT','Format to use for displaying a cell value in the answered reports. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_ANSWERED entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_DISTRIBUTION','Column to show in Distribution reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in DISTRIBUTION_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_DISTRIBUTION_FORMAT','Format to use for displaying a cell value in the distribution reports. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_DISTRIBUTION entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_REALTIME','Column to show in the Realtime summary. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in REALTIME_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_REALTIME_FORMAT','Format to use for displaying a cell value in the realtime queue summary report. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_REALTIME entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_REALTIME_STYLE','Extra html property to add to cell values in the realtime queue summary table. You can use class or style to modify display on those cells. Example:<br/>\r\n<br/>\r\nclass=&quot;bigblue&quot;\r\n<br/>\r\nstyle=&quot;border:1px solid red;&quot;\r\n\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_UNANSWERED','Column to show in Unanswered reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in UNANSWERED_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_COLUMN_UNANSWERED_FORMAT','Format to use for displaying a cell value in the unanswered reports. It uses regular printf formatting rules, except for hourly values that can use {HH}, {MM}, {SS}, {mm} and {ss}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nThe parameter field name must be set as the parameter field on the COLUMN_UNANSWERED entry.<br/>\r\nFormat Examples:<br/><br/>\r\nGiven a value in seconds, convert it to HH:MM:SS with:<br/>\r\n{HH}:{MM}:{SS}\r\n',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_DISTRIBUTION_DISPLAY_ROWS','Comma separated list of fields to show on a specific Distribution reports. The fields are the one defined as COLUMN_DISTRIBUTION.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_ABANDONED','Define the queue_log events that will count towards the ABANDONED counters/variables in reports, using a comma separated list. In a standard Asterisk setup, this must be set to \\\"ABANDON\\\" and nothing else.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_ANSWERED','Define the queue_log events that will count towards the ANSWERED counters/variables in reports, using a comma separated list. Normal answered dispositions in the queue_log are COMPLETECALLER, COMPLETEAGENT, you could also want to count the TRANSFER disposition towards the ANSWERED column, but as transfers have their own variable, you can also leave them separated.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_LOGIN','Define the queue_log events that will count towards the LOGIN counters/variables in reports, using a comma separated list. Usually you have AGENTLOGIN and ADDMEMBER as events for login events in the queue_log file. Old asterisk versions could also use AGENTCALLBACKLOGIN.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_LOGOUT','Define the queue_log events that will count towards the LOGOUT counters/variables in reports, using a comma separated list. Usually you have AGENTLOGOFF and REMOVEMEMBER as events for login events in the queue_log file.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_RECEIVED','Define the queue_log events that will count towards the RECEIVED counters/variables in reports, using a comma separated list. All dispositions on the queue_log file that should add to a received call should be listed here, for example:<br/><br/>\r\nCOMPLETECALLER,COMPLETEAGENT,ABANDON,EXITEMPTY,EXITWITHKEY,EXITWITHTIMEOUT,TRANSFER',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_TRANSFERRED','Define the queue_log events that will count towards the TRANSFERRED counters/variables in reports, using a comma separated list. In a regular Asterisk setup, the only event associated with transfers is TRANSFER.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_EVENT_UNANSWERED','Define the queue_log events that will count towards the UNANSWERED counters/variables in reports, using a comma separated list. As an abandon call has its own variable, you should list here the rest of the unanswered dispositions, for example:<br/><br/>\r\nEXITWITHKEY,EXITEMPTY,EXITWITHTIMEOUT',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_REALTIME_COLUMN_WIDTHS','Comma separated list of column widths for realtime reports, where parameter is the report to modify, for example &#39;agent&#39;',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_REALTIME_DISPLAY_ROWS','Comma separated list of fields to show on the Realtime Queue Summary table. The fields are the one defined as COLUMN_REALTIME.<br/>\r\n<br/>\r\nparameter: group field (queue_summary)<br/>\r\nvalue: comma separated list of fields',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_TOTAL_COLUMN_ANSWERED','Formula to use for the Total row on Answered reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_TOTAL_COLUMN_DISTRIBUTION','Formula to use for the Total row on Distribution reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_TOTAL_COLUMN_REALTIME','Formula to use for the Total row on Realtime reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_TOTAL_COLUMN_UNANSWERED','Formula to use for the Total row on Unanswered reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_UNANSWERED_DISPLAY_GRID','If a chart is defined in the unanswered reports, parameter field, then use the grid layout width as setup in the value field. The grid system has 12 columns in total:<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: width1,width2',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_UNANSWERED_DISPLAY_ROWS','Comma separated list of fields to show on a specific Unanswered reports. The fields are the one defined as COLUMN_UNANSWERED.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_agent_filter','Regular Expression to filter unwanted Agents from initial selection.<br/> Example: <strong>Agent/[0-9][0-9][0-9][0-9]$</strong>\r\n\r\n\r\n\r\n',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_agent_reports','Comma separated list of reports to show on the Agent page. You must specify the correct .php file that displays the report you want on each element.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_agent_row_color','To paint the whole cell background to the status color for an agent in the realtime view, set this to 1',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_answered_reports','Comma separated list of reports to show on the Answered page. You must specify the correct .php file that displays the report you want on each element.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_asterisk_12','Set this to 1 if you are using Asterisk 1.2 or older, otherwise you will have some issues in the realtime view.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_asterisk_16','Set this to 1 if you are using Asterisk 1.6, otherwise you will have some issues in the realtime view.\n',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_asterisk_18','Set this to 1 if you are using Asterisk 1.8, otherwise you will have some issues in the realtime view.',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_avg_time_format','Format for average duration fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in drill down and detailed reports.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_call_flow','To have separate reports for outbound queues, set call_flow for them. The parameter must be the queue name/number and the value must be set to \\\\\\\"outbound\\\\\\\".',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_call_time_format','Format for the call duration fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in drill down and detailed reports.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_csv_separator','Separator character to use in CSV export files. Default value is comma (,) for Excel and friends. If you use LibreOffice/OpenOffice you might need to change it to semicolon (;)',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_custom_reports','Comma separated list of custom reports to show on a new/custom tab on the menu. The parameter is the tab name to display, and value is a comma separated list of .php scripts to load.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_date_format','Format for the date field, using MySQL syntax. Example: %%m-%%d-%%Y %%H:%%i:%%s. This is used on drill down or detailed reports only. The report format themselves are set in the designer.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_decimal_places','Number of decimal places to show on float numbers.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_default_end_hour','Default end hour in HH:SS format for the date/time selection.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_default_start_hour','Default start hour in HH:SS format for the date/time selection.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_detailed_agent_report','Show a detailed agent report in the Agent tab. (Similar to the drill down information you can get on a regular report, but already expanded for the complete date range selection).',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_dict_agent','Dictionary entry for Agents. It will replace the agent set as the parameter to the value you specify (So you can use names instead of interfaces).',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_dict_queue','Dictionary entry for Queues. Same as the agent dictionary, but for replacing queue names.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_distribution_interval','Interval in minutes to break up the distribution by hour report. By default it breaks by hour (60 minutes), but you can use smaller or larger values.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_distribution_reports','Comma separated list of reports to show on the Distribution page. You must specify the correct .php file that displays the report you want on each element.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_drilldown_records_per_page','Number of records per page to show when expanding/drilling down on any report.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_first_page','Initial page to load (Eg: answered.php, unanswered.php, distribution.php, agent.php). Can be set per user',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_freepbx_device_user_mode','Set this to 1 if you use FreePBX in user&device mode',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_hide_parsed_time','Set this to 1 to hide the parsed time information on the footer of every report.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_honor_timeframe_in_agent','Honor time frame selection in Agent Tab Reports. It will also try to compute missing events for the period if \nthey are not in the logs.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_ignore_none_abandons','If you do not want to count for inbound abandoned calls when selecting some agents from a report, set this parameter to one. This is useful for when you are tracking outbound campaigns and want to track performance per agent on outbound as it filters out the inbound abandoned calls that are assigned to the whole queue (agent NONE) and not a particular agent. If you select all agents for a report it will include also the NONE agent, so inbound abandons will count normally event if this parameter is set to one.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_language','Language to use. You can specify a user name in the parameter field to limit the language to a particular user. If the parameter field is left empty, then the language will be set for all users (global setting).',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_alert_subject','Subect to use when emailing alerts',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_mail_from_email','Schedule and Alert reports needs a FROM field to send emails.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_from_name','Schedule and Alert reports needs a NAME field to send emails.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_header_image','Image file to use as header for emails reports/alerts',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_report_subject','Subject to use when emailing reports',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_mail_smtp_password','Schedule and Alert reports, configure an SMTP password if needed.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_smtp_server','Schedule and Alert reports, configure the SMTP server for sending emails. SSL protocol example: ssl://smtp.server.com ; for TLS protocol: tls://smtp.server.com ; without encryption: smtp.server.com',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_smtp_server_port','Schedule and Alert reports, configure the SMTP port if needed.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_mail_smtp_username','Schedule and Alert reports, configure the SMTP username if needed.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_pbxware','Set this to 1 if you use PBXWare for the realtime view to work correctly',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_realtime_agent_sort','If set to \\\"status\\\", busy agents will be shown first on the realtime page.',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_realtime_alarm_call_duration','Alarm in seconds for call duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_alarm_last_call','Alarm in seconds for the last call information in the realtime view. Can be set per queue by setting the parameter to the queue name.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_alarm_pause_duration','Alarm in seconds for pause/break duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_alarm_row_color','Background row color when a value is in alarm in the realtime view.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_alarm_threshold','Threshold (in percentage) from which to start coloring in alarm calls in the realtime view.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_alarm_wait_count','Alarm (in number of calls) for calls waiting in a queue in the realtime view.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_alarm_wait_duration','Alarm in seconds for call waiting duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_coach_options','Options to pass to chanspy when launching a Coach action from the realtime view. You can use any options available to the asterisk chanspy application, like &quot;w&quot; to enable whispering, or &quot;d&quot; to use dtmf to switch modes: 4 spy, 5 whisper, 6 barge., etc.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_custom_pauses','If this value is set to 1 the realtime page will check the ASTDB for the PAUSECUSTOM/Agent family and it will show the pause code stored there for a particular Agent as stored in astdb Key. Eg: PAUSECUSTOM/Agent/1000 = Break:${EPOCH} stored in ASTDB will show Agent 1000 as break when paused.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_group_queues','Start the realtime view with a grouped queue display.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_hide_loggedoff','Start the realtime view without showing logged off Agents.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_last_hour_stats','Set this option if you want the call counters in the realtime view to show only the last hour counts, and not the whole day.',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_realtime_refresh','Refresh time in seconds for the realtime view.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_refresh_sql','Refresh time in seconds for statistics values on the queue summary table in the realtime view. Retrieving the information is cpu expensive, so you might want to leave it at the default value of 60 seconds or even higher if you have many supervisors checking the realt time view at the same time.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_reports','Comma separated list of reports to show on the Realtime page. You must specify the correct .php file that displays the report you want on each element.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_realtime_spy_device','Device used by the user (set in the parameter field). Example: SIP/1234',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_spy_extension','Extension to reach the supervisor phone when launching a call steal action in the realtime view. The parameter must be set to the asternic user name, the value could be the extension number followed by the context, for example: 100@from-internal',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_spy_options','Options to pass to chanspy when launching a Listen action from the realtime view. You can use any options available to the asterisk chanspy application, like &quot;q&quot; to disable the initial beep, etc.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_strict_interface_status','This setting will make the realtime view show status as returned by the asterisk queue application by means of the STATE INTERFACE options for the AddQueueMember application. It should be set to 1 in systems with Local type queue members with STATE INTERFACE set, like FreePBX 2.8 or higher.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_realtime_tracking_mode','If set, coaching sessions in the realtime view will not end when the call ends, so the supervisor continues pinned to the agent for subsequent calls.',1,'2017-10-13 20:06:01'),(NULL,'pt_br','help_text_recordings_path','Recordings location/directory in the hardrive to perform the direct download.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_session_time_format','Format for the session duration fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in the agent reports.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_setup_reports','Comma separated list of reports to show on the Setup page. You must specify the correct .php file that displays the report you want on each element.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_shared_lastcall','Compartir la información de último llamado entre colas. Sólo se mostrará el tiempo más corto para todas las colas. Si se utiliza rastreo de salientes y se guarda el valor astdb LASTCALL, será también tomado en cuenta.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_short_abandon_threshold','Ligações com duração abaixo deste valor nao serão consideradas no relatorio de abandono.',0,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_short_unanswered_threshold','Ignorar ligação curta: ligações menores do que este valor serão COMPLETAMENTE ignoradas. Se especificar nome da fila no parametro ai somente esta fila será afetada.',0,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_show_agent_call','Show end call events when drilling down on agent reports',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_show_agent_field','Mostrar columna de Agente en reportes de no atendidos (útil cuando se rastrean llamados salientes)',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_show_url_field','Enable and display the URL field and reports',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_sla_abandoned','Service Level value in seconds for Abandoned calls',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_sla_answered','Service Level value in seconds for Answered calls',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_sla_interval','Time interval in seconds to split the table for SLA (Service Level Agreement) and Abandon Rate reports.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_sla_steps','Number of steps to show in SLA (Service Level Agreement) and Abandon Rate reports.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_sla_transferred','Service Level value in seconds for Transferred calls',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_sla_unanswered','Service Level value in seconds for unanswered calls (not abandoned, but unanswered due to timeouts, exit with key, etc).',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_timeframe_interval','Interval in minutes to present the time frame selection on the home tab. Defaults to 15 minutes.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_timezone','Timezone Configuration for user, in the format [ -]HH:MM\r\n\r\nIf the user name is specified as parameter, then applies only to that user. If parameter is left blank it will be applied globally.',0,'2012-09-27 03:29:50'),(NULL,'pt_br','help_text_unanswered_reports','Comma separated list of reports to show on the Unanswered page. You must specify the correct .php file that displays the report you want on each element.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ABANDONED','Number of Abandoned calls (with EVENT_ABANDON disposition in queue_log)',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ABANDONED_SLA','Number of Abandoned calls (with EVENT_ABANDON disposition in queue_log) who&#146;s wait time was less or equal than sla_abandoned setting in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ABANDONED_WAIT_TIME','Wait time for abandoned calls for the particular grouped report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AGENTS_LOGGED_OFF','Number of Logged Off agents. Only available in COLUMN_REALTIME formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AGENTS_PAUSED','Number of Paused agents. Only available in COLUMN_REALTIME formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AGENTS_STAFFED','Number of Logged In/Available agents. Only available in COLUMN_REALTIME formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AGENTS_TALKING','Number of Agents engaged on a call. Only available in COLUMN_REALTIME formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ANSWERED','Number of Answered calls (with EVENT_ANSWERED disposition in the queue_log file) for the particular grouped report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ANSWERED_SLA','Number of Anaswered calls (with EVENT_ANSWERED disposition in queue_log) who&#146;s wait time was less or equal than sla_answered setting in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ANSWERED_TALK_TIME','Talk Time of Answered Calls for the particular grouped report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ANSWERED_WAIT_TIME','Wait Time of Answered Calls for the particular grouped report. (Wait Time is the time an user was waiting on the queue before being connected to an agent, it only counts the time since the queue was entered, it does not count potential previous times like IVRs, etc.)',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ABANDONED','Average of Abandoned Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ABANDONED_SLA','Average of Abandoned Calls that where waiting less or equal abandoned_sla time as setup in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ABANDONED_WAIT_TIME','Average Wait Time for Abandoned Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ANSWERED','Average number of Answered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ANSWERED_SLA','Average number of Answered Calls that were waiting for less or equal than answered_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ANSWERED_TALK_TIME','Average Talk Time for Answered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_ANSWERED_WAIT_TIME','Average Wait Time for Answered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_LOGIN','Average number of Agent Logins',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_LOGOUT','Average number of Agents Logoffs',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_RECEIVED','Average number of Received Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_TRANSFERRED','Average number of Transferred Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_TRANSFERRED_SLA','Average number of Transferred Calls that were waiting for less or equal than transferred_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_TRANSFERRED_TALK_TIME','Average Talk Time of Transferred Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_TRANSFERRED_WAIT_TIME','Average Wait Time of Transferred Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_UNANSWERED','Average number of Unanswered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_UNANSWERED_SLA','Average number of Unanswered Calls that had a wait time of less or equal seconds as set in unanswered_sla in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_AVG_UNANSWERED_WAIT_TIME','Average Wait Time for Unanswered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_CALLS_WAITING','Number of Calls Waiting. Only available in COLUMN_REALTIME formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_LOGIN','Number of Agent Logins.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_LOGOUT','Number of Agent Logoffs.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_ABANDONED_WAIT_TIME','Maximum Wait Time in Abandoned Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_ANSWERED_TALK_TIME','Maximum Talk Time in Answered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_ANSWERED_WAIT_TIME','Maximum Wait Time in Answered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_CALLERS_WAITING','Maximum number of callers waiting in the queue.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_COL','Maximum value for the column, to be used in TOTAL formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_TRANSFERRED_TALK_TIME','Maximum Talk Time for Transferred Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_TRANSFERRED_WAIT_TIME','Maximum Wait Time for Transferred Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_UNANSWERED_WAIT_TIME','Maximum Wait Time for Unanswered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MAX_WAIT_TIME','Maximum Wait Time for the particular grouped report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_ABANDONED_WAIT_TIME','Minimum Wait Time in Abandoned Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_ANSWERED_TALK_TIME','Minimum Talk Time in Answered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_ANSWERED_WAIT_TIME','Minimum Wait Time in Answered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_COL','Minimum value for the column, to be used in TOTAL formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_TRANSFERRED_TALK_TIME','Minimum Talk Time for Transferred Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_TRANSFERRED_WAIT_TIME','Minimum Wait Time for Transferred Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_MIN_UNANSWERED_WAIT_TIME','Minimum Wait Time for Unanswered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_RECEIVED','Number of Received calls (with EVENT_RECEIVED disposition in the queue_log file) for the particular grouped report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_ROW_COUNT','Number of Rows on the report. To be used in TOTAL formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ABANDONED','Sum of Abandoned calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ABANDONED_SLA','Sum of Abandoned calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_abandoned seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ABANDONED_WAIT_TIME','Sum of Wait Time for Abandoned Calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ANSWERED','Sum of Answered Calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ANSWERED_SLA','Sum of Answered Calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_answered seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ANSWERED_TALK_TIME','Sum of Talk Time for Answered calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_ANSWERED_WAIT_TIME','Sum of Wait Time for Answered calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_COL','Sum of all values for a particular column. To be used in TOTAL formulas.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_LOGIN','Sum of Login events up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_LOGOUT','Sum of Logoff events up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_RECEIVED','Sum of Received Calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_TRANSFERRED','Sum of Transferred Calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_TRANSFERRED_SLA','Sum of Transferred Calls up to the particular row in a report, who&#146;s wait time is less or equal than sla_transferred seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_TRANSFERRED_TALK_TIME','Sum of Talk Time for Transferred calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_TRANSFERRED_WAIT_TIME','Sum of Wait Time for Transferred calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_UNANSWERED','Sum of Unanswered calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_UNANSWERED_SLA','Sum of Unanswered calls up to the particular row in a report, who&#146;s wait time is less or equal than transferred_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_SUM_UNANSWERED_WAIT_TIME','Sum of Wait Time for Transferred calls up to the particular row in a report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ABANDONED','Total number of Abandoned Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ABANDONED_SLA','Total number of Abandoned calls who&#146;s wait time is less or equal than abandoned_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ABANDONED_WAIT_TIME','Total Wait Time for Abandoned Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ANSWERED','Total number of Answered calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ANSWERED_SLA','Total number of Answered calls who&#146;s wait time is less or equal than answered_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ANSWERED_TALK_TIME','Total Talk Time for Answered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_ANSWERED_WAIT_TIME','Total Wait Time for Answered Calls',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_LOGIN','Total number of Login events.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_LOGOUT','Total number of Logoff events.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_RECEIVED','Total number of Received calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_TRANSFERRED','Total number of Transferred calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_TRANSFERRED_SLA','Total of Transferred Calls that have a wait time of less or equal transferred_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_TRANSFERRED_TALK_TIME','Total Talk Time for Transferred Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_TRANSFERRED_WAIT_TIME','Total Wait Time for Transferred Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_UNANSWERED','Total number of Unanswered Calls.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_UNANSWERED_SLA','Total of Unanswered Calls that have a wait time of less or equal unanswered_sla seconds as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TOTAL_UNANSWERED_WAIT_TIME','Wait Time for Unanswered Calls for the whole set of data.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TRANSFERRED','Number of Transferred Calls (with EVENT_TRANSFERRED disposition in queue_log)',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TRANSFERRED_SLA','Number of Transferred Calls (with EVENT_TRANSFERRED disposition in queue_log) who&#146;s wait time is less or equal than transferred_sla as set in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TRANSFERRED_TALK_TIME','Talk Time for Transferred Calls for a particular row.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_TRANSFERRED_WAIT_TIME','Wait Time for Transferred Calls for a particular row.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_UNANSWERED','Number of Unanswered calls (with EVENT_UNANSWERED disposition in the queue_log file) for the particular grouped report.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_UNANSWERED_SLA','Number of Unanswered calls (with EVENT_UNANSWERED disposition in queue_log) who&#146;s wait time was less or equal than sla_unanswered setting in Preferences.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_variable_UNANSWERED_WAIT_TIME','Wait Time for Unanswered Calls for a particular row.',1,'0000-00-00 00:00:00'),(NULL,'pt_br','help_text_wait_time_format','Format for the wait time fields. HH = hours, MM=minutes, SS=seconds, mm=full minutes, ss=full seconds. Used in drill down and detailed reports.',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_week_mode','When to start counting weeks from the year:<br><pre>\r\nMode    First day of week       Range   Week 1 is the first week ...\r\n0       Sunday                  0-53    with a Sunday in this year\r\n1       Monday                  0-53    with more than 3 days this year\r\n2       Sunday                  1-53    with a Sunday in this year\r\n3       Monday                  1-53    with more than 3 days this year\r\n4       Sunday                  0-53    with more than 3 days this year\r\n5       Monday                  0-53    with a Monday in this year\r\n6       Sunday                  1-53    with more than 3 days this year\r\n7       Monday                  1-53    with a Monday in this year\r\n</pre>',1,'2012-10-02 04:24:54'),(NULL,'pt_br','help_text_wrap_up','Optinoal wrap_up time, it can be set globally or per queue. This value will affect the AHL (Average Handling Time) numbers in reports.',1,'2017-10-13 20:06:01'),(NULL,'pt_br','hours','horas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','info1','Info 1',0,'0000-00-00 00:00:00'),(NULL,'pt_br','info2','info 2',0,'0000-00-00 00:00:00'),(NULL,'pt_br','info3','Info 3',0,'0000-00-00 00:00:00'),(NULL,'pt_br','info4','Info 4',0,'0000-00-00 00:00:00'),(NULL,'pt_br','info5','Info 5',0,'0000-00-00 00:00:00'),(NULL,'pt_br','none','Nenhum',0,'2012-09-22 05:45:37'),(NULL,'pt_br','of','de',0,'2012-10-02 22:18:52'),(NULL,'pt_br','on %s since %s seconds ago','em %s desde %s segundos',0,'2012-09-22 05:45:37'),(NULL,'pt_br','on %s since %s secs ago','ativo %s á %s secs',0,'2012-09-22 05:45:37'),(NULL,'pt_br','on days','dias ativos',0,'2012-10-02 22:18:52'),(NULL,'pt_br','on hours','horas ativas',0,'2012-10-02 22:18:52'),(NULL,'pt_br','on minutes','minutos ativos',0,'2012-10-02 22:18:52'),(NULL,'pt_br','partial','parcial',0,'2012-09-22 05:45:37'),(NULL,'pt_br','realtime-agent-busy','Ocupado',0,'2012-09-26 04:17:47'),(NULL,'pt_br','realtime-agent-dialout','Lig. Ativa',0,'2012-09-22 05:45:37'),(NULL,'pt_br','realtime-agent-hold','Em Espera',0,'2012-09-22 05:45:37'),(NULL,'pt_br','realtime-agent-not in use','Logado',0,'2012-10-02 22:18:50'),(NULL,'pt_br','realtime-agent-ringing','Tocando',0,'2012-09-26 04:33:52'),(NULL,'pt_br','realtime-agent-unavailable','Não Logado',0,'2012-09-26 04:18:44'),(NULL,'pt_br','realtime_queue_summary','Resumo Fila',0,'2012-10-02 22:18:50'),(NULL,'pt_br','seconds','segundos',0,'2012-09-22 05:45:37'),(NULL,'pt_br','unanswered_calls_by_event','Ligaçoes Nao atendidas - Por Evento',0,'2012-10-02 22:19:07'),(NULL,'pt_br','unanswered_calls_by_holdtime','Nivel de Servico',0,'2012-10-02 22:19:07'),(NULL,'pt_br','unanswered_calls_by_queue','Ligações Não atendidas - Por fila',0,'2012-10-02 22:19:07'),(NULL,'pt_br','unanswered_calls_by_url','Nao atendidas - Por URL',0,'2012-10-02 22:19:07'),(NULL,'pt_br','unanswered_calls_detail','Ligações Não atendidas - Detalhes',0,'2012-10-02 22:19:07'),(NULL,'pt_br','unanswered_calls_summary','Resumo Ligações Não Atendidas',0,'2012-10-02 22:19:07'),(NULL,'pt_br','within','dentro de ',0,'2012-09-22 05:45:37'),(NULL,'pt_br','within %d%s seconds','%d%s segundos',0,'2012-10-02 22:17:26');

INSERT INTO `language` VALUES (NULL,'ru','%','%',0,'0000-00-00 00:00:00'),(NULL,'ru','%%','%%',0,'0000-00-00 00:00:00'),(NULL,'ru','%% Answ','%% Отвеченных',0,'0000-00-00 00:00:00'),(NULL,'ru','%% Calls','%% Вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','%% Paused','%% Приостановленных',0,'0000-00-00 00:00:00'),(NULL,'ru','%% Talk Time','%% Продолжительности разговора',0,'0000-00-00 00:00:00'),(NULL,'ru','%% Unansw','%% Неотвеченных',0,'0000-00-00 00:00:00'),(NULL,'ru','%s','%в',0,'0000-00-00 00:00:00'),(NULL,'ru','%s %%','%в %%',0,'0000-00-00 00:00:00'),(NULL,'ru','%s days','%s дней',0,'0000-00-00 00:00:00'),(NULL,'ru','%s min. ago','%s минут назад',0,'0000-00-00 00:00:00'),(NULL,'ru','%s minutes','%s минут',0,'0000-00-00 00:00:00'),(NULL,'ru','%s records deleted','%s удаленных записей',0,'0000-00-00 00:00:00'),(NULL,'ru','%s secs','%s секунд',0,'0000-00-00 00:00:00'),(NULL,'ru','ABANDON','Несостоявшийся',0,'0000-00-00 00:00:00'),(NULL,'ru','ALL','ВСЕГО',0,'0000-00-00 00:00:00'),(NULL,'ru','Abandon Avg Queue Position at Disconnection','Среднее положение в очереди до отмены вызова во время разъединения Abandon Avg Queue Position at Disconnection',0,'0000-00-00 00:00:00'),(NULL,'ru','Abandon Avg Queue Start Position','Среднее начальное положение в очереди до отмены вызова Abandon Avg Queue Start Position',0,'0000-00-00 00:00:00'),(NULL,'ru','Abandon Avg Wait Before Disconnection','Среднее время ожидания отмены вызова до разъединения',0,'0000-00-00 00:00:00'),(NULL,'ru','Abandon Rate','Частота отмены вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Abandoned','Несостоявшийся',0,'0000-00-00 00:00:00'),(NULL,'ru','Abandoned Calls','Несостоявшиеся вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Actions','Действия',0,'0000-00-00 00:00:00'),(NULL,'ru','Active','Активировать',0,'0000-00-00 00:00:00'),(NULL,'ru','Add','Добавить',0,'0000-00-00 00:00:00'),(NULL,'ru','Add Record','Добавить запись',0,'0000-00-00 00:00:00'),(NULL,'ru','Agent','Оператор',0,'0000-00-00 00:00:00'),(NULL,'ru','Agent Status','Статус оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','Agent Totals','Всего операторов',0,'0000-00-00 00:00:00'),(NULL,'ru','Agents','Операторы',0,'0000-00-00 00:00:00'),(NULL,'ru','Alert','Уведомление',0,'0000-00-00 00:00:00'),(NULL,'ru','Alerts','Уведомления',0,'0000-00-00 00:00:00'),(NULL,'ru','All %s records are selected.','Все записи выбраны.',0,'0000-00-00 00:00:00'),(NULL,'ru','All %s records on this page are selected.','Все записи на странице выбраны.',0,'0000-00-00 00:00:00'),(NULL,'ru','An error has occurred','Произошла ошибка',0,'0000-00-00 00:00:00'),(NULL,'ru','Answer','Ответить',0,'0000-00-00 00:00:00'),(NULL,'ru','Answered','Отвеченный вызов',0,'0000-00-00 00:00:00'),(NULL,'ru','Answered Calls','Отвеченные вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Answered by Day','Отвеченные вызовы по дням',0,'0000-00-00 00:00:00'),(NULL,'ru','Answered/Abandoned','Отвеченный/Несостоявшийся',0,'0000-00-00 00:00:00'),(NULL,'ru','Answered/Abandoned per Hour','Количество отвеченных/несостоявшихся вызовов в час',0,'0000-00-00 00:00:00'),(NULL,'ru','April','Апрель',0,'0000-00-00 00:00:00'),(NULL,'ru','Are you sure?','Вы уверены?',0,'0000-00-00 00:00:00'),(NULL,'ru','August','Август',0,'0000-00-00 00:00:00'),(NULL,'ru','Available','Доступные',0,'0000-00-00 00:00:00'),(NULL,'ru','Available Keywords','Доступные ключевые слова',0,'0000-00-00 00:00:00'),(NULL,'ru','Available Variables','Доступные значения',0,'0000-00-00 00:00:00'),(NULL,'ru','Average Duration by Day','Средняя продолжительность в день',0,'0000-00-00 00:00:00'),(NULL,'ru','Average Session Time','Среднее время обработки вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Average Wait Time by Day','Среднее время ожидания в день',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg Duration','Средняя продолжительность',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg Talk','Среднее время разговора',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg Talk Time','Среднее время разговора',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg Wait','Среднее время ожидания',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg Wait Time','Среднее время ожидания',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg. Paused','Среднее количество приостановленных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg. Session','Среднее время обработки вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Avg. Session Time','Среднее время обработки вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Back','Назад',0,'0000-00-00 00:00:00'),(NULL,'ru','Bad username or password','Неверное имя пользователя или пароль',0,'0000-00-00 00:00:00'),(NULL,'ru','Busy','Занято',0,'0000-00-00 00:00:00'),(NULL,'ru','COMPLETEAGENT','Завершено оператором Complete by Agent',0,'0000-00-00 00:00:00'),(NULL,'ru','COMPLETECALLER','Завершено абонентом Complete by Caller',0,'0000-00-00 00:00:00'),(NULL,'ru','Caller ID','Идентификатор абонента',0,'0000-00-00 00:00:00'),(NULL,'ru','Calls','Звонки',0,'0000-00-00 00:00:00'),(NULL,'ru','Calls Waiting Detail','Информация о вызовах, находящихся в ожидании',0,'0000-00-00 00:00:00'),(NULL,'ru','Campaigns','Campaigns',1,'2017-10-13 20:06:03'),(NULL,'ru','Cancel','Отмена',0,'0000-00-00 00:00:00'),(NULL,'ru','Cannot steal call. realtime_spy_extension for user <b>%s</b> is not defined in Setup/Preferences.','Невозможно перехватить вызов. Параметр realtime_spy_extension для пользователя <b>%s</b> не задан в разделе \"Установки/Настройки\".',0,'0000-00-00 00:00:00'),(NULL,'ru','Clear Selection','Снять выделение',0,'0000-00-00 00:00:00'),(NULL,'ru','Click to add text','Нажмите, чтобы добавить текст',0,'0000-00-00 00:00:00'),(NULL,'ru','Click to edit...','Нажмите, чтобы отредактировать',0,'0000-00-00 00:00:00'),(NULL,'ru','Click to view calls in detail','Нажмите, чтобы просмотреть описание вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Coach','Инструктор',0,'0000-00-00 00:00:00'),(NULL,'ru','Completed','Завершено',0,'0000-00-00 00:00:00'),(NULL,'ru','Confirm','Подтвердить',0,'0000-00-00 00:00:00'),(NULL,'ru','Could not connect to the Asterisk Manager Interface to retrieve status information. Please check your manager credentials in config.php and verify they match your settings in /etc/asterisk/manager.conf','Не удалось соединиться с Asterisk Manager Interface для получения информации о статусе. Пожалуйста, проверьте Ваши учетные данные в файле config.php и убедитесь, что они соответствуют данным, указанным в файле /etc/asterisk/manager.conf.',0,'0000-00-00 00:00:00'),(NULL,'ru','Could not copy uploaded file','Could not copy uploaded file',1,'2017-10-13 20:06:03'),(NULL,'ru','Count','Подсчитать',0,'0000-00-00 00:00:00'),(NULL,'ru','Cron Configuration','Конфигурация планировщика',0,'0000-00-00 00:00:00'),(NULL,'ru','Dashboard','Dashboard',1,'2017-10-13 20:06:03'),(NULL,'ru','Date','Дата',0,'0000-00-00 00:00:00'),(NULL,'ru','Day','День',0,'0000-00-00 00:00:00'),(NULL,'ru','December','Декабрь',0,'0000-00-00 00:00:00'),(NULL,'ru','Delete','Удалить',0,'0000-00-00 00:00:00'),(NULL,'ru','Delete Marked','Удалить отмеченные',0,'0000-00-00 00:00:00'),(NULL,'ru','Delta','Разница',0,'0000-00-00 00:00:00'),(NULL,'ru','Deselects all','Удалить все',0,'0000-00-00 00:00:00'),(NULL,'ru','Deselects marked','Удалить отмеченные',0,'0000-00-00 00:00:00'),(NULL,'ru','Dialer','Dialer',1,'2017-10-13 20:06:03'),(NULL,'ru','Display Report','Показать отчет',0,'0000-00-00 00:00:00'),(NULL,'ru','Distribution','Распределение вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Download','Загрузить',0,'0000-00-00 00:00:00'),(NULL,'ru','Duration','Продолжительность',0,'0000-00-00 00:00:00'),(NULL,'ru','EXITWITHKEY','Выход по нажатию клавиши',0,'0000-00-00 00:00:00'),(NULL,'ru','EXITWITHTIMEOUT','Время ожидания истекло',0,'0000-00-00 00:00:00'),(NULL,'ru','Edit Email Alert','Редактировать уведомление электронной почтой',0,'0000-00-00 00:00:00'),(NULL,'ru','Edit Record','Редактировать запись',0,'0000-00-00 00:00:00'),(NULL,'ru','Edit Scheduled Report','Редактировать запланированный отчет',0,'0000-00-00 00:00:00'),(NULL,'ru','Email','Email',0,'0000-00-00 00:00:00'),(NULL,'ru','Empty file?','Empty file?',1,'2017-10-13 20:06:03'),(NULL,'ru','End Date','Дата окончания',0,'0000-00-00 00:00:00'),(NULL,'ru','End Position','Конечная позиция',0,'0000-00-00 00:00:00'),(NULL,'ru','Error inserting record:<br/>','Ошибка внесения записи:<br/>',0,'0000-00-00 00:00:00'),(NULL,'ru','Error updating record','Ошибка обновления записи',0,'0000-00-00 00:00:00'),(NULL,'ru','Event','Событие',0,'0000-00-00 00:00:00'),(NULL,'ru','Example','Например',0,'0000-00-00 00:00:00'),(NULL,'ru','Export','Экспортировать',0,'0000-00-00 00:00:00'),(NULL,'ru','Exports the data to a .pdf file','Экспортирует данные в файл .pdf',0,'0000-00-00 00:00:00'),(NULL,'ru','Exports the data to a comma separated file, to be read by your spreadsheet software','Экспортирует данные в файл с разделением значений запятыми для последующего использования программами для работы с электронными таблицами.',0,'0000-00-00 00:00:00'),(NULL,'ru','Fails','Неудачи',0,'2013-07-03 06:05:03'),(NULL,'ru','February','Февраль',0,'0000-00-00 00:00:00'),(NULL,'ru','Filter','Фильтр',0,'0000-00-00 00:00:00'),(NULL,'ru','Filter report by Caller Id','Отсортировать отчет по индентификатору абонента',0,'0000-00-00 00:00:00'),(NULL,'ru','First','Первая',0,'0000-00-00 00:00:00'),(NULL,'ru','Friday','Пятница',0,'0000-00-00 00:00:00'),(NULL,'ru','From','От',0,'0000-00-00 00:00:00'),(NULL,'ru','From the last (X) days','За последние (X) дней',0,'0000-00-00 00:00:00'),(NULL,'ru','Generate','Generate',1,'2017-10-13 20:06:03'),(NULL,'ru','Generate Offline License Request','Генерирует автономный запрос на лицензию.',0,'0000-00-00 00:00:00'),(NULL,'ru','Goes to the top of the page','Переходит на начало страницы',0,'0000-00-00 00:00:00'),(NULL,'ru','Group by Queue','Сгруппировать по очереди',0,'0000-00-00 00:00:00'),(NULL,'ru','Help','Справка',0,'0000-00-00 00:00:00'),(NULL,'ru','Hide Logged off','Скрыть незарегистрированных операторов',0,'0000-00-00 00:00:00'),(NULL,'ru','Higher ...','Последующие...',0,'0000-00-00 00:00:00'),(NULL,'ru','Home','Главная страница',0,'0000-00-00 00:00:00'),(NULL,'ru','Hour','Час',0,'0000-00-00 00:00:00'),(NULL,'ru','Hour Range','Диапазон часов',0,'0000-00-00 00:00:00'),(NULL,'ru','Hours','Час',0,'0000-00-00 00:00:00'),(NULL,'ru','ISO Code','Код ISO',0,'0000-00-00 00:00:00'),(NULL,'ru','Idle Time','время простоя',0,'2013-07-03 05:36:50'),(NULL,'ru','If the field value is higher than this number you will receive an alerting email','Если значение поля выше заданного числа, Вы получите предупреждение по электронной почте.',0,'0000-00-00 00:00:00'),(NULL,'ru','Ignoring field ','Ignoring field ',1,'2017-10-13 20:06:03'),(NULL,'ru','Import','Импортировать',0,'0000-00-00 00:00:00'),(NULL,'ru','In order to receive scheduled reports or alerts via email, you must setup a cron job in the server. You can use the following command in your server command line:<br/><br/>crontab -e<br/><br/>and add the following line (replacing the user and password with a valid user/password):<br/><br/>','Чтобы получать запланированные отчеты или уведомления электронной почтой, Вам необходимо настроить работу планировщика на сервере. Для этого в командной строке (на сервере) введите следующую команду: <br/><br/>crontab -e<br/><br/> и добавьте следующую строку (вместо user и password введите действующие имя пользователя и пароль): <br/><br/> .',0,'0000-00-00 00:00:00'),(NULL,'ru','Incompleted Calls','Незавершенные вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Invalid Date','Недопустимая дата',0,'0000-00-00 00:00:00'),(NULL,'ru','Invalid Hour','Недопустимый час',0,'0000-00-00 00:00:00'),(NULL,'ru','January','Январь',0,'0000-00-00 00:00:00'),(NULL,'ru','July','Июль',0,'0000-00-00 00:00:00'),(NULL,'ru','June','Июнь',0,'0000-00-00 00:00:00'),(NULL,'ru','Last','Последняя',0,'0000-00-00 00:00:00'),(NULL,'ru','Last in Call','Последний оператор вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Last three months','Последние три месяца',0,'0000-00-00 00:00:00'),(NULL,'ru','Level','Права доступа',0,'0000-00-00 00:00:00'),(NULL,'ru','License Handling','Обработка лицензии',0,'0000-00-00 00:00:00'),(NULL,'ru','License validation problem','Ошибка проверки лицензии',0,'0000-00-00 00:00:00'),(NULL,'ru','Licensed to','Лицензия выдана для',0,'0000-00-00 00:00:00'),(NULL,'ru','Listen','Прослушать',0,'0000-00-00 00:00:00'),(NULL,'ru','Lists','Lists',1,'2017-10-13 20:06:03'),(NULL,'ru','Loading','Идет загрузка',0,'0000-00-00 00:00:00'),(NULL,'ru','Logged Off','Вышел из системы',0,'0000-00-00 00:00:00'),(NULL,'ru','Login','Логин',0,'0000-00-00 00:00:00'),(NULL,'ru','Login Form','Форма регистрации',0,'0000-00-00 00:00:00'),(NULL,'ru','Logins','Имя пользователя',0,'0000-00-00 00:00:00'),(NULL,'ru','Logoff','Выход из системы',0,'0000-00-00 00:00:00'),(NULL,'ru','Logout','Выйти',0,'0000-00-00 00:00:00'),(NULL,'ru','Longest Session','Максимальная длительность вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Lower ...','Предыдущие...',0,'0000-00-00 00:00:00'),(NULL,'ru','March','Март',0,'0000-00-00 00:00:00'),(NULL,'ru','Max Callers','Максимальное количество абонентов',0,'0000-00-00 00:00:00'),(NULL,'ru','Max Wait Time','Максимальное время ожидания',0,'0000-00-00 00:00:00'),(NULL,'ru','Max. wait time','Максимальное время ожидания',0,'0000-00-00 00:00:00'),(NULL,'ru','May','Май',0,'0000-00-00 00:00:00'),(NULL,'ru','Minutes','Минута',0,'0000-00-00 00:00:00'),(NULL,'ru','Monday','Понедельник',0,'0000-00-00 00:00:00'),(NULL,'ru','Month','Месяц',0,'0000-00-00 00:00:00'),(NULL,'ru','Month days','День месяца',0,'0000-00-00 00:00:00'),(NULL,'ru','Name','Имя',0,'0000-00-00 00:00:00'),(NULL,'ru','New Email Alert','Создать уведомление электронной почтой',0,'0000-00-00 00:00:00'),(NULL,'ru','New Scheduled Report','Создать запланированный отчет',0,'0000-00-00 00:00:00'),(NULL,'ru','Next','Следующая',0,'0000-00-00 00:00:00'),(NULL,'ru','No','Нет',0,'0000-00-00 00:00:00'),(NULL,'ru','No active channel','Нет активного канала',0,'0000-00-00 00:00:00'),(NULL,'ru','No info','Информация отсутствует',0,'0000-00-00 00:00:00'),(NULL,'ru','No records found','Записей не найдено',0,'0000-00-00 00:00:00'),(NULL,'ru','No results','Нет результатов',0,'0000-00-00 00:00:00'),(NULL,'ru','No valid fields to import!','No valid fields to import!',1,'2017-10-13 20:06:03'),(NULL,'ru','None','Отсутствует',0,'0000-00-00 00:00:00'),(NULL,'ru','Notice','Уведомление',0,'0000-00-00 00:00:00'),(NULL,'ru','November','Ноябрь',0,'0000-00-00 00:00:00'),(NULL,'ru','Number','Номер',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Abandoned Calls','Количество несостоявшихся вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Agent Logins','Количество входов оператора в систему',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Agent Logoffs','Количество выходов оператора из системы',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Agents','Количество операторов',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Answered Calls','Количество отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Calls per Agent','Количество вызовов на одного оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Outbound Calls','Количество исходящих звонков',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Received Calls','Количество принятых вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Transferred Calls','Количество переадресованных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Number of Unanswered Calls','Количество неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Numbers','Numbers',1,'2017-10-13 20:06:03'),(NULL,'ru','OK','OK',0,'0000-00-00 00:00:00'),(NULL,'ru','October','Октябрь',0,'0000-00-00 00:00:00'),(NULL,'ru','Outbound Calls','Исходящие вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Overflow','Переполнение',0,'0000-00-00 00:00:00'),(NULL,'ru','Page','Страница',0,'0000-00-00 00:00:00'),(NULL,'ru','Page parsed in %s seconds','Страница проанализирована %s секунд',0,'0000-00-00 00:00:00'),(NULL,'ru','Password','Пароль',0,'0000-00-00 00:00:00'),(NULL,'ru','Passwords do not match','Пароли не совпадают',0,'0000-00-00 00:00:00'),(NULL,'ru','Pause Time','Длительность паузы',0,'0000-00-00 00:00:00'),(NULL,'ru','Paused','Поставлено на паузу',0,'0000-00-00 00:00:00'),(NULL,'ru','Pauses','Паузы',0,'0000-00-00 00:00:00'),(NULL,'ru','Pauses per Session','Количество пауз во время вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Pending','Ожидание',0,'0000-00-00 00:00:00'),(NULL,'ru','Period','Период',0,'0000-00-00 00:00:00'),(NULL,'ru','Play','Воспроизвести',0,'0000-00-00 00:00:00'),(NULL,'ru','Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use','Пожалуйста, скопируйте текст выше и отправьте электронным письмом для обработки. В письме укажите код активации и имя владельца лицензии, которую Вы используете. Please copy the above text and send it via email to %s for processing, together with your activation code and the licensee name you want to use',0,'0000-00-00 00:00:00'),(NULL,'ru','Please select the reports to send','Выберите отчеты для отправки',0,'0000-00-00 00:00:00'),(NULL,'ru','Please write down destination emails','Введите электронные адреса',0,'0000-00-00 00:00:00'),(NULL,'ru','Position','Рабочее место',0,'0000-00-00 00:00:00'),(NULL,'ru','Previous','Предыдущая',0,'0000-00-00 00:00:00'),(NULL,'ru','Proceed','Продолжить',0,'0000-00-00 00:00:00'),(NULL,'ru','Querying data...','Идет запрос данных...',0,'0000-00-00 00:00:00'),(NULL,'ru','Queue','Очередь',0,'0000-00-00 00:00:00'),(NULL,'ru','Queues','Очереди',0,'0000-00-00 00:00:00'),(NULL,'ru','RINGNOANSWER','Не удалось ответить на вызов',0,'0000-00-00 00:00:00'),(NULL,'ru','Reactivate','Возобновить',0,'0000-00-00 00:00:00'),(NULL,'ru','Realtime','Реальное время',0,'0000-00-00 00:00:00'),(NULL,'ru','Received','Получено',0,'0000-00-00 00:00:00'),(NULL,'ru','Record deleted','Запись удалена',0,'0000-00-00 00:00:00'),(NULL,'ru','Record inserted','Запись вставлена',0,'0000-00-00 00:00:00'),(NULL,'ru','Record updated','Запись обновлена',0,'0000-00-00 00:00:00'),(NULL,'ru','Records imported','Records imported',1,'2017-10-13 20:06:03'),(NULL,'ru','Report','Отчет',0,'0000-00-00 00:00:00'),(NULL,'ru','Reports','Отчеты',0,'0000-00-00 00:00:00'),(NULL,'ru','Required field','Обязательное поле',0,'0000-00-00 00:00:00'),(NULL,'ru','Revoke','Удалить',0,'0000-00-00 00:00:00'),(NULL,'ru','Revoke Current License','Удалить текущую лицензию',0,'0000-00-00 00:00:00'),(NULL,'ru','SLA','Соглашение об уровне обслуживания',0,'0000-00-00 00:00:00'),(NULL,'ru','Saturday','Суббота',0,'0000-00-00 00:00:00'),(NULL,'ru','Save','Сохранить',0,'0000-00-00 00:00:00'),(NULL,'ru','Scheduled Reports and Alerts','Запланированные отчеты и уведомления',0,'0000-00-00 00:00:00'),(NULL,'ru','Search','Поиск',0,'0000-00-00 00:00:00'),(NULL,'ru','Seconds','Секунды',0,'0000-00-00 00:00:00'),(NULL,'ru','Select Agents','Выбрать оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','Select Date Range','Выбрать диапазон дат',0,'0000-00-00 00:00:00'),(NULL,'ru','Select Queues','Выбрать очередь',0,'0000-00-00 00:00:00'),(NULL,'ru','Select Time Frame','Выбрать промежуток времени',0,'0000-00-00 00:00:00'),(NULL,'ru','Select all %s records.','Выбрать все записи.',0,'0000-00-00 00:00:00'),(NULL,'ru','Select an option','Выберите один вариант',0,'0000-00-00 00:00:00'),(NULL,'ru','Select language','Выбрать язык',0,'0000-00-00 00:00:00'),(NULL,'ru','Select option','Выбрать параметр',0,'0000-00-00 00:00:00'),(NULL,'ru','Select some options','Выберите несколько вариантов',0,'0000-00-00 00:00:00'),(NULL,'ru','Select the field to compare','Выберите поле для сравнения',0,'0000-00-00 00:00:00'),(NULL,'ru','Select the report to check','Выберите отчет для проверки',0,'0000-00-00 00:00:00'),(NULL,'ru','Select the report to control','Выберите отчет для управления Select the report to control',0,'0000-00-00 00:00:00'),(NULL,'ru','Selected','Выбранные',0,'0000-00-00 00:00:00'),(NULL,'ru','Selects all','Выбрать все',0,'0000-00-00 00:00:00'),(NULL,'ru','Selects marked','Выбрать отмеченные',0,'0000-00-00 00:00:00'),(NULL,'ru','Separate with comma ( , )<br>* means all','Разделяются запятой ( , )<br>* - все дни',0,'0000-00-00 00:00:00'),(NULL,'ru','September','Сентябрь',0,'0000-00-00 00:00:00'),(NULL,'ru','Server Time','Время на сервере',0,'0000-00-00 00:00:00'),(NULL,'ru','Session Time','Время обработки вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Sessions','Вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Setup','Настройки',0,'0000-00-00 00:00:00'),(NULL,'ru','Shortcuts','Быстрый доступ',0,'0000-00-00 00:00:00'),(NULL,'ru','Shortest Session Time','Минимальная длительность вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Spy','Подслушать',0,'0000-00-00 00:00:00'),(NULL,'ru','Start Date','Дата начала',0,'0000-00-00 00:00:00'),(NULL,'ru','Start Position','Начальная позиция',0,'0000-00-00 00:00:00'),(NULL,'ru','State','Состояние',0,'0000-00-00 00:00:00'),(NULL,'ru','Steal','Перехватить',0,'0000-00-00 00:00:00'),(NULL,'ru','String','Строка',0,'0000-00-00 00:00:00'),(NULL,'ru','Success!','Завершено успешно!',0,'0000-00-00 00:00:00'),(NULL,'ru','Sunday','Воскресенье',0,'0000-00-00 00:00:00'),(NULL,'ru','TRANSFER','Transfer',0,'0000-00-00 00:00:00'),(NULL,'ru','Talk Time','Время разговора',0,'0000-00-00 00:00:00'),(NULL,'ru','There is no valid license file on this installation yet.','Отсутствует файл действующей лицензии. There is no valid license file on this installation yet.',0,'0000-00-00 00:00:00'),(NULL,'ru','This month','Текущий месяц',0,'0000-00-00 00:00:00'),(NULL,'ru','This week','Текущая неделя',0,'0000-00-00 00:00:00'),(NULL,'ru','Thursday','Четверг',0,'0000-00-00 00:00:00'),(NULL,'ru','Time','Время',0,'0000-00-00 00:00:00'),(NULL,'ru','To','До',0,'0000-00-00 00:00:00'),(NULL,'ru','Today','Сегодня',0,'0000-00-00 00:00:00'),(NULL,'ru','Toggle Search Form','Форма поиска по меткам',0,'0000-00-00 00:00:00'),(NULL,'ru','Total','Всего',0,'0000-00-00 00:00:00'),(NULL,'ru','Total Answered Calls','Всего отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Total Calls','Всего вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Total Duration','Общая продолжительность',0,'0000-00-00 00:00:00'),(NULL,'ru','Total Session Time','Общее время обработки вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','Total Time per Agent (seconds)','Общее время разговора для каждого оператора (в секундах)',0,'0000-00-00 00:00:00'),(NULL,'ru','Total Unanswered Calls','Всего неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Total records found','Всего найдено записей',0,'0000-00-00 00:00:00'),(NULL,'ru','Transfered Calls','Переадресованные вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Transferred','Переадресован',0,'0000-00-00 00:00:00'),(NULL,'ru','Transferred Calls','Переадресованные вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Translation','Перевод',0,'0000-00-00 00:00:00'),(NULL,'ru','Tuesday','Вторник',0,'0000-00-00 00:00:00'),(NULL,'ru','Type','Тип',0,'0000-00-00 00:00:00'),(NULL,'ru','URL','URL-адрес',0,'0000-00-00 00:00:00'),(NULL,'ru','Unanswered','Неотвеченные вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Unanswered Calls','Неотвеченные вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','Unanswered Rate','Частота неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','Unanswered by Day','Неотвеченные за день',0,'0000-00-00 00:00:00'),(NULL,'ru','Use comma to separate emails','Для разделения нескольких электронных адресов используйте запятую.',0,'0000-00-00 00:00:00'),(NULL,'ru','User','Пользователь',0,'0000-00-00 00:00:00'),(NULL,'ru','View Record','Просмотреть запись',0,'0000-00-00 00:00:00'),(NULL,'ru','Wait Time','Время ожидания',0,'0000-00-00 00:00:00'),(NULL,'ru','Waiting','Ожидание',0,'0000-00-00 00:00:00'),(NULL,'ru','Wednesday','Среда',0,'0000-00-00 00:00:00'),(NULL,'ru','Week','Неделя',0,'0000-00-00 00:00:00'),(NULL,'ru','Week days','День недели',0,'0000-00-00 00:00:00'),(NULL,'ru','Write down the value to compare','Введите значение для сравнения',0,'0000-00-00 00:00:00'),(NULL,'ru','Yes','Да',0,'0000-00-00 00:00:00'),(NULL,'ru','You do not have enough privileges to access this resource','You do not have enough privileges to access this resource',1,'2017-10-13 20:06:03'),(NULL,'ru','You must select at least one agent','Необходимо выбрать хотя бы одного оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','You must select at least one queue','Необходимо выбрать хотя бы одну очередь',0,'0000-00-00 00:00:00'),(NULL,'ru','admin-acl','Контроль доступа',0,'0000-00-00 00:00:00'),(NULL,'ru','admin-designer','Конструктор отчетов',0,'0000-00-00 00:00:00'),(NULL,'ru','admin-language','Перевод',0,'0000-00-00 00:00:00'),(NULL,'ru','admin-schedule','Отчеты/Уведомления',0,'0000-00-00 00:00:00'),(NULL,'ru','admin-setup','Параметры',0,'0000-00-00 00:00:00'),(NULL,'ru','admin-users','Пользователи',0,'0000-00-00 00:00:00'),(NULL,'ru','agent-dialout','Идет набор номера',0,'0000-00-00 00:00:00'),(NULL,'ru','agent-not in use','Не используется',0,'0000-00-00 00:00:00'),(NULL,'ru','agent_availability','Занятость оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','agent_detail','Полный отчет оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','agent_dispositions','Распоряжение вызова (Результат обработки вызова) оператором ',0,'0000-00-00 00:00:00'),(NULL,'ru','agent_durations','Продолжительность вызовов и пауз оператора',0,'0000-00-00 00:00:00'),(NULL,'ru','agent_pauses','Информация о паузе',0,'0000-00-00 00:00:00'),(NULL,'ru','agent_summary','Сводка операторов',0,'0000-00-00 00:00:00'),(NULL,'ru','all month','весь месяц',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_by_agent','оператором',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_by_duration','Отвеченные по длительности вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_by_event','Причина разъединения',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_by_holdtime','Уровень обслуживания',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_by_queue','в очереди',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_by_url','по URL-адресу',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_detail','Описание отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_summary','Сводка отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','answered_calls_transferred','Переадресованный вызов',0,'0000-00-00 00:00:00'),(NULL,'ru','at hour','в час',0,'0000-00-00 00:00:00'),(NULL,'ru','at minute','в минуту',0,'0000-00-00 00:00:00'),(NULL,'ru','calls','вызовы',0,'0000-00-00 00:00:00'),(NULL,'ru','day','день',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_ABANDON','Абонент отменил позицию в очереди. Позицией является позиция абонента в очереди после завершения вызова. Исходной позицией является исходная позиция абонента в тот момент, когда вызов впервые попал в очередь. Время ожидания - это общее время, которое вызов ожидал в очереди до момента отключения от системы. The caller abandoned their position in the queue. The position is the\r\ncaller&rsquo;s position in the queue when they hungup, the origposition is\r\nthe original position the caller was when they first entered the\r\nqueue, and the waittime is how long the call had been waiting in the\r\nqueue at the time of disconnect.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_COMPLETEAGENT','Абонент был соединен с оператором, вызов был завершен в обычном режиме *оператором*. Время удержания и продолжительность вызова сохранены. Исходная позиция абонента в очереди сохранена в origposition. The caller was connected to an agent, and the call was terminated normally\r\nby the *agent*. The caller&lsquo;s hold time and the length of the call are both\r\nrecorded. The caller&lsquo;s original position in the queue is recorded in\r\norigposition.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_COMPLETECALLER','Абонент был соединен с оператором, вызов был завершен в обычном режиме *абонентом*. Время удрежания и продолжительность вызова сохранены. Исходная позиция абонента в очереди сохранена в origposition. The caller was connected to an agent, and the call was terminated normally\r\nby the *caller*. The callers hold time and the length of the call are both\r\nrecorded. The caller&rsquo;s original position in the queue is recorded in\r\norigposition.\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_CONNECT','Абонент соединен с оператором.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_ENTERQUEUE','A caller entered the queue. Three parameters are also written: the URL (if specified) in the Info 1 field and the caller ID of the caller on the Info 2 field, and the original position where the call has landed in the Info 3 field.\r\nВызов поступил в очередь. Записываются три парамтера: в поле Инфо 1 вносится URL-адрес (при наличии), в поле Инфо 2 вносится ID абонента, в поле Инфо 3 вносится начальное положение вызова при поступлении.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_EXITWITEMPTY','Абоненты был отключен от очереди принудительно по причине отсутствия доступных операторов и того, что система настроена таким образом, отключать абонентов при отсутствии доступных операторов. The caller was exited from the queue forcefully because the queue had no\r\nreachable members and it&lsquo;s configured to do that to callers when there\r\nare no reachable members. The position is the caller&lsquo;s position in the\r\nqueue when they hungup, the origposition is the original position the\r\ncaller was when they first entered the queue, and the waittime is how\r\nlong the call had been waiting in the queue at the time of disconnect.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_EXITWITHKEY','Абонент решил воспользоваться кнопками меню для выхода из очереди. Кнопка и позиция абонента в очереди сохранены.  The caller elected to use a menu key to exit the queue. The key and\r\nthe caller&lsquo;s position in the queue are recorded.\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_EXITWITHTIMEOUT','Абонент находился в режиме удержания слишком долго, и время ожидания истекло.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_RINGNOANSWER','Время ожидания ответа от участника очереди превышено. Фиксируется единичный параметр, указывающий общее время, в течение которого звонил добавочнй номер участника очереди, в поле Инфо 1. The timeout value for ringing the queue member was exceeded. A single parameter will also be written indicating the amount of time the member’s extension rang in the Info 1 field.',0,'0000-00-00 00:00:00'),(NULL,'ru','disposition_help_TRANSFER','Вызов абонента был переведен на другой добавочный номер. Контекст и добавочный номер сохранены. Время удрежания и продолжительность вызова сохранены. ПОЖАЛУЙСТА, помните о том, что переадресация, выполненая SIP UA&lsquo;s при использовании опции \"повторно\" не всегда распознаются Asterisk и  запуск события. Context and extension\r\nare recorded.The caller&lsquo;s hold time and the length of the call are both\r\nrecorded. PLEASE remember that transfers performed by SIP UA&lsquo;s by way\r\nof a reinvite may not always be caught by Asterisk and trigger off this\r\nevent. Единственным способом для осуществления переадресации участником очереди, при котором Вы можете со 100-процентным результатом получить событие, является использование встроенного функционала переадресации в Фыеукшыл/ The only way to be 100% sure that you will get this event when\r\na transfer is performed by a queue member is to use the built-in transfer\r\nfunctionality of Asterisk.',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_agent','по оператором',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_agent (outbound)','по оператором (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_day','по дням',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_day (outbound)','по дням (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_day_of_week','по дням недели',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_day_of_week (outbound)','по дням недели (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_hour','по часам',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_hour (outbound)','по часам (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_month','по месяцам',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_month (outbound)','по месяцам (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_queue','по очереди',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_queue (outbound)','по очереди (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_url','по URL-адресу',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_url (outbound)','по URL-адресу (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_by_week','по неделям',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_by_week (outbound)','по неделям (исходящий)',0,'2013-05-28 01:28:58'),(NULL,'ru','distribution_detail','Подробный отчет распределения вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','distribution_summary','Сводка распределения вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_abandon_info1','Позиция - это позиция абонента в очереди после того, как абонент завершил вызов.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_abandon_info2','Исходная позиция абонента после того, как вызов был направлен в очередь.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_abandon_info3','Время ожидания - общее время, которое вызов ожида ответа в очереди во время отключения от системы. The waittime is how long the call had been waiting in the queue at the time of disconnect.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentcallbacklogin_info1','Оператор обратной связи вошел в систему. Добавочный номер и контекст сохранены. The callback agent logged in. The login extension and context is recorded.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentcallbacklogoff_info1','Оператор обратных вызовов вышел из системы.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentcallbacklogoff_info2','Последний добавочный номер регистрации и контекст, а также общее время нахождения оператора в системе сохранены.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentcallbacklogoff_info3','Причины выхода из системы, при условии, что это был не обычный выход из системы. (Например, автоматический выход из системы, канал не доступен) The reason for the logoff if it was not a normal logoff (e.g., Autologoff, Chanunavail)',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentlogin_info1','Оператор вошел в систему. Канал записывается. The agent logged in. The channel is recorded.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentlogoff_info1','Оператор вышел из системы.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_agentlogoff_info2','Общее время нахождения оператора в системе.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_completeagent_info1','Время удержания вызова абонента&#39;.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_completeagent_info2','Продолжительность вызова.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_completeagent_info3','Исходная позиция абонента в очереди сохраняется в origposition.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_completecaller_info1','Время удержания вызова абонента&#39;.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_completecaller_info2','Продолжительность вызова.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_completecaller_info3','Исходная позиция абонента сохранена в origposition.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_connect_info1','Время удержания вызова - общее время нахождения вызова в режиме удержания.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_connect_info2','The bridged channel unique ID contains the unique ID of the queue member channel that is taking the call.',1,'2017-10-13 20:06:03'),(NULL,'ru','event_help_connect_info3','Время звонка - промежуток времени между моментом поступления вызова в очередь и моментом, когда на вызов\r\nбыл получен ответ оператора.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_enterqueue_info1','URL параметр ',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_enterqueue_info2','Идентификатор абонента',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_enterqueue_info3','Исходная позиция абонента при направлении вызова в очередь в первый раз. The original position the caller was positioned when they first entered the queue.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitempty_info1','Позиция абонента в очереди после завершения вызова.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitempty_info2','Origposition - это исходная позиция абонента, когда он в первый раз попал в очередь. is the original position the caller was when they first entered the queue.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitempty_info3','Время ожидания - это общее время, которое вызов ожидал ответа в очереди во время отключения от системы.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitwithkey_info1','Абонент выбрал использование кнопок меню для выхода из очереди.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitwithkey_info2','Позиция абонента.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitwithtimeout_info1','Позиция абонента при выходе из очереди.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitwithtimeout_info2','Исходная позиция абонента при попадании в очередь. Original position at which the called entered the queue.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_exitwithtimeout_info3','Общее время, которое абонент провел в очереди.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_pause_info1','Причина постановки вызова на паузу (при наличии)',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_ringnoanswer_info1','Время в миллисекундах, которое звонил телефон оператора до того момента, когда был достигнут лимит ожидания ответа. Попытка дозвона, окончившаяся тем, что оператор не принял вызов. Time in milliseconds the agent phone rang until the timeout was reached. The attempt ended without the member picking up the call. Bad queue member!',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_transfer_info1','Добавочный номер',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_transfer_info2','Контекст',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_transfer_info3','Время удержания вызова абонента&#39;.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_transfer_info4','Продолжительность вызова.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_transfer_info5','Позиция абонента во время переадресации вызова.',0,'0000-00-00 00:00:00'),(NULL,'ru','event_help_unpause_info1','Причина снятия вызова с паузы (при наличии). ',0,'0000-00-00 00:00:00'),(NULL,'ru','every day','каждый день',0,'0000-00-00 00:00:00'),(NULL,'ru','every hour','каждый час',0,'0000-00-00 00:00:00'),(NULL,'ru','every minute','каждую минуту',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_ACTION','Определяет обработчика действий абонента, таким образом, Вы можете вызвать собственные функции/программы для обработки особых случаев. Вам необходимо создать функцию javascript в файле js/custom.js. При нажатии на иконку события он получит уникальный идентификатор вызова. Define a custom action handler, so you can call your own functions/program to handle special cases. You must create the javascript function in the js/custom.js file. It will receive the unique id of the call when the action icon is clicked.<br/>\r\n<br/>\r\nparameter: position,icon image,Tooltip<br/>\r\nvalue: javascript_function',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_ANSWERED_DISPLAY_GRID','Если диаграмма задается во вкладке отчетов отвеченных вызовов, поле параметра, то используйте ширину сетчатой схемы в качестве настройки в поле значения. Сетка состоит из 12 столбцов: If a chart is defined in the answered reports tab, parameter field, then use the grid layout width as setup in the value field. The grid system has 12 columns in total:<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: width1,width2',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_ANSWERED_DISPLAY_ROWS','Список полей, разделенный запятой, отображающийся в отчетах отвеченных вызовов. Поля определяются как COLUMN_ANSWERED.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields ',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_CHART_ANSWERED','Отображает график на странице отчетов отвеченных вызовов.<br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_CHART_DISTRIBUTION','Отображает график на странице отчетов распределения вызовов. <br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_CHART_SERIES_COLOR','Цвета, используемые для построения диаграмм. Параметром является положение указателя, значением - шестнадцатиричный html цвет. Colors to use for charts. Parameter is the index position, and value the hex html color.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_CHART_UNANSWERED','Отображает график на странице отчетов неотвеченных вызовов.<br/><br/>\r\n\r\nparameter: position,group field,title<br/>\r\nvalue: field,field',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_ANSWERED','Столбец в отчетах отвеченных вызовов. Вы можете добавить в отчет все столбцы, затем отсортировать их по каждой группе при помощи присвоения нумерации элементам списка ANSWERED_DISPLAY_ROWS.\r\nColumn to show in Answered reports. You can add all the columns you want for a report, then you can filter limit them on each group report by enumerating them in ANSWERED_DISPLAY_ROWS entries.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>\r\n\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_ANSWERED_FORMAT','Формат отображения значения ячейки в отчетах отвеченных вызовов. Применяются общие правила форматирования печати за исключением часовых значений: {ЧЧ}, {ММ}, {СС}, {мм} и {сс}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nИмя поля параметра задается в качестве поля параметра в The parameter field name must be set as the parameter field on the COLUMN_ANSWERED entry.<br/>\r\nПример форматирования:<br/><br/>\r\nЗначение в секундах переводится в формат ЧЧ:ММ:СС с:<br/>\r\n{ЧЧ}:{ММ}:{СС}\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_DISTRIBUTION','Столбец в отчетах распределения вызовов. Вы можете добавить в отчет все столбцы, затем отсортировать их по каждой группе при помощи присвоения нумерации элементам списка DISTRIBUTION_DISPLAY_ROWS.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_DISTRIBUTION_FORMAT','Формат отображения значения ячейки в отчетах распределения вызовов. Применяются общие правила форматирования печати за исключением часовых значений: {ЧЧ}, {ММ}, {СС}, {мм} и {сс}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nИмя поля параметра задается в качестве поля параметра в The parameter field name must be set as the parameter field on the COLUMN_DISTRIBUTION entry.<br/>\r\nПример форматирования:<br/><br/>\r\nЗначение в секундах переводится в формат ЧЧ:ММ:СС с:<br/>\r\n{ЧЧ}:{ММ}:{СС}\r\n\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_REALTIME','Столбец сводки в реальном времени. Вы можете добавить в отчет все столбцы, затем отсортировать их по группам при помощи присвоения нумерации элементам списка REALTIME_DISPLAY_ROWS.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_REALTIME_FORMAT','Format to use for displaying a cell value in the realtime queue summary report.Формат отображения значения ячейки в сводке по очереди в реальном времени. Применяются общие правила форматирования печати за исключением часовых значений: {ЧЧ}, {ММ}, {СС}, {мм} и {сс}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nИмя поля параметра задается в качестве поля параметра в The parameter field name must be set as the parameter field on the COLUMN_REALTIME entry.<br/>\r\nПример форматирования:<br/><br/>\r\nЗначение в секундах переводится в формат ЧЧ:ММ:СС с:<br/>\r\n{ЧЧ}:{ММ}:{СС}\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_REALTIME_STYLE','Для дополнительного форматирования ячеек в таблице сводок очередей, отображающих информацию в реальном времени, Вы можете использовать HTML-класс или стиль текста. Например:<br/>\r\n<br/>\r\nclass=&quot;bigblue&quot;\r\n<br/>\r\nstyle=&quot;border:1px solid red;&quot;\r\n\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_UNANSWERED','Столбец в отчете неотвеченных вызовов. Вы можете добавить в отчет все столбцы, затем отсортировать их по группам при помощи присвоения нумерации элементам списка UNANSWERED_DISPLAY_ROWS.<br/>\r\n<br/>\r\nparameter: column name/label<br/>\r\nvalue: variable or formula<br/>',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_COLUMN_UNANSWERED_FORMAT','Формат отображения значения ячейки в отчетах неотвеченных вызовов. Применяются общие правила форматирования печати за исключением часовых значений: {ЧЧ}, {ММ}, {СС}, {мм} и {сс}<br/>\r\n<br/>\r\nparameter: field name<br/>\r\nvalue: format string<br/>\r\n<br/>\r\nИмя поля параметра задается в качестве поля параметра в The parameter field name must be set as the parameter field on the COLUMN_UNANSWERED entry.<br/>\r\nПример форматирования:<br/><br/>\r\nЗначение в секундах переводится в формат ЧЧ:ММ:СС с:<br/>\r\n{ЧЧ}:{ММ}:{СС}\r\n\r\n\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_DISTRIBUTION_DISPLAY_ROWS','Список полей, разделенный запятой, отображающийся в отчетах распределения вызовов. Поля определяются как COLUMN_DISTRIBUTION.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_ABANDONED','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные с НЕСОСТОЯВШИМИСЯ ВЫЗОВАМИ, с использованием списка, разделенного запятыми. В стандартных настройках Asterisk должно быть установлено только \\\"ABANDON\\\". Define the queue_log events that will count towards the ABANDONED counters/variables in reports, using a comma separated list. In a standard Asterisk setup, this must be set to \\\"ABANDON\\\" and nothing else.счетчики/переменные ',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_ANSWERED','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные с ОТВЕЧЕННЫМИ ВЫЗОВАМИ, с использованием списка, разделенного запятыми. Define the queue_log events that will count towards the ANSWERED counters/variables in reports, using a comma separated list. Normal answered dispositions in the queue_log are COMPLETECALLER, COMPLETEAGENT, you could also want to count the TRANSFER disposition towards the ANSWERED column, but as transfers have their own variable, you can also leave them separated. Отвеченный вызов в queue_log обозначается COMPLETECALLER, COMPLETEAGENT. Вы также можете подсчитать количество результатов ПЕРЕАДРЕСОВАННЫЕ ВЫЗОВЫ в столбце ОТВЕЧЕННЫЕ ВЫЗОВЫ, но так как для переадресованных вызовов есть свои переменные, то они могут будет подсчитаны отдельно.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_LOGIN','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные со ВХОДОМ В СИСТЕМУ, с использованием списка, разделенного запятыми.Как правило, имеются события AGENTLOGIN и ADDMEMBER в качестве действий по входу в систему в файле queue_log. В предыдущих версиях Asterisk также могут использоваться AGENTCALLBACKLOGIN.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_LOGOUT','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные с ВЫХОДОМ ИЗ СИСТЕМЫ, с использованием списка, разделенного запятыми. Как правило, имеются AGENTLOGOFF и REMOVEMEMBER в качестве действий по выходу из системы в файле queue_log.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_RECEIVED','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные с ПОЛУЧЕННЫМИ ВЫЗОВАМИ, с использованием списка, разделенного запятыми. Все результаты обработки вызовов в файле queue_log, имеющие отношение к полученным вызовам, должны быть перечислены здесь, например:<br/><br/>\r\nCOMPLETECALLER,COMPLETEAGENT,ABANDON,EXITEMPTY,EXITWITHKEY,EXITWITHTIMEOUT,TRANSFER',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_TRANSFERRED','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные с ПЕРЕАДРЕСОВАННЫМИ ВЫЗОВАМИ, с использованием списка, разделенного запятыми. В стандартных настройках Asterisk единственным событием, относящийся к переадрессации, является TRANSFER.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_EVENT_UNANSWERED','Определяет события queue_log, которые подсчитывают счетчики/переменные, связанные с НЕОТВЕЧЕННЫМИ ВЫЗОВАМИ, с использованием списка, разделенного запятыми. Так как для несостоявшегося вызова имеется собстввенная переменная, Вам необходимо перечислить все остальные результаты обработки вызовов как неотвеченные здесь, например:<br/><br/>\r\nEXITWITHKEY,EXITEMPTY,EXITWITHTIMEOUT',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_REALTIME_COLUMN_WIDTHS','help_text_REALTIME_COLUMN_WIDTHS',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_REALTIME_DISPLAY_ROWS','Список полей, разделенный запятой, отображающийся в таблице Сводки очередей в реальном времени. Поля определяются как COLUMN_REALTIME.<br/>\r\n<br/>\r\nparameter: group field (queue_summary)<br/>\r\nvalue: comma separated list of fields',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_TOTAL_COLUMN_ANSWERED','Формула для строки \"Всего\" в отчете по отвеченным вызовам. Formula to use for the Total row on Answered reports.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_TOTAL_COLUMN_DISTRIBUTION','Формула для строки \"Всего\" в отчете распределения вызовов.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_TOTAL_COLUMN_REALTIME','Формула для строки \"Всего\" в отчетах в реальном времени.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_TOTAL_COLUMN_UNANSWERED','Формула для строки \"Всего\" в отчете по неотвеченным вызовам.<br/>\r\n<br/>\r\nparameter: field<br/>\r\nvalue: formula',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_UNANSWERED_DISPLAY_GRID','Если диаграмма задается в отчете неотвеченных вызовов, поле параметра, то используйте ширину сетчатой схемы в качестве настройки для значения поля. Сетка состоит из 12 столбцов: If a chart is defined in the unanswered reports, parameter field, then use the grid layout width as setup in the value field. The grid system has 12 columns in total:<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: width1,width2',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_UNANSWERED_DISPLAY_ROWS','Список полей, разделенный запятой, отображающийся в отчетах неотвеченных вызовов. Поля определяются как COLUMN_UNANSWERED.<br/>\r\n<br/>\r\nparameter: group field<br/>\r\nvalue: comma separated list of fields',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_agent_filter','Фильтр \"Регулярное выражение\" применяется для удаления из выделения ненужных операторов.<br/> Пример: <strong>Agent/[0-9][0-9][0-9][0-9]$</strong>\r\n\r\n\r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_agent_reports','Список отчетов, разделенный запятой, отображающийся на странице \"Оператор\". Вам необходимо задать правильный файл .php, отображающий необходимый Вам отчет по каждому элементу. Comma separated list of reports to show on the Agent page. You must specify the correct .php file that displays the report you want on each element.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_agent_row_color','Для придания ячейки цвета фона, соответствующего статусу оператора, в режиме реального времени, измените параметр на \"1\".',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_answered_reports','Список отчетов, разделенный запятой, отображающийся на странице Отвеченных вызовов. Вам необходимо задать правильный файл .php, отображающий необходимый Вам отчет по каждому элементу. Comma separated list of reports to show on the Answered page. You must specify the correct .php file that displays the report you want on each element.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_asterisk_12','Установите значение \"1\", если Вы пользуетесь версией Asterisk 1.2 или более ранней версией. В противном случае возможно возникновение ограничений в использовании режима просмотра в реальном времени.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_asterisk_16','Set this to 1 if you are using Asterisk 1.6, otherwise you will have some issues in the realtime view.\n',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_asterisk_18','Set this to 1 if you are using Asterisk 1.8, otherwise you will have some issues in the realtime view.',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_avg_time_format','Формат поля средней продолжительности. ЧЧ = часы, ММ = минуты, СС = секунды, мм = полные минуты, сс = полные секунды. Используются в поисковых и подробных отчетах.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_call_flow','To have separate reports for outbound queues, set call_flow for them. The parameter must be the queue name/number and the value must be set to \\\\\\\"outbound\\\\\\\".',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_call_time_format','Формат поля продолжительности вызова. ЧЧ = часы, ММ = минуты, СС = секунды, мм = полные минуты, сс = полные секунды. Используются в поисковых и подробных отчетах.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_csv_separator','Разделитель, используемый для экспорта файлов в формате CSV. По умолчанию разделителем является запятая (,). Если Вы пользуетесь LibreOffice/OpenOffice, то, возможно, потребуется изменить разделитель на точку с запятой (;). ',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_custom_reports','Список индивидуальных отчетов, разделенный запятой, отображающийся в меню на вкладе \"Новый/Индивидуальный\". Параметром является название вклдаки для отображения, а значение - это список скрпитов .php, разделенные запятой, к загрузке. Comma separated list of custom reports to show on a new/custom tab on the menu. The parameter is the tab name to display, and value is a comma separated list of .php scripts to load.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_date_format','Формат поля даты с использованием синтаксиса MySQL. Например: %%м-%%д-%%Г %%Ч:%%м:%%с. Используется только в поисковых или полных отчетах. Формат отчета задается в конструкторе отчетов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_decimal_places','Количество десятичных знаков для отображения чисел с плавающей запятой. ',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_default_end_hour','Формат времени завершения по умолчанию ЧЧ:СС для выбора даты/времени.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_default_start_hour','Формат времени начала по умолчанию ЧЧ:СС для выбора даты/времени.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_detailed_agent_report','Отображает подробный отчет оператора во вкладке \"Оператор\". (Как и в случае  с детализированной информацией, представленной в периодическом отчете, но дополненной в соответствии с выбранным диапазонов дат). (Similar to the drill down information you can get on a regular report, but already expanded for the complete date range selection).',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_dict_agent','Словарная запись для оператора. Заменяет идентификатор оператора, задаваемый в качестве параметра, на выбранное Вами значение (Таким образом, Вы можете использовать имя вместо номера).',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_dict_queue','Словарная запись для очереди. Выполняет ту же функцию, что и словарная запись для оператора, но для замены имени очереди.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_distribution_interval','Интервал времени в минутахInterval in minutes to break up the distribution by hour report. По умолчанию интервал составляет час (60 минут), возможен выбор большего или меньшего значения. By default it breaks by hour (60 minutes), but you can use smaller or larger values.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_distribution_reports','Список отчетов, разделенный запятой, отображающийся на странице Распределения вызовов. Вам необходимо задать правильный файл .php, отображающий необходимый Вам отчет по каждому элементу. Comma separated list of reports to show on the Distribution page. You must specify the correct .php file that displays the report you want on each element.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_drilldown_records_per_page','Количество записей на странице отчета при разворачивании/детализации Number of records per page to show when expanding/drilling down on any report.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_first_page','Стартовая страница при загрузке (Например: answered.php, unanswered.php, distribution.php, agent.php). Возможно установить персональный вид стартовой страницы для каждого пользователя.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_freepbx_device_user_mode','Set this to 1 if you use FreePBX in user&device mode',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_hide_parsed_time','Установите значение \"1\", чтобы скрыть отображение в нижнем колонтитуле каждого отчета информации о времени обработки.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_honor_timeframe_in_agent','Honor time frame selection in Agent Tab Reports. It will also try to compute missing events for the period if \nthey are not in the logs.',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_ignore_none_abandons','Если Вы не хотите учитывать несостоявшиеся входящие вызовы при выборе в отчете нескольких операторов, измените параметр на \"один\". Эта функция полезна при отслеживании кампании исходящих вызовов и производительности каждого оператора, так как не учитываются несостоявшиеся входящие вызовы, распределенные в общую очередь (оператор \"NONE\"), но не прикрепленные к конкретному оператору. Если Вы выбираете всех операторов, включая и оператора \"NONE\", то несостоявшиеся входящие вызовы учитываются как обычно, даже если выбран параметр \"один\". \r\n',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_language','Выбор языка. Если в поле параметра задать имя оператора, то использование языка будет ограничено для конкретного оператора. Если поле остается пустым, то выбранный язык применяется ко всем пользователям (основные настройки). Language to use. You can specify a user name in the parameter field to limit the language to a particular user. If the parameter field is left empty, then the language will be set for all users (global setting).',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_alert_subject','Subect to use when emailing alerts',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_mail_from_email','Для отправки запланированного отчета и уведомления электронным письмом, необходимо заполнить поле \"ОТ\".',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_from_name','Для отправки запланированного отчета и уведомления электронным письмом, необходимо заполнить поле \"ИМЯ\".',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_header_image','Файл изображения, используемый в качестве заголовка для отчетов/уведомлений, отправляемый электронной почтой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_report_subject','Subject to use when emailing reports',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_mail_smtp_password','При необходимости, для отправки запланированных отчетов и уведомлений введите пароль для SMTP-сервера.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_smtp_server','Для отправки запланированных отчетов и уведомлений необходимо настроить SMTP-сервер. Наример: SSL-протокол: ssl://smtp.server.com ; TLS-протокол: tls://smtp.server.com ; без шифрования: smtp.server.com',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_smtp_server_port','При необходимости, для отправки запланированных отчетов и уведомления настройте SMTP-порт.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_mail_smtp_username','При необходимости, для отправки запланированных отчетов и уведомления введите имя пользователя для SMTP-сервера.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_pbxware','Set this to 1 if you use PBXWare for the realtime view to work correctly',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_realtime_agent_sort','If set to \\\"status\\\", busy agents will be shown first on the realtime page.',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_realtime_alarm_call_duration','Предупреждающий сигнал, устанавливаемый для продолжительности вызова в секундах в режиме реального времени. Сигнал может быть задан для конкретной очереди путем Alarm in seconds for call duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_alarm_last_call','Предупреждающий сигнал в секундах, сообщающий о последнем вызове в режиме реального времени. Alarm in seconds for the last call information in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_alarm_pause_duration','Предупреждающий сигнал в секундах, сообщающий о продолжительности паузы/перерыва в режиме реального времени. Alarm in seconds for pause/break duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_alarm_row_color','Цвет фона строки, когда показатель Background row color when a value is in alarm in the realtime view.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_alarm_threshold','Пороговое значение (в процентах), начиная с которого вызовы обозначаются сигнальным цветом в режиме реального времени. Threshold (in percentage) from which to start coloring in alarm calls in the realtime view.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_alarm_wait_count','Предупреждающий сигнал для вызовов, ожидающих в очереди, в режиме реального времени. (Alarm (in number of calls) for calls waiting in a queue in the realtime view.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_alarm_wait_duration','Предупреждающий сигнал в секундах, устанавливаемый для продолжительности ожидания ответа в режиме реального времени. Alarm in seconds for call waiting duration in the realtime view. Can be set per queue by setting the parameter to the queue name.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_coach_options','Возможность для перехода в режим прослушивания вызова при запуске действия Тренер в реальном времени. Вы можете использовать любые варианты, доступные в приложении, например, Options to pass to chanspy when launching a Coach action from the realtime view. You can use any options available to the asterisk chanspy application, например &quot;w&quot; чтобы включить to enable whispering, or &quot;d&quot; to use dtmf to switch modes: 4 spy, 5 whisper, 6 barge., etc.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_custom_pauses','Если значение равно 1, то страница с просмотром в реальном времени будет проверять ASTDB на PAUSECUSTOM/Оператор и отобразит код паузы, хранящийся для конкретного Оператора в ASTDB.  If this value is set to 1 the realtime page will check the ASTDB for the PAUSECUSTOM/Agent family and it will show the pause code stored there for a particular Agent as stored in astdb Key. Например: PAUSECUSTOM/Agent/1000 = Break:${EPOCH}, сохраненный в ASTDB, will show Agent 1000 as break when paused.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_group_queues','Начать просмотр в реальном времени с отображением вызовов, сгруппированным по очередям обслуживания.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_hide_loggedoff','Начать просмотр в реальном времени без учета операторов, вышедших из системы. Start the realtime view without showing logged off Agents.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_last_hour_stats','Set this option if you want the call counters in the realtime view to show only the last hour counts, and not the whole day.',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_realtime_refresh','Время обновления в секундах для режима просмота в реальном времени.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_refresh_sql','Время обновления в секундах для просмота статистики в таблице сводки очередей в реальном времени. Процесс получения информации оказывает большую нагрузку на процессор, поэтому для экономии возможно установить значние обновления по умолчанию 60 секунд или больше, если одновременно в реальном времени проверяют данные несколько супервизоров.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_reports','Список отчетов, разделенный запятой, отображающийся на странице Режима реального времени. Вам необходимо задать правильный файл .php, отображающий необходимый Вам отчет по каждому элементу. Comma separated list of reports to show on the Realtime page. You must specify the correct .php file that displays the report you want on each element.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_spy_device','Устройство, используемое пользователем (задается в поле параметра). Например: SIP/1234',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_spy_extension','Добавочные номер для звонка на телефон супервизора при запуке действия перехвата вызова в режиме реального времени. Параметром должно являться им пользователя asternic, значением может быть добавочный номер с последующим контекстом, например: Extension to reach the supervisor phone when launching a call steal action in the realtime view. The parameter must be set to the asternic user name, the value could be the extension number followed by the context, for example: 100@from-internal',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_spy_options','Возможность прослушать вызов при запуске действия \"Прослушать\" в режиме реального времени. Вы можете исползовать любые варианты, доступные в приложении прослушивания вызовов chanspy asterisk, например &quot;q&quot; отключить первый гудок, и т.п. Options to pass to chanspy when launching a Listen action from the realtime view. You can use any options available to the asterisk chanspy application, like &quot;q&quot; to disable the initial beep, etc.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_strict_interface_status','Данная настройка позволяет показывать статус режима просмотра в реальном времени, осуществляемое приложением Asterisk при помощи настроек STATE INTERFACE для приложения AddQueueMember. Для систем с участниками очереди локального типа с настройками STATE INTERFACE (например, FreePBX версия 2.8 или выше) необходимо установить значение 1. This setting will make the realtime view show status as returned by the asterisk queue application by means of the STATE INTERFACE options for the AddQueueMember application. It should be set to 1 in systems with Local type queue members with STATE INTERFACE set, like FreePBX 2.8 or higher.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_realtime_tracking_mode','If set, coaching sessions in the realtime view will not end when the call ends, so the supervisor continues pinned to the agent for subsequent calls.',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_recordings_path','Местоположение записей на жестком диске в целях осуществления загрузки данных. Recordings location/directory in the hardrive to perform the direct download.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_session_time_format','Формат поля продолжительности обработки вызова. ЧЧ = часы, ММ = минуты, СС = секунды, мм = полные минуты, сс = полные секунды. Используются в отчетах оператора.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_setup_reports','Список отчетов, разделенный запятой, отображающийся на странице \"Параметры страницы\". Вам необходимо задать правильный файл .php, отображающий необходимый Вам отчет по каждому элементу. Comma separated list of reports to show on the Setup page. You must specify the correct .php file that displays the report you want on each element.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_shared_lastcall','Compartir la información de último llamado entre colas. Sólo se mostrará el tiempo más corto para todas las colas. Si se utiliza rastreo de salientes y se guarda el valor astdb LASTCALL, será también tomado en cuenta.',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_short_abandon_threshold','Порог ожидания (в секундах) для того, чтобы вызов считался отмененным (если продолжительность вызова меньше заданного значения, то вызов полностью отклоняется). При указании имени очереди значение будет применимо только к этой очереди. Duration  treshhold (in seconds) for a call to be considered as abandoned (if duration is less than this value, then ignore the call completely). Specifying the queue name as a parameter will apply the value to that queue only.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_short_unanswered_threshold','Порог ожидания (в секундах) для вызова, чтобы считаться неотвеченным (если величина ожидания ниже установленного значения, то вызов не принимается во внимание). Задание имени очереди в качестве параметра определит значение только к заданной очереди. Duration  treshhold (in seconds) for a call to be considered as unanswered (if duration is less than this value, then ignore the call completely). Specifying the queue name as a parameter will apply the value to that queue only.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_show_agent_call','Отображает действия по завершению вызова при детализации отчета оператора. Show end call events when drilling down on agent reports',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_show_agent_field','Mostrar columna de Agente en reportes de no atendidos (útil cuando se rastrean llamados salientes)',1,'2017-10-13 20:06:03'),(NULL,'ru','help_text_show_url_field','Активировать и отобразить поле URL-адреса и отчетов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_sla_abandoned','Показатель уровня обслуживания в секундах для несостявшихся вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_sla_answered','Показатель уровня обслуживания в секундах для неотвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_sla_interval','Интервал времени в секундах для разделения таблицы для отчетов SLA (Соглашение об уровне обслуживания) и частоты отмены вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_sla_steps','Количество операций для отображения в отчетах SLA (Соглашение об уровне обслуживания) и частоты отмены вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_sla_transferred','Показатель уровня обслуживания в секундах для переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_sla_unanswered','Показатель уровня обслуживания в секундах для неотвеченных (не отмененных, а неотвеченных в результате истечения времени ожидания, ) вызовов. вызовов. Service Level value in seconds for unanswered calls (not abandoned, but unanswered due to timeouts, exit with key, etc).',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_timeframe_interval','Интервал времени в минутах - отображаются сведения о промежутке времени на домашней странице. Значение по умолчанию - 15 минут.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_timezone','Конфигурация часовго пояса для пользователя в формате [ -]ЧЧ:ММ\\\"\r\n\r\nЕсли имя пользователя задано в качестве параметра, то конфигурация применяется только к этому пользователю. Если поле остается пустым, конфигурация применяется повсеместно. If the user name is specified as parameter, then applies only to that user. If parameter is left blank it will be applied globally.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_unanswered_reports','Список отчетов, разделенный запятой, отображающийся на странице \"Неотвеченные вызовы\". Вам необходимо задать правильный файл .php, отображающий необходимый Вам отчет по каждому элементу. Comma separated list of reports to show on the Unanswered page. You must specify the correct .php file that displays the report you want on each element.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ABANDONED','Количество несостоявшихся вызовов (с результатом обработки вызова EVENT_ABANDON в queue_log).',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ABANDONED_SLA','Количество несостоявшихся вызовов (с результатом обработки вызовов EVENT_ABANDON в queue_log)  с временем ожидания менее или равным значению sla_abandoned, заданному в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ABANDONED_WAIT_TIME','Время ожидания для несостоявшихся вызовов для конкретного отчета с группировкой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AGENTS_LOGGED_OFF','Количество неподключенных операторов. Данные доступны только в формуле COLUMN_REALTIME.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AGENTS_PAUSED','Количество приостановленных операторов. Данные доступны только в формуле COLUMN_REALTIME.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AGENTS_STAFFED','Количество зарегестрированных/доступных операторов. Данные доступны только в формуле COLUMN_REALTIME.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AGENTS_TALKING','Количество операторов, обслуживающих вызов. Данные доступны только в формуле COLUMN_REALTIME.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ANSWERED','Количество отвеченных вызовов (с результатом обработки вызова EVENT_ANSWERED в файле queue_log) для отчета с группировкой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ANSWERED_SLA','Количество отвеченных вызовов (с результатом обработки вызовов EVENT_ANSWERED в queue_log) с временем ожидания менее или равным значению sla_answered, заданному в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ANSWERED_TALK_TIME','Время разговора отвеченных вызовов для составления полного отчета с группировкой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ANSWERED_WAIT_TIME','Время ожидания для отвеченных вызовов для конкртеного отчета с гуппировкой. (Время ожидания - это время ожидания абонента в очереди до момента, когда оператор ответил на вызов. Учитывается только то время, которое вызов провел в очереди, не учитывается вероятное предыдущее время, например Интерактивная система ответа, голосовое меню, и т.д.). Wait Time of Answered Calls for the particular grouped report. (Wait Time is the time an user was waiting on the queue before being connected to an agent, it only counts the time since the queue was entered, it does not count potential previous times like IVRs, etc.)',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ABANDONED','Среднее количество несостявшихся вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ABANDONED_SLA','Среднее количество несостявшихся вызовов, время ожидания которых меньше или равно времени abandoned_sla, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ABANDONED_WAIT_TIME','Среднее время ожидания до отмены вызова',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ANSWERED','Среднее количество отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ANSWERED_SLA','Среднее количество отвеченных вызовов, находившихся в ожидании менее или равное количество answered_sla секунд, определенных Настройками. Average number of Answered Calls that were waiting for less or equal than answered_sla seconds as set in Preferences.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ANSWERED_TALK_TIME','Средняя продолжительность разговора отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_ANSWERED_WAIT_TIME','Среднее время ожидания ответа оператора. Average Wait Time for Answered Calls',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_LOGIN','Среднее количество действий операторов по входу в систему.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_LOGOUT','Среднее количество действий операторов по выходу из системы.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_RECEIVED','Среднее количество принятых вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_TRANSFERRED','Среднее количество переадресованных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_TRANSFERRED_SLA','Среднее количество переадресованных вызовов, находившихся в ожидании менее или равное количество transferred_sla секунд, определенных Настройками. Average number of Transferred Calls that were waiting for less or equal than transferred_sla seconds as set in Preferences.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_TRANSFERRED_TALK_TIME','Среднее время разговора переадресованных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_TRANSFERRED_WAIT_TIME','Среднее время ожидания переадресации вызова Average Wait Time of Transferred Calls',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_UNANSWERED','Среднее количество неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_UNANSWERED_SLA','Среднее количество неотвеченных вызовов, время ожидания которых меньше или равно unanswered_sla секундам, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_AVG_UNANSWERED_WAIT_TIME','Среднее время ожидания для неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_CALLS_WAITING','Количество вызовов, находящихся в режиме ожидания. Данные доступны только в формуле COLUMN_REALTIME.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_LOGIN','Количество входов в систему оператора.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_LOGOUT','Количество выходов из системы оператора.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_ABANDONED_WAIT_TIME','Максимальное время ожидания несостоявшихся вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_ANSWERED_TALK_TIME','Максимальное время разговора отвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_ANSWERED_WAIT_TIME','Максимальное время ожидания отвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_CALLERS_WAITING','Максимальное количество абонентов, ожидающих в очереди.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_COL','Максимальное значение столбца, используемое в формулах суммы.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_TRANSFERRED_TALK_TIME','Максимальное время разговора переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_TRANSFERRED_WAIT_TIME','Максимальное время ожидания для переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_UNANSWERED_WAIT_TIME','Максимальное время ожидания неотвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MAX_WAIT_TIME','Максимальное время ожидания для отчета с группировкой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_ABANDONED_WAIT_TIME','Минимальное время ожидания в несостоявшихся вызовах.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_ANSWERED_TALK_TIME','Минимальное время разговора отвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_ANSWERED_WAIT_TIME','Минимальное время ожидания отвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_COL','Минимальное значение столбца для формул СУММЫ.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_TRANSFERRED_TALK_TIME','Минимальное время разговора переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_TRANSFERRED_WAIT_TIME','Минимальное время ожидания для переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_MIN_UNANSWERED_WAIT_TIME','Минимальное время ожидания неотвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_RECEIVED','Количество принятых вызовов (с результатом обработки вызова EVENT_RECEIVED в файле queue_log) для отчета с группировкой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_ROW_COUNT','Количество строк в отчете. Используется в формулах суммы.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ABANDONED','Сумма несостоявшихся вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ABANDONED_SLA','Сумма несостоявшихся вызовов в строке, время ожидания которых меньше или равно sla_abandoned секундам, заданным в Настройках. ',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ABANDONED_WAIT_TIME','Сумма времени ожидания несостоявшихся вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ANSWERED','Сумма отвеченных вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ANSWERED_SLA','Сумма отвеченных вызовов в строке отчета, время ожидания которых меньше или равно sla_answered секундам, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ANSWERED_TALK_TIME','Общее время разговора отвеченных вызовов до определенной строки в отчете. Sum of Talk Time for Answered calls up to the particular row in a report.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_ANSWERED_WAIT_TIME','Сумма времени ожидания для отвеченных вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_COL','Сумма всех значений в конкретном столбце. Используется в формулах СУММЫ.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_LOGIN','Сумма действий по входу в систему до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_LOGOUT','Сумма действий по выходу из системы до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_RECEIVED','Сумма полученных вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_TRANSFERRED','Сумма переадресованных вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_TRANSFERRED_SLA','Сумма переадресованных вызовов до строки в отчете, время ожидания которых меньше или равно sla_transferred секундам, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_TRANSFERRED_TALK_TIME','Общее время разговора переадресованных вызовов до определенной строки в отчете. Sum of Talk Time for Transferred calls up to the particular row in a report.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_TRANSFERRED_WAIT_TIME','Сумма времени ожидания для переадресованных вызовов до строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_UNANSWERED','Сумма неотвеченных вызовов до конкретной строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_UNANSWERED_SLA','Сумма неотвеченных вызовов до строки в отчете, время ожидания которых меньше или равно transferred_sla секундам, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_SUM_UNANSWERED_WAIT_TIME','Сумма времени ожидания для переадресованных вызовов до строки в отчете.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ABANDONED','Общее количество несостоявшихся вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ABANDONED_SLA','Общее количество несостоявшихся вызовов, время ожидания которых меньше или равно abandoned_sla секундам, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ABANDONED_WAIT_TIME','Общее время ожидания до отмены вызова.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ANSWERED','Общее количество отвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ANSWERED_SLA','Общее количество отвеченных вызовов, время ожидания которых меньше или равно answered_sla секундам, заданным в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ANSWERED_TALK_TIME','Общее время разговора отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_ANSWERED_WAIT_TIME','Общее время ожидания ответа для отвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_LOGIN','Общее количество действий по входу в систему.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_LOGOUT','Общее количество действий по выходу из системы.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_RECEIVED','Общее количество принятых вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_TRANSFERRED','Общее количество переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_TRANSFERRED_SLA','Общее количество переадресованных вызовов, время ожидание которых меньше или равно transferred_sla секундам, заданым в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_TRANSFERRED_TALK_TIME','Общее время разговора переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_TRANSFERRED_WAIT_TIME','Общее время ожидания для переадресованных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_UNANSWERED','Общее количество неотвеченных вызовов.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_UNANSWERED_SLA','Общее количество неотвеченных вызовов, время ожидание которых меньше или равно unanswered_sla секундам, заданым в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TOTAL_UNANSWERED_WAIT_TIME','Время ожидания неотвеченных вызовов для полного набора данных.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TRANSFERRED','Количество переадресованных вызовов (с результатом обработки вызова EVENT_TRANSFERRED в queue_log)',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TRANSFERRED_SLA','Количество переадресованных вызовов (с результатом обработки вызовов EVENT_TRANSFERRED в queue_log) с временем ожидания менее или равным значению transferred_sla, заданному в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TRANSFERRED_TALK_TIME','Время разговора переадресованных вызовов определенной строки. Talk Time for Transferred Calls for a particular row.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_TRANSFERRED_WAIT_TIME','Время ожидания переадресованных вызовов для строки.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_UNANSWERED','Количество неотвеченных вызовов (с результатом обработки вызова EVENT_UNANSWERED в журнале очереди) для полного отчета с группировкой.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_UNANSWERED_SLA','Количество неотвеченных вызовов (с результатом обработки вызова EVENT_UNANSWERED в queue_log) с временем ожидания менее или равным значению sla_unanswered, заданному в Настройках.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_variable_UNANSWERED_WAIT_TIME','Время ожидания неотвеченных вызовов для строки. ',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_wait_time_format','Формат поля времени ожидания вызова. ЧЧ = часы, ММ = минуты, СС = секунды, мм = полные минуты, сс = полные секунды. Используются в поисковых и подробных отчетах.',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_week_mode','Когда начинать отсчет недель в году When to start counting weeks from the year:<br><pre>\r\nРежим Первый день недели       Интервал Неделя 1 является первой неделей ...\r\n0         Воскресенье          0-53    с воскресенья в году\r\n1         Понедельник          0-53    с более, чем 3-мя днями в году\r\n2         Воскресенье          1-53    с воскресенья в году\r\n3         Понедельник          1-53    более, чем 3-мя днями в году\r\n4         Воскресенье          0-53    с более, чем 3-мя днями в году\r\n5         Понедельник          0-53    с понедельника в году\r\n6         Воскресенье          1-53    с более, чем 3-мя днями в году\r\n7         Понедельник          1-53    с понедельника в году\r\n</pre>',0,'0000-00-00 00:00:00'),(NULL,'ru','help_text_wrap_up','Optinoal wrap_up time, it can be set globally or per queue. This value will affect the AHL (Average Handling Time) numbers in reports.',1,'2017-10-13 20:06:03'),(NULL,'ru','hours','час',0,'0000-00-00 00:00:00'),(NULL,'ru','info1','Информация 1',0,'0000-00-00 00:00:00'),(NULL,'ru','info2','Информация 2',0,'0000-00-00 00:00:00'),(NULL,'ru','info3','Информация 3',0,'0000-00-00 00:00:00'),(NULL,'ru','info4','Информация 4',0,'0000-00-00 00:00:00'),(NULL,'ru','info5','Информация 5',0,'0000-00-00 00:00:00'),(NULL,'ru','none','отсутствует',0,'0000-00-00 00:00:00'),(NULL,'ru','of','из',0,'0000-00-00 00:00:00'),(NULL,'ru','on %s since %s seconds ago','на %s по истечение %s секунд',0,'0000-00-00 00:00:00'),(NULL,'ru','on %s since %s secs ago','на %s по истечение %s секунд',0,'0000-00-00 00:00:00'),(NULL,'ru','on days','в дни',0,'0000-00-00 00:00:00'),(NULL,'ru','on hours','в часы',0,'0000-00-00 00:00:00'),(NULL,'ru','on minutes','в минуты',0,'0000-00-00 00:00:00'),(NULL,'ru','partial','неполный',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime-agent-busy','Занято',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime-agent-dialout','Исходящий вызов',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime-agent-hold','Вызов в режиме удержания',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime-agent-not in use','Не используется',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime-agent-ringing','Звонит',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime-agent-unavailable','Недоступен',0,'0000-00-00 00:00:00'),(NULL,'ru','realtime_queue_summary','Сводка очереди',0,'0000-00-00 00:00:00'),(NULL,'ru','seconds','секунды',0,'0000-00-00 00:00:00'),(NULL,'ru','unanswered_calls_by_event','Причина разъединения',0,'0000-00-00 00:00:00'),(NULL,'ru','unanswered_calls_by_holdtime','Уровень обслуживания',0,'0000-00-00 00:00:00'),(NULL,'ru','unanswered_calls_by_queue','Неотвеченные вызовы в очереди',0,'0000-00-00 00:00:00'),(NULL,'ru','unanswered_calls_by_url','Неотвеченные вызовы по URL-адресу',0,'0000-00-00 00:00:00'),(NULL,'ru','unanswered_calls_detail','Описание неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','unanswered_calls_summary','Сводка неотвеченных вызовов',0,'0000-00-00 00:00:00'),(NULL,'ru','within','в течение',0,'0000-00-00 00:00:00'),(NULL,'ru','within %d%s seconds','в течение %d%s секунд',0,'0000-00-00 00:00:00');

UNLOCK TABLES;

-- Table structure for table `qagent`
--

DROP TABLE IF EXISTS `qagent`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `qagent` (
  `agent_id` int(6) NOT NULL auto_increment,
  `agent` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`agent_id`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `qagent`
--

LOCK TABLES `qagent` WRITE;
/*!40000 ALTER TABLE `qagent` DISABLE KEYS */;
INSERT INTO `qagent` VALUES (-1,'ALL');
/*!40000 ALTER TABLE `qagent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qevent`
--

DROP TABLE IF EXISTS `qevent`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `qevent` (
  `event_id` int(11) NOT NULL auto_increment,
  `event` varchar(40) default NULL,
  PRIMARY KEY  (`event_id`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `qevent`
--

LOCK TABLES `qevent` WRITE;
/*!40000 ALTER TABLE `qevent` DISABLE KEYS */;
INSERT INTO `qevent` VALUES (1,'ABANDON'),(2,'ADDMEMBER'),(3,'AGENTCALLBACKLOGIN'),(4,'AGENTCALLBACKLOGOFF'),(5,'AGENTDUMP'),(6,'AGENTLOGIN'),(7,'AGENTLOGOFF'),(8,'AGENTPAUSED'),(9,'COMPLETEAGENT'),(10,'COMPLETECALLER'),(11,'CONFIGRELOAD'),(12,'CONNECT'),(13,'CONNECTED'),(14,'DID'),(15,'ENTERQUEUE'),(16,'EXITEMPTY'),(17,'EXITWITHKEY'),(18,'EXITWITHTIMEOUT'),(19,'NONE'),(20,'PAUSE'),(21,'PAUSEALL'),(22,'PAUSECUSTOM'),(23,'QUEUESTART'),(24,'REMOVEMEMBER'),(25,'RINGNOANSWER'),(26,'TRANSFER'),(27,'UNPAUSE'),(28,'UNPAUSEALL');
/*!40000 ALTER TABLE `qevent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qname`
--

DROP TABLE IF EXISTS `qname`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `qname` (
  `queue_id` int(11) NOT NULL auto_increment,
  `queue` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`queue_id`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `qname`
--

LOCK TABLES `qname` WRITE;
/*!40000 ALTER TABLE `qname` DISABLE KEYS */;
INSERT INTO `qname` VALUES (-1,'ALL');
/*!40000 ALTER TABLE `qname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_stats`
--

DROP TABLE IF EXISTS `queue_stats`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `queue_stats` (
  `queue_stats_id` int(12) NOT NULL auto_increment,
  `uniqueid` varchar(40) default NULL,
  `datetime` timestamp NOT NULL,
  `qname` int(6) default NULL,
  `qagent` int(6) default NULL,
  `qevent` int(2) default NULL,
  `info1` varchar(50) NOT NULL default '',
  `info2` varchar(50) NOT NULL default '',
  `info3` varchar(50) NOT NULL default '',
  `info4` varchar(50) NOT NULL default '',
  `info5` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`queue_stats_id`),
  UNIQUE KEY `unico` (`uniqueid`,`datetime`,`qname`,`qagent`,`qevent`),
  KEY `ixevent` (`qevent`),
  KEY `ixdate` (`datetime`),
  KEY `ixuni` (`uniqueid`),
  KEY `ixagent` (`qagent`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `queue_stats`
--

LOCK TABLES `queue_stats` WRITE;
/*!40000 ALTER TABLE `queue_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `queue_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recordings`
--

DROP TABLE IF EXISTS `recordings`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `recordings` (
  `uniqueid` varchar(40) NOT NULL default '',
  `filename` varchar(200) default NULL,
  PRIMARY KEY  (`uniqueid`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `recordings`
--

LOCK TABLES `recordings` WRITE;
/*!40000 ALTER TABLE `recordings` DISABLE KEYS */;
/*!40000 ALTER TABLE `recordings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sched`
--

DROP TABLE IF EXISTS `sched`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `sched` (
  `schid` int(6) NOT NULL auto_increment,
  `dest` text,
  `reports` text,
  `lastdays` smallint(4) default NULL,
  `field` varchar(40) default '',
  `exceed` varchar(40) default '',
  `crondaymonth` varchar(40) default '*',
  `crondayweek` varchar(40) default '*',
  `cronhour` varchar(20) default '*',
  `cronminute` varchar(20) default '*',
  `lastrun` datetime,
  `active` tinyint(4) default '1',
  `queues` TEXT default NULL,
  PRIMARY KEY  (`schid`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `sched`
--

LOCK TABLES `sched` WRITE;
/*!40000 ALTER TABLE `sched` DISABLE KEYS */;
/*!40000 ALTER TABLE `sched` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `secure_level`
--

DROP TABLE IF EXISTS `secure_level`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `secure_level` (
  `level` int(11) NOT NULL default '0',
  `detail` varchar(100) default NULL,
  PRIMARY KEY  (`level`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `secure_level`
--

LOCK TABLES `secure_level` WRITE;
/*!40000 ALTER TABLE `secure_level` DISABLE KEYS */;
INSERT INTO `secure_level` VALUES (1,'user'),(2,'admin'),(4,'agent'),(8,'supervisor');
/*!40000 ALTER TABLE `secure_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `setup`
--

DROP TABLE IF EXISTS `setup`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `setup` (
  `id` int(11) NOT NULL auto_increment,
  `keyword` varchar(50) default NULL,
  `parameter` varchar(50) default NULL,
  `value` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `keypar` (`keyword`,`parameter`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `setup`
--

LOCK TABLES `setup` WRITE;
/*!40000 ALTER TABLE `setup` DISABLE KEYS */;
INSERT INTO `setup` VALUES (1,'realtime_alarm_call_duration','','300'),(2,'realtime_alarm_row_color','','#ff0'),(3,'realtime_alarm_threshold','','50'),(4,'avg_time_format','','HH:MM:SS'),(5,'call_time_format','','HH:MM:SS'),(6,'csv_separator','',','),(7,'date_format','','%m-%d-%Y %H:%i:%S'),(8,'decimal_places','','2'),(9,'default_end_hour','','23:59'),(10,'default_start_hour','','00:00'),(11,'detailed_agent_report','','1'),(12,'distribution_interval','','60'),(13,'first_page','','distribution.php'),(14,'honor_timeframe_in_agent','','true'),(15,'language','','en'),(16,'realtime_refresh','','5'),(17,'recordings_path','','/var/spool/asterisk/monitor'),(18,'session_time_format','','HH:MM:SS'),(19,'show_agent_call','','1'),(20,'show_agent_field','','0'),(21,'show_url_field','','0'),(22,'sla_abandoned','','15'),(23,'sla_answered','','60'),(24,'sla_interval','','15'),(25,'sla_steps','','10'),(26,'sla_transferred','','60'),(27,'sla_unanswered','','15'),(28,'timeframe_interval','','1'),(29,'wait_time_format','','HH:MM:SS'),(30,'week_mode','','7');
/*!40000 ALTER TABLE `setup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sqlrealtime`
--

DROP TABLE IF EXISTS `sqlrealtime`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `sqlrealtime` (
  `lastupdate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `data` longtext,
  `user` varchar(100) NOT NULL,
  PRIMARY KEY  (`user`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `sqlrealtime`
--

LOCK TABLES `sqlrealtime` WRITE;
/*!40000 ALTER TABLE `sqlrealtime` DISABLE KEYS */;
/*!40000 ALTER TABLE `sqlrealtime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_filter`
--

DROP TABLE IF EXISTS `user_filter`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `user_filter` (
  `user` varchar(30) default NULL,
  `param` varchar(30) default NULL,
  `value` varchar(100) default NULL
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `user_filter`
--

LOCK TABLES `user_filter` WRITE;
/*!40000 ALTER TABLE `user_filter` DISABLE KEYS */;
INSERT INTO `user_filter` VALUES ('user','queue','ALL'),('user','agent','ALL'),('admin','queue','ALL'),('admin','agent','ALL'),('supervisor','queue','ALL'),('supervisor','agent','ALL'),('restUser','queue','ALL'),('restUser','agent','ALL');
/*!40000 ALTER TABLE `user_filter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userqagent`
--

DROP TABLE IF EXISTS `userqagent`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `userqagent` (
  `users_id` int(6) default NULL,
  `qagent_agent_id` int(6) default NULL
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `userqagent`
--

LOCK TABLES `userqagent` WRITE;
/*!40000 ALTER TABLE `userqagent` DISABLE KEYS */;
INSERT INTO `userqagent` VALUES (1,-1),(2,-1),(3,-1),(4,-1);
/*!40000 ALTER TABLE `userqagent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userqname`
--

DROP TABLE IF EXISTS `userqname`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `userqname` (
  `users_id` int(6) default NULL,
  `qname_queue_id` int(6) default NULL
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `userqname`
--

LOCK TABLES `userqname` WRITE;
/*!40000 ALTER TABLE `userqname` DISABLE KEYS */;
INSERT INTO `userqname` VALUES (1,-1),(2,-1),(3,-1),(4,-1);
/*!40000 ALTER TABLE `userqname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `users` (
  `id` int(11) NOT NULL auto_increment,
  `login` varchar(30) default NULL,
  `password` varchar(100) default NULL,
  `name` varchar(100) default NULL,
  `level` varchar(20) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `nombre` (`login`)
);
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (1,'admin','d033e22ae348aeb5660fc2140aec35850c4da997','Administrator','15'),(2,'user','12dea96fec20593566ab75692c9949596833adc9','User','1'),(3,'supervisor','0f4d09e43d208d5e9222322fbc7091ceea1a78c3','Supervisor','8'),(4,'restUser','3fe3445084aa644b001565bdf71e7fb1b956f0ff','REST User','15');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;

DROP TABLE IF EXISTS `gqname`;
CREATE TABLE `gqname` (
  `groupname_id` int(11) NOT NULL auto_increment,
  `groupname` varchar(200) default NULL,
  PRIMARY KEY  (`groupname_id`),
  UNIQUE KEY `name` (`groupname`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `gqnameqname`;
CREATE TABLE `gqnameqname` (
  `gqname_groupname_id` int(11) default NULL,
  `qname_queue_id` int(11) default NULL
);

DROP TABLE IF EXISTS `plugins`;
CREATE TABLE `plugins` (
  `id` int(11) NOT NULL auto_increment,
  `rawname` varchar(100) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` tinytext NOT NULL,
  `enabled` tinyint(1) default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `agent_activity`;

CREATE TABLE `agent_activity` (
  `id` int(11) NOT NULL auto_increment,
  `datetime` timestamp,
  `queue` varchar(80) default NULL,
  `agent` varchar(100) default NULL,
  `event` varchar(40) default NULL,
  `data` varchar(150) default NULL,
  `lastedforseconds` int(11) default NULL,
  `uniqueid` varchar(100) default NULL,
  `computed` tinyint(1) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `uni` (`datetime`,`queue`,`agent`,`event`,`uniqueid`)
) DEFAULT CHARSET=utf8;

INSERT INTO `designer` (keyword,parameter,value) VALUES ('COLUMN_AGENT','Answered','ANSWERED_CALLS'),('COLUMN_AGENT','Failed','FAILED_CALLS'),('COLUMN_AGENT','Cancelled','CANCELLED_CALLS'),('COLUMN_AGENT','Session Time','SESSION_TIME'),('COLUMN_AGENT','Pause Time','PAUSE_TIME'),('COLUMN_AGENT_FORMAT','Session Time','{HH}:{MM}:{SS}'),('COLUMN_AGENT_FORMAT','Pause Time','{HH}:{MM}:{SS}'),('COLUMN_AGENT','Sessions','SESSION_COUNT'),('COLUMN_AGENT','Pauses','PAUSE_COUNT'),('COLUMN_AGENT','Talk Time','TALK_TIME'),('COLUMN_AGENT','Wrapup Time','WRAPUP_TIME'),('COLUMN_AGENT','Hold Time','HOLD_TIME'),('COLUMN_AGENT_FORMAT','Talk Time','{HH}:{MM}:{SS}'),('COLUMN_AGENT_FORMAT','Wrapup Time','{HH}:{MM}:{SS}'),('COLUMN_AGENT_FORMAT','Hold Time','{HH}:{MM}:{SS}'),('COLUMN_AGENT','%% Session','round((SESSION_TIME * 100) / TOTAL_SESSION_TIME,2)'),('COLUMN_AGENT_FORMAT','%% Session','%.2f %%'),('COLUMN_AGENT','Idle Time','SESSION_TIME - ( TALK_TIME + PAUSE_TIME + WRAPUP_TIME + HOLD_TIME )'),('COLUMN_AGENT_FORMAT','Idle Time','{HH}:{MM}:{SS}'),('COLUMN_AGENT','AHT','(TALK_TIME+WRAPUP_TIME) / ANSWERED_CALLS'),('COLUMN_AGENT_FORMAT','AHT','{HH}:{MM}:{SS}'),('COLUMN_AGENT','%% Paused','PAUSE_TIME * 100 / SESSION_TIME'),('COLUMN_AGENT_FORMAT','%% Paused','%.2f %%'),('TOTAL_COLUMN_AGENT','Answered','TOTAL_ANSWERED_CALLS'),('TOTAL_COLUMN_AGENT','Failed','TOTAL_FAILED_CALLS'),('TOTAL_COLUMN_AGENT','Cancelled','TOTAL_CANCELLED_CALLS'),('TOTAL_COLUMN_AGENT','Session Time','TOTAL_SESSION_TIME'),('TOTAL_COLUMN_AGENT','Pause Time','TOTAL_PAUSE_TIME'),('TOTAL_COLUMN_AGENT','Sessions','TOTAL_SESSION_COUNT'),('TOTAL_COLUMN_AGENT','Pauses','PAUSE_COUNT'),('TOTAL_COLUMN_AGENT','Talk Time','TOTAL_TALK_TIME'),('TOTAL_COLUMN_AGENT','Wrapup Time','TOTAL_WRAPUP_TIME'),('TOTAL_COLUMN_AGENT','Hold Time','TOTAL_HOLD_TIME'),('TOTAL_COLUMN_AGENT','Idle Time','TOTAL_SESSION_TIME - ( TOTAL_TALK_TIME + TOTAL_PAUSE_TIME + TOTAL_WRAPUP_TIME + TOTAL_HOLD_TIME )'),('TOTAL_COLUMN_AGENT','AHT','SUM_COL'),('TOTAL_COLUMN_AGENT','%% Paused','TOTAL_PAUSE_TIME * 100 / TOTAL_SESSION_TIME'),('TOTAL_COLUMN_AGENT','%% Session','SUM_COL');


create or replace view queue_stats_full as select q.*,qevent.event as event, qagent.agent as agent, qname.queue as queue from queue_stats q force index (ixdate) left join qagent on qagent=agent_id left join qname on qname=queue_id left join qevent on qevent = event_id;